#include "bits/stdc++.h"

using namespace std;
#define int long long
vector <int> t;
int k;

void update(const int pos, const int val, int vl = 0, int vr = k - 1, int v = 0) {
	if(vl == vr) {
		t[v] = val;
		return;
	}
	int vm = (vl + vr) / 2;
	if(pos <= vm) update(pos, val, vl, vm, 2*v+1);
	else update(pos, val, vm+1, vr, 2*v+2);
	t[v] = min(t[2*v+1], t[2*v+2]);
}

int get(const int l, const int r, int vl = 0, int vr = k - 1, int v = 0) {
	if(l > vr || vl > r) return LLONG_MAX;
	if(l <= vl && vr <= r) return t[v];
	int vm = (vl + vr) / 2;
	return min(get(l, r, vl, vm, 2*v+1), get(l, r, vm+1, vr, 2*v+2));
}

signed main () {
	int n;
	cin >> n;
	k = 1;
	while(k < n) k <<= 1;
	t.resize(2*k-1, LLONG_MAX);
	int a[n], sum = 0, pref[n];
	for(int i = 0; i < n; i ++) cin >> a[i];
	pref[0] = a[0];
	for(int i = 1; i < n; i ++) pref[i] = pref[i - 1] + a[i];
	sum = (pref[n-1] + 1)  / 2;
	for(int i = 0; i < n; i ++) update(i, a[i]);
//	for(int i = 0; i < t.size(); i ++) cout << t[i] << " ";
//	cout << "\n";
	int ans = LLONG_MAX; 
	for(int i = 0; i < n; i ++) {
		int l = i, r = n - 1;
		while(l < r) {
			int m = (l + r) / 2;
			if(pref[m] - (!i ? 0 : pref[i-1]) >= sum) r = m;
			else l = m + 1;
		}
		if(pref[n-1] - (!i ? 0 : pref[i-1]) < sum)continue;
		ans = min(ans, r-i+1);
		if(pref[r] - (!i ? 0 : pref[i - 1]) - get(i, r) >= sum){
			ans = min(ans, r-i);
//			cout << pref[r] - (!i ? 0 : pref[i - 1]) - get(i, r) << " " << i << " " << r << "\n";
		}
	}
	cout << ans;
	return 0;
}