#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    cin >> a;
    ll s = 0;
    for (auto i: a) {
        s += i;
    }
    const int LG = 19;
    vector<vector<int>> st(LG, vector<int> (n));
    for (int i = 0; i < n; i++) {
        st[0][i] = a[i];
    }
    for (int l = 1; l < LG ; l++) {
        for (int i = 0; i + (1 << l) <= n; i++) {
            st[l][i] = min(st[l - 1][i], st[l - 1][i + (1 << (l - 1))]);
        }
    }
    vector<int> logs(1 << LG);
    for (int i = 0; i < LG; i++) {
        logs[1 << i] = i;
    }
    for (int i = 1; i < (1 << LG); i++) {
        logs[i] = max(logs[i], logs[i - 1]);
    }
    ll mn = (s + 1) / 2;
    deque<ll> q;
    ll cur = 0;
    int ans = n;
    int l = 0, r = 0;
    while (r < n) {
        cur += a[r];
        while (l < r && cur - a[l] >= mn) {
            cur -= a[l];
            l++;
        }
        q.push_back(a[r]);
        if (cur >= mn) {
            ans = min(ans, r - l + 1);
        }
        int lg = logs[r - l + 1];
        ll kok = min(st[lg][l], st[lg][r - (1 << lg) + 1]);
        if (cur - kok >= mn) {
            ans = min(ans, r - l);
        }
        ++r;
    }
    cout << ans << en;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
