#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

constexpr int base = 239, mod = 228228227;

void solve() {
    int n;
    cin >> n;
    vector<string> v(n);
    cin >> v;
    int l = 0, r = v[0].size() + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        map<int, int> cnt;
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = 0; j < mid; ++j) {
                cur = (cur * 1ll * base + v[i][j] - 'a' + 1) % mod;
            }
            ++cnt[cur];
        }
        bool ok = 1;
        for (auto i: cnt) {
            if (i.second % 2 != 0) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            l = mid;
        } else {
            r = mid;
        }
    }
    cout << l << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
