#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <random>
#include <map>
#include <set>
#include <chrono>

#define fast() ios::sync_with_stdio(0); cin.tie(0);
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll inf = ll(1e18) * 2 + 36ll;
const int mod = ll(1e9) + 7ll;
const ld pi = acos(-1), eps = 1e-7;

using vll = vector<ll>;

mt19937_64 rnd(time(0));

ll n;
vll a;
ll sum = 0;

struct Node {
	ll l, r, colour, time;
	Node() {
		l = -1;
		r = -1;
		colour = -1;
		time = -1;
	}
};

vector<Node> tree;
void init() {
	tree.push_back(Node());
}

void add(string s, ll colour, ll time) {
	ll v = 0;
	for (auto el : s) {
		if (el == 'L') {
			if (tree[v].l == -1) {
				tree.push_back(Node());
				tree[v].l = tree.size() - 1;
			}
			v = tree[v].l;
		}if (el == 'R') {
			if (tree[v].r == -1) {
				tree.push_back(Node());
				tree[v].r = tree.size() - 1;
			}
			v = tree[v].r;
		}
	} tree[v].time = time;
	tree[v].colour = colour;
}

pair<ll, ll> get_colout(string s) {
	ll v = 0;
	ll curr_c = -1, curr_t = -1;
	ll deep = 0;
	for (auto el : s) {
		if (tree[v].time > curr_t) {
			curr_c = tree[v].colour;
			curr_t = tree[v].time;
		}
		if (el == 'L') {
			if (tree[v].l == -1) {
				break;
			}
			else {
				v = tree[v].l;
				deep++;
			}
		}
		else {
			if (tree[v].r == -1) {
				break;
			}
			else {
				v = tree[v].r;
				deep++;
			}
		}
	} return{ curr_c, deep};
}

signed main() {
	fast();
	ll q; cin >> q;
	while (q--) {
		ll n; cin >> n;
		n = abs(n);
		if (!n) {
			cout << "0\n";
			continue;
		}
		bool fl = false;
		for (ll i = 0;i < 62;i++) {
			if (n == (1ll << i)) {
				cout << "1\n";
				fl = true;
				break;
			}
			for (ll j = 0;j < i;j++) {
				if (n == (1ll << i) - (1ll << j)) {
					cout << "2\n";
					fl = true;
					break;
				}
				if (n == (1ll << i) + (1ll << j)) {
					cout << "2\n";
					fl = true;
					break;
				}
			}
		}
		if (!fl) {
			cout << "3\n";
		}
	}
	return 0;
}