#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <random>
#include <map>
#include <set>

#define fast() ios::sync_with_stdio(0); cin.tie(0);
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
const ll inf = ll(1e18) * 2 + 36ll;
const int mod = ll(1e9) + 7ll;
const ld pi = acos(-1), eps = 1e-7;

using vll = vector<ll>;

mt19937_64 rnd(238);

ll n;
vll a;
ll sum = 0;


ll solve1() {
	deque<ll> q, qMin;
	ll curr_sm = 0;
	ll best_res = 1e12;
	for (int i = 0;i < n; i++) {
		curr_sm += a[i];
		q.push_back(i);
		while (qMin.size() && a[qMin.back()] >= a[i]) {
			qMin.pop_back();
		}
		qMin.push_back(i);
		if (curr_sm > sum) {
			while (q.size() && curr_sm - a[q.front()] >= sum) {
				curr_sm -= a[q.front()];
				if (qMin.size() && qMin.front() == q.front()) {
					qMin.pop_front();
				}
				q.pop_front();
			}
			best_res = min(best_res, ll(q.size()));
			if (curr_sm - a[qMin.front()] >= sum) {
				best_res = min(best_res, ll(q.size()) - 1);
			}
		}
	}
	return best_res;
}

signed main() {
	fast();
	cin >> n;
	a.resize(n, 0);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
	}
	sum = (sum + 1) / 2;
	cout << solve1();
	return 0;
}