#include "bits/stdc++.h"
using namespace std;

// #define ORD_SET
// #define ROPE
#ifdef ORD_SET
    #include <ext/pb_ds/assoc_container.hpp>
    #include <ext/pb_ds/tree_policy.hpp>
    using namespace __gnu_pbds;
    template<typename T>
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif
#ifdef ROPE
    #include <ext/rope>
    using namespace __gnu_cxx;
#endif        

// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

typedef long long ll;
typedef long double ld;
#define pb push_back
#define ff first
#define ss second
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
// #define ll int
void freopen(string s) { freopen((s + ".in").c_str(), "r", stdin); freopen((s + ".out").c_str(), "w", stdout); }
void NotInteractive() { ios_base::sync_with_stdio(false); cin.tie(NULL); }
void pre(ll a) { cout<<fixed<<setprecision(a); }
ll bit(ll x) { return __builtin_popcountll(x); }
ll binpow(ll x, ll y, ll z) { ll pow = 1; while(y) { if(y%2) pow *= x, pow %= z; x *= x, x %= z; y /= 2; } return pow; }
template<typename T> T gcd(T a, T b) { if(b==0) return a; return gcd(b, a%b); }
template<typename T> T lcm(T a, T b) { return a/gcd(a, b)*b; }
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count()); mt19937_64 sf(rng());

struct seg { ll tl, tr, id; };
ll B = 316;
const ll mod = (ll)1e9+7;   // dividing with mod
const ll inf = (ll)1e18+7;  // a/b = a*power(b, P-2)%P   (P - prime number)
const ll MX = LLONG_MAX;  // (a<<x) = (a*pow(2, x)),   (a>>x) = (a/(pow2, x))
const ll MN = LLONG_MIN; // Stars and Bars     n+k-1 
const ld P = acos(-1.0); // n          k  
const ll N = (ll)1e6+5;
vector<pair<ll, char>> g[N];
ll col[N], upd[N];

void precalc()
{
    for(ll i=0; i<N; i++) col[i] = -1;
    return;
}


void kigash()
{
    ll q, c, cnt = 1;
    cin>>q>>c;
    for(ll i=1; i<=q; i++)
    {
        ll t, x = -1; string s;
        cin>>t;
        if(t==1)
        {
            cin>>x>>s;
            ll v = 1;
            for(ll j=0; j<sz(s); j++)
            {
                if(sz(g[v])==0) g[v].pb({++cnt, s[j]}), v = cnt;
                else if(g[v][0].ss!=s[j]) g[v].pb({++cnt, s[j]}), v = cnt;
                else v = g[v][0].ff;
            }
            col[v] = x, upd[v] = i;
        }
        else
        {
            cin>>s;
            ll v = 1, u = 1, mx = -1;
            for(ll j=0; j<sz(s); j++)
            {
                u = v;
                if(sz(g[v])==0) g[v].pb({++cnt, s[j]}), v = cnt;
                else if(g[v][0].ss!=s[j]) g[v].pb({++cnt, s[j]}), v = cnt;
                else v = g[v][0].ff;
                if(col[v]!=-1)
                {
                    if(upd[v]>mx)
                    {
                        mx = upd[v];
                        x = col[v];
                    }
                    else
                    {
                        if(x!=-1)
                        {
                            if(s[j]=='L') x = (x+1)%c;
                            else x = (x-1+c)%c;
                        }
                        col[v] = x;
                    }
                }
                else
                {
                    if(x!=-1)
                    {
                        if(s[j]=='L') x = (x+1)%c;
                        else x = (x-1+c)%c;
                    }
                    col[v] = x;
                }
            }
            cout<<x<<"\n";
        }
    }
    return;
}

signed main(/**/)
{
    // freopen("");
    NotInteractive();
    precalc();
    
    ll tt = 1;
    // cin>>tt;
    for(ll i=1; i<=tt; i++) kigash();
    
    exit(0);
}