/*#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC target ("avx2")*/

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
  
#define fix fixed<<setprecision
#define forn(i, n) for(int i = 1; i <= (n); ++i)
#define all(v) v.begin(),v.end()
#define sz(s) (int) (s).size()
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define ss second
#define ff first

using namespace std;
using namespace __gnu_pbds;
using pii = pair<int,int>;
using pll = pair<long long, long long>;
using ll = long long;
using ull = unsigned long long;
 
 
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int N = 65;
int sz[N], p[N];

int get(int a){
	return p[a] = ((p[a] == a) ? a : get(p[a]));
}

void unite(int a, int b){
	a = get(a), b = get(b);
	if(a == b)
		return;
	if(sz[a] > sz[b])
		swap(a, b);
	p[a] = b;
	sz[b] += sz[a];
}

void solve(){
	ll x, rl, cnt = 0, ans = 0;
	cin >> x;
	x = abs(x), rl = x;
	string s = "";
	while(rl){
		s += to_string(rl&1);
		rl >>= 1;
	}
	reverse(all(s));
	for(int i = 0; i < sz(s); ++i)
		p[i] = i, sz[i] = 1;
	for(int i = 1; i < sz(s); ++i)
		if(s[i] == '1' && s[i-1] == '1') unite(i, i-1);
	for(int i = 1; i < sz(s)-1; ++i){
		if(s[i] == '0' && s[i-1] == '1' && s[i+1] == '1'){
			if(sz[get(i-1)] != 1 || sz[get(i+1)] != 1){
				unite(i-1, i+1);
				++ans;
			}
		}
	}
	set<int> st;
	for(int i = 0; i < sz(s); ++i)
		if(s[i] == '1')
			st.insert(get(i));
	for(auto o : st)
		ans += min(2, sz[o]);
	cout << ans << '\n';
}

int main(){
	//freopen("outofplace.in", "r", stdin);
	//freopen("outofplace.out", "w", stdout);
	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
	int t;
	cin >> t;
	while(t--) solve();
}
