﻿

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>

typedef long long ll;
using namespace std;
string bin(ll x) {
	string ans;
	if (x == 0) {
		return "0";
	}
	while (x != 0) {
		if ((x & 1) == 1) {
			ans += '1';
		}
		else {
			ans += '0';
		}
		x = x >> 1;
	}
	reverse(ans.begin(), ans.end());
	return ans;
}
int main(){
	int t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		n = abs(n);
		string st = bin(n);
		//cout << st << endl;
		if (n == 0) {
			cout << 0 << endl;
			continue;
		}
		int m = st.size();
		vector<vector<ll>> dp(m, { 0, 0, 0 });
		dp[0][0] = st[0] == '1' ? 1 : 0;
		dp[0][1] = 2;
		dp[0][2] = 1e14;
		for (int i = 1; i < m; i++) {
			dp[i][0] = min(dp[i - 1][0], min(dp[i - 1][1], dp[i - 1][2])) + (st[i] == '1' ? 1 : 0);
			dp[i][1] = min(dp[i - 1][0], min(dp[i - 1][1], dp[i - 1][2])) + 2;
			dp[i][2] = min(dp[i - 1][1], dp[i - 1][2]) + (st[i] == '0' ? 1 : 0);
		}
		cout << min(dp[m - 1][0], min(dp[m - 1][1], dp[m - 1][2])) << endl;
	}
}
