﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>

typedef long long ll;
using namespace std;

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);
	int n; cin >> n;
	vector<ll> a(n);
	ll sum = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
	}
	sum = (sum + 1) / 2;
	int l = 0, r = 0, ans = n;
	ll now = 0;
	multiset<int> mst;
	while (r < n) {
		mst.insert(a[r]);
		now += a[r];
		while (now - a[l] >= sum) {
			mst.erase(mst.find(a[l]));
			now -= a[l];
			l++;
		}
		if (now >= sum) {
			//cout << l << ' ' << r << ' ' << *mst.begin() << ' ' << now << endl;
			if (now - *mst.begin() >= sum) ans = min(ans, r - l);
			else ans = min(ans, r - l + 1);
		}
		r++;
	}
	cout << ans << endl;
}