﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>

typedef long long ll;
using namespace std;

int main()
{
	cin.tie(0)->sync_with_stdio(false);
	cout.tie(0)->sync_with_stdio(false);
	int n; cin >> n;
	vector<string> s(n);
	for (int i = 0; i < n; i++) cin >> s[i];
	int l = 0, r = n;
	while (r - l > 1) {
		int k = (r + l) / 2;
		map<string, int> used;
		for (int i = 0; i < n; i++) {
			string nw = "";
			for (int j = 0; j < k; j++) {
				nw.push_back(s[i][j]);
			}
			used[nw]++;
		}
		bool ok = 1;
		for (pair<string, int> p : used) {
			ok &= (p.second % 2 == 0);
		}
		if (ok) l = k;
		else r = k;
	}
	for (int t = r; t >= l; t--) {
		map<string, int> used;
		for (int i = 0; i < n; i++) {
			string nw = "";
			for (int j = 0; j < t; j++) {
				nw.push_back(s[i][j]);
			}
			used[nw]++;
		}
		bool ok = 1;
		for (pair<string, int> p : used) {
			ok &= (p.second % 2 == 0);
		}
		if (ok) {
			cout << t << endl;
			break;
		}
	}
}