#include "bits/stdc++.h"
using namespace std;

#define ar array
typedef long long ll;
#define int ll

signed main(){
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int n, m;
	cin >> n >> m;
	
	vector a(n + 2, vector<int>(m + 2));
	pair<int, int> Max{-1, -1};
	int cntMax = -1;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> a[i][j];
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			int cnt = 0;
			cnt += (a[i - 1][j - 1] == 8 || a[i - 1][j - 1] == 4 || a[i - 1][j - 1] == 0);
			cnt += (a[i + 1][j + 1] == 8 || a[i + 1][j + 1] == 4 || a[i + 1][j + 1] == 0);
			cnt += (a[i - 1][j + 1] == 2 || a[i - 1][j + 1] == 6 || a[i - 1][j + 1] == 0);
			cnt += (a[i + 1][j - 1] == 2 || a[i + 1][j - 1] == 6 || a[i + 1][j - 1] == 0);
			cnt += (a[i + 1][j] == 1 || a[i + 1][j] == 5 || a[i + 1][j] == 0);
			cnt += (a[i - 1][j] == 1 || a[i - 1][j] == 5 || a[i - 1][j] == 0);
			cnt += (a[i][j + 1] == 3 || a[i][j + 1] == 7 || a[i][j + 1] == 0);
			cnt += (a[i][j - 1] == 3 || a[i][j - 1] == 7 || a[i][j - 1] == 0);
			if (cnt > cntMax) {
				cntMax = cnt;
				Max = {i, j};
			}
		}
	}
	
	int x = Max.first;
	int y = Max.second;
	
	cout << x << " " << y << "\n";
	
	vector b(n + 1, vector<bool>(m + 1));
	b[x][y] = 1;
	
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (i == x && j == y)
				continue;
			if (i - x == j - y) {
				if (i > x) {
					b[i][j] = a[i][j] == 8;
				} else {
					b[i][j] = a[i][j] == 4;
				}
			} else if (x - i == j - y) {
				if (j > y) {
					b[i][j] = a[i][j] == 6;
				} else {
					b[i][j] = a[i][j] == 2;
				}
			} else {
				if (abs(x - i) < abs(y - j)) {
					if (j > y) {
						b[i][j] = a[i][j] == 7;
					} else {
						b[i][j] = a[i][j] == 3;
					}
				} else {
					if (i > x) {
						b[i][j] = a[i][j] == 1;
					} else {
						b[i][j] = a[i][j] == 5;
					}
				}
			}
		}
	}
	bool found = false;
	for (int i = 1; i <= n; i++) {
		bool ok = true;
		for (int j = 1; j <= m; j++) {
			if (b[i][j]) {
				ok = false;
			}
		}
		if (ok) {
			found = true;
			cout << i << " ";
			break;
		}
	}
	if (!found) {
		cout << x << " ";
	}
	found = false;
	for (int j = 1; j <= m; j++) {
		bool ok = true;
		for (int i = 1; i <= n; i++) {
			if (b[i][j]) {
				ok = false;
			}
		}
		if (ok) {
			found = true;
			cout << j << "\n";
			break;
		}
	}
	if (!found) {
		cout << y << "\n";
	}
	
	return 0;
}
