#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll _ = 1;
    cin >> _;
    while (_--) {
        ll n;
        cin >> n;
        n = abs(n);

        ll res = 0;
        for (ll i = 0; i + 1 < 64 && n != 0; ++i) {
            if (((n >> i) & 1ll)) {
                if (n >> (i + 1) & 1ll) {
                    n += (1ll << i);
                    ++res;
                }
                else {
                    n -= (1ll << i);
                    ++res;
                }
            }
        }

        cout << res << '\n';
    }
}