﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<string> a(n);
    int min_x = 1e9;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i].size() < min_x) {
            min_x = a[i].size();
        }
    }
    sort(a.begin(), a.end());
    int l = -1, r = min_x + 1, mid;
    while (l + 1 < r) {
        mid = (l + r) / 2;
        bool f = true;
        for (int i = 1; i < n; i += 2) {
            string s1 = a[i - 1].substr(0, mid);
            string s2 = a[i].substr(0, mid);
            if (s1 != s2) {
                f = false;
                break;
            }
        }
        if (f) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    cout << l;
}