#include <bits/stdc++.h>

using namespace std;

struct Node {
  long long v = -1, op = -1;
  Node *l = nullptr, *r = nullptr;
};

int main() {
  int q; cin >> q;
  long long c; cin >> c;
  auto make_children = [&](Node *p) {
    if(p->l == nullptr) p->l = new Node;
    if(p->r == nullptr) p->r = new Node;
  };
  auto handle_node = [&](Node *p) {
    make_children(p);
    if(p->op != -1) {
      p->v = p->op; p->op = -1;
      p->l->op = (p->v + 1) % c;
      p->r->op = (p->v - 1 + c) % c;
    }
  };
  auto set_value = [&](Node *p, long long x) {
    p->op = x;
    handle_node(p);
  };
  auto go_left = [&](Node *p) {
    handle_node(p);
    p = p->l;
    handle_node(p);
    return p;
  };
  auto go_right = [&](Node *p) {
    p = p->r;
    handle_node(p);
    return p;
  };
  Node *root = new Node; set_value(root, -1);
  for(int i = 0; i < q; i++) {
    int t; cin >> t;
    if(t == 1) {
      long long u; cin >> u;
      string s; cin >> s;
      Node *p = root;
      for(int j = 0; j < s.size(); j++) {
        if(s[j] == 'L') p = go_left(p);
        else p = go_right(p);
      }
      set_value(p, u);
    } else {
      string s; cin >> s;
      long long color;
      Node *p = root;
      for(int j = 0; j < s.size(); j++) {
        if(s[j] == 'L') p = go_left(p);
        else p = go_right(p);
      }
      cout << p->v << endl;
    }
  }

  return 0;
}

