#include <iostream>
#include <utility>
#include <cmath>
#include <chrono>
#include <algorithm>
#include <vector>

#define ff first
#define ss second
#define pb push_back
#define int long long
#define all(x) x.begin(), x.end()


using namespace std;
typedef long long ll;

const int INF = 1e18 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 1; i < n; ++i) {
        vector<int> dp2 = dp;
        for (int j = 0; j <= n; ++j) {
            if (j + i > n) break;
//            cout << dp[i + j] << endl;
            dp2[i+j] = min(dp2[i + j], dp[j] + i * (i - 1) / 2);
//            cout << i + j << " " << dp[i + j] << " " << dp[j] + i * (i - 1) / 2 << endl;
        }
        dp = dp2;
    }
    cout << dp[n];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}