#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }
/// Actual code starts here
const int N = 100005;

__int128 get(ll x) {
    __int128 sum = 0;
    if (x < 0) {
        return sum;
    }
    ++sum;
    __int128 pw10 = 1;
    for (int len = 0; len <= 18; ++len) {
        __int128 a = pw10;
        __int128 b = min(__int128(x), 10 * pw10 - 1);
        if (b < a) {
            break;
        }
        sum += (len + 1) * (b - a + 1);
        pw10 *= 10;
    }
    return sum;
}

void solve() {
    ///__int128 lol = get(1000000000000000000);
    ll s;
    cin >> s;
    for (ll L = 0; L < 305000; ++L) {
        ll l = L;
        ll r = (ll)1e18 + 7;
        while (l < r) {
            ll m = (l + r) >> 1;
            if (get(m) - get(L - 1) >= __int128(s)) {
                r = m;
            } else {
                l = m + 1;
            }
        }
        if (get(r) - get(L - 1) == __int128(s)) {
            cout << r - L + 1 << '\n' << L << ' ' << r;
            return;
        }
    }
    cout << -1;
    return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
