#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include<stack>
#include<string>
#include<iomanip>
#include<set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

void cinv(vector <ll>& a) {
	for (int i = 0; i < a.size(); ++i) {
		cin >> a[i];
	}
}

string to2(ll n) {
	string ans = "";
	while (n > 1) {
		ans += n % 2 + '0';
		n /= 2;
	}
	ans += '1';
	reverse(all(ans));
	return ans;
}

int cntin2(ll n) {
	string s = to2(n);
	int ans = 0;
	for (int i = 0; i < s.size(); ++i) {
		ans += (s[i] - '0');
	}
	return ans;
}

//===================================================================

void solve() {
	/*ll n;
	cin >> n;
	vector<ll>a(n);
	ll cnt = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		cnt += a[i];
	}
	ll g = (cnt + 1) / 2;
	ll sum = a[0];
	ll mn = 1e9;
	for (ll l = 0, r = 0; r < n && l < n; ) {
		if (sum < g) {
			if (r + 1 == n) {
				break;
			}
			++r;
			sum += a[r];
		}
		else{

			for (int i = l; i < r + 1; ++i) {
				if (a[i] <= sum - g) {
					mn = min(mn, r - l);
				}
			}
			
			mn = min(mn, r - l + 1);
			sum -= a[l];
			++l;
		}
	cout << mn;
	}*/
	ll n;
	cin >> n;
	n = abs(n);
	cout << min(cntin2(n), cntin2(pow(2, ceil(log2(n))) - n) + 1);
}

// ==============================================================================

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	cin >> t;
	while (t--) solve();
	return 0;
}