#include <bits/stdc++.h>

using namespace std;

#define int long long
#define first ff
#define second ss
#define pair<int,int> pairi
#define push_back pub
#define push_front puf
#define pop_back pob
#define pop_front pof

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto x : v) {
        out << x << ' ';
    }
    return out;
}

const long long INF = 1e18;

int c;

struct Node {
    Node* l; Node* r;
    int col, add;
    Node() {
        l = nullptr;
        r = nullptr;
        col = -1;
        add = -1;
    }
};

struct Seg_tree {
    Node* root = new Node();

    void push(Node* v) {
        if (v->add != -1) {
            v->col = v->add;
            if (v->l == nullptr)
                v->l = new Node();
            if (v->r == nullptr)
                v->r = new Node();
            v->l->add = (v->add + 1) % c;
            v->r->add = (v->add - 1 + c) % c;
            v->add = -1;
        }
    }

    void color(Node* v, int x, string &s, int i) {
        if (i == s.size()) {
            v->add = x;
            push(v);
            return;
        }

        if (s[i] == 'L') {
            if (v->l == nullptr)
                v->l = new Node();
            color(v->l, x, s, i + 1);
        } else {
            if (v->r == nullptr)
                v->r = new Node();
            color(v->r, x, s, i + 1);
        }
    }

    int get(Node* v, string &s, int i) {
        push(v);

        if (i == s.size()) {
            return v->col;
        }

        if (s[i] == 'L') {
            if (v->l == nullptr)
                v->l = new Node();
            return get(v->l, s, i + 1);
        } else {
            if (v->r == nullptr)
                v->r = new Node();
            return get(v->r, s, i + 1);
        }
    }
};
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    Seg_tree tr;

    int q;
    cin >> q >> c;
    while (q--) {
        int t, x;
        string s;
        cin >> t;
        if (t == 1) {
            cin >> x >> s;
            tr.color(tr.root, x, s, 0);
        } else {
            cin >> s;
            cout << tr.get(tr.root, s, 0) << '\n';
        }
    }
    return 0;
}
/*
6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2
R
*/
