#include <bits/stdc++.h>

using namespace std;

//#define int int_fast64_t
#define segl(i) ((i) * 2 + 1), l, (l + r) / 2
#define segr(i) ((i) * 2 + 2), (l + r) / 2, r

int c;
int timeline = 0;
map<pair<signed, unsigned>, pair<signed, signed>> colored;

int find_color(const string& path) {
    unsigned i = 0;
    signed curcolor = -1;
    signed curtime = -1;
    for(signed j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            i = i * 2 + 1;
            if(curcolor != -1) {
                curcolor++;
                curcolor %= c;
            }
            if(colored.find({j + 1, i}) != colored.end()) {
                pair<signed, signed> color = colored[{j + 1, i}];
                if(color.second > curtime) {
                    curtime = color.second;
                    curcolor = color.first;
                }
            }
        }
        else {
            i = i * 2 + 2;
            if(curcolor != -1) {
                curcolor--;
                curcolor += c;
                curcolor %= c;
            }
            if(colored.find({j + 1, i}) != colored.end()) {
                pair<signed, signed> color = colored[{j + 1, i}];
                if(color.second > curtime) {
                    curtime = color.second;
                    curcolor = color.first;
                }
            }
        }
    }
    return curcolor;
}

int set_color(const string& path, signed color) {
    unsigned i = 0;
    for(signed j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            i = i * 2 + 1;
        }
        else {
            i = i * 2 + 2;
        }
    }
    colored[{path.size(), i}] = {color, timeline++};
}

void solve() {
    int q;
    cin >> q >> c;
    for(int i = 0; i<q; ++i) {
        int t;
        cin >> t;
        if(t == 1) {
            int x;
            cin >> x;
            string path;
            cin >> path;
            set_color(path, x);
        }
        else {
            string path;
            cin >> path;
            cout << find_color(path) << endl;
        }
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
}
