#include <bits/stdc++.h>

using namespace std;

#define int int_fast64_t
#define segl(i) ((i) * 2 + 1), l, (l + r) / 2
#define segr(i) ((i) * 2 + 2), (l + r) / 2, r

vector<pair<int, int>> tree;
vector<int> a;

pair<int, int> f(const pair<int, int>& a, const pair<int, int>& b) {
    return {(a.first + b.first), min(a.second, b.second)};
}

void build(int i, int l, int r) {
    if(l + 1 == r) {
        tree[i] = {a[l], a[l]};
        return;
    }
    build(segl(i));
    build(segr(i));
    pair<int, int> a = tree[i * 2 + 1], b = tree[i * 2 + 2];
    tree[i] = f(a, b);
}

pair<int, int> mget(int i, int l, int r, int ql, int qr) {
    if(ql <= l && r <= qr) {
        return tree[i];
    }
    if(r <= ql || qr <= l) {
        return {0, 2e9};
    }
    pair<int, int> a = mget(segl(i), ql, qr), b = mget(segr(i), ql, qr);
    return f(a, b);
}

void solve() {
    int n;
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    int sum = 0;
    for(int i = 0; i<n; ++i) {
        int l;
        cin >> l;
        a[i] = l;
        sum += l;
    }
    sum++;
    sum /= 2;
    build(0, 0, n);
    int l = 0, r = n;
    while(r - l > 1) {
        int mg = (r + l) / 2;
        int maxsum = 0;
        for(int i = 0; i + mg <= n; ++i) {
            pair<int, int> getter = mget(0, 0, n, i, i + mg);
            maxsum = max(maxsum, getter.first);
        }
        for(int i = 0; i + mg + 1 <= n; ++i) {
            pair<int, int> getter = mget(0, 0, n, i, i + mg + 1);
            maxsum = max(maxsum, getter.first - getter.second);
        }
        if(maxsum >= sum)
            r = mg;
        else
            l = mg;
    }
    cout << r;
}

signed main()
{
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
}
