﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN

#include "trash.h"

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

__int128 pow10(ll a) {
    if (a == 0) return 1;
    if (a & 1) return pow10(a - 1) * 10;
    __int128 t = pow10(a >> 1);
    return t * t;
}

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

ll len_kok(ll x) {
    if (x == 0) return 1;
    int ans = 0;
    while (x) {
        ans++;
        x /= 10;
    }
    return ans;
}

vector<__int128> info, pref, pref_cnt;

void make() {
    info.resize(20);
    pref.resize(20);
    pref_cnt.resize(20);
    info[0] = 0, pref[0] = 0, pref_cnt[0] = 0;
    info[1] = 10, pref[1] = 1 * 10 + pref[0], pref_cnt[1] = info[1] + pref_cnt[0];
    info[2] = 90, pref[2] = 2 * 90 + pref[1], pref_cnt[2] = info[2] + pref_cnt[1];
    for (__int128 len = 3; len <= 19; len++) {
        info[len] = info[len - 1] * (__int128) 10;
        pref[len] = len * info[len] + pref[len - 1];
        pref_cnt[len] = info[len] + pref_cnt[len - 1];
    }
}

int gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0, y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_sol(ll a, ll b, ll c, ll &x0, ll &y0, ll &g) {
    g = gcd(a, b, x0, y0);
    if (c % g) {
        return false;
    }
    x0 *= c / g;
    y0 *= c / g;
    return true;
}


void solve() {
    make();

    ll X;
    cin >> X;
    ll best = -1, bestl = -1, bestr = -1;
    for (__int128 l1 = 1; l1 <= 19; l1++) {
        for (__int128 ln = l1 + 1; ln <= 19; ln++) {
            __int128 sum = pref[ln - 1] - pref[l1 + 1 - 1];
            if (sum > X)
                continue;
            __int128 ost = X - sum;
            ll x, y, g;
            if (!find_sol(l1, ln, ost, x, y, g))
                continue;
            __int128 mx = min(ost / l1, info[l1]);
            __int128 c = (mx - x) / (ln / g);
            x = x + c * (ln / g);
            y = y - c * (l1 / g);
            if (x >= 0 && x <= info[l1] && y >= 0 && y <= info[ln]) {
                __int128 count = pref_cnt[ln - 1] - pref_cnt[l1 + 1 - 1] + x + y;
                if (count > best) {
                    best = count;
                    bestr = info[ln - 1] + y - 1, bestl = bestr - count + 1;
                }
            }
        }
    }
    cout << best << '\n' << bestl << ' ' << bestr;
}

int32_t main() {
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
