﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN

#include "trash.h"

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

ll cnt = 0;

void make(vector<ll> &a) {
    if (cnt == 0) {
        reverse(a.begin(), a.end());
        for (auto &i: a) {
            cout << i << ' ';
        }
        return;
    }
    if ((int) a.size() - 1 <= cnt) {
        cnt -= (int) a.size() - 1;
        for (auto &i: a) {
            cout << i << ' ';
        }
        return;
    }
    ll mx = a.back();
    a.pop_back();
    vector<ll> first, second;
    for(int i = 0; i < cnt; i++) {
        first.push_back(a[i]);
    }
    first.push_back(mx);
    for(int i = cnt; i < a.size(); i++) {
        second.push_back(a[i]);
    }
    reverse(all(second));
    for(auto i : first) cout << i << ' ';
    for(auto i : second) cout << i << ' ';
    cnt = 0;
}

void solve() {
    ll n;
    cin >> n;
    n++;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) {
        a[i] = i;
    }
    string s;
    cin >> s;
    for (auto i: s) {
        if (i == 'A')
            cnt++;
    }
    cnt /= 2;
    vector<ll> now;
    now.push_back(1);
    for (int i = 1; i <= (int) s.size(); i++) {
        char c = s[i - 1];
        if (c == 'A') {
            now.push_back(i + 1);
        } else {
            make(now);
            now.clear();
            now.push_back(i + 1);
        }
    }
    if (now.size())
        make(now);
}

int32_t main() {
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
