from math import log2


def get_steps(num):
    num = abs(num)
    steps = 0
    if num == 0:
        return 0
    else:
        while num:
            d = int(log2(num))
            new_step = 2 ** d
            second_new_step = 2 ** (d + 1)
            if num - new_step < second_new_step - num:
                num -= new_step
                steps += 1
            else:
                num = second_new_step - num
                steps += 1
        return steps


if __name__ == "__main__":
    n = int(input())
    for i in range(n):
        print(get_steps(int(input())))