#include <bits/stdc++.h>

using namespace std;

long long closest_2_step (long long x) {
    x --;
    x |= x >> 1;
    x |= x >> 2;
    x |= x >> 4;
    x |= x >> 8;
    x |= x >> 16;
    x |= x >> 32;
    return x + 1;
}

//long long optimal_jump(long long x) {
//    x = abs(x);
//    if (!(x & (x - 1))) return 1;
//    long long stepRight = closest_2_step(x);
//    long long x_new = min(abs(x - stepRight), abs(x - stepRight / 2));
//    return 1 + optimal_jump(x_new);
//}

int main(){
    int t;
    cin >> t;
    for (int n = 0; n < t; n++) {
        long long a;
        cin >> a;
        a = abs(a);
        if (a == 0) {
            cout << "0\n";
            continue;
        }
        if (!(a & (a - 1))) {
            cout << "1\n";
            continue;
        }
        int count = 0;
        while (a != 0) {
            long long stepRight = closest_2_step(a);
            a = min(a - stepRight / 2, abs(a - stepRight));
            count++;
        }
        cout << count << "\n";
//        cout << optimal_jump(a) << "\n";
    }
}
