
#ifndef SUPER_MEGA_CODE_FROM_T1TUKLL
#define SUPER_MEGA_CODE_FROM_T1TUKLL

#ifndef DEBUG
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,bmi")
#endif

#include <bits/stdc++.h>

namespace time_clck {
	long double start_time = std::clock();
}
typedef long long ll;
typedef unsigned long long ull;

void solv() {
	ll q, c;
	std::cin >> q >> c;
	
	std::map<std::string, std::pair<ll, ll>> tree;
	
	while (q--) {
		int inpt;
		std::cin >> inpt;
		
		if (inpt == 1) {
			ll color;
			std::cin >> color;
			std::string way;
			std::cin >> way;
			
			tree[way] = { color, 1 };
		}
		else {
			std::string way;
			std::cin >> way;
			
			ll curr_clr = -1;
			bool have_color = false;
			for (int i = 0; i < way.size(); ++i) {
				std::string curr_way(way.begin(), way.begin() + i + 1);
				if (tree[curr_way].second == 1) {
					curr_clr = tree[curr_way].first;
					have_color = true;
				}
				else {
					if (way[i] == 'L') {
						curr_clr = (curr_clr + 1) % c;
					}
					else {
						curr_clr = ((curr_clr - 1) % c + c) % c;
					}
				}
			}
			if (have_color) {
				std::cout << curr_clr << '\n';
			}
			else {
				std::cout << -1 << '\n';
			}
		}
	}
}

int main() {
#ifndef DEBUG
	std::ios::basic_ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
#endif
	int n = 1;
	//std::cin >> n;
	while (n--) {
		solv();
	}

#pragma region TIME
#ifdef DEBUG
	std::cout << '\n' << '\n';
	long double TIME = (clock() - time_clck::start_time) / CLOCKS_PER_SEC;
	std::cout << TIME << "s";
#endif
#pragma endregion
}
#endif
