#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define ppb pop_back
ll t, n, m;
string s, s1;
struct segtree{
    vector<ll> tree;
    ll size;
    void init(ll n){
        size = 1;
        while(size<n) size*=2;
        tree.assign(2 * size - 1, 0);
    }
    void set(ll i, ll v, ll x, ll lx, ll rx){
        if(rx-lx==1){
            tree[x] = v;
            return;
        }
        ll m = (rx+lx)/2;
        if(i<m){
            set(i, v, 2*x+1, lx, m);
        } else{
            set(i, v, 2*x+2, m, rx);
        }
        tree[x] = min(tree[2*x+1], tree[2*x+2]);
    }
    void set(ll i, ll v){
        set(i, v, 0, 0, size);
    }
    ll mi(ll l, ll r, ll x, ll lx, ll rx){
        if(l>=rx || lx>=r) return 1e9;
        if(lx>=l && rx<=r) return tree[x];
        ll m = (lx+rx)/2;
        ll m1 = mi(l, r, 2*x+1, lx, m);
        ll m2 = mi(l, r, 2*x+2, m, rx);
        return min(m1, m2);
    }
    ll mi(ll l, ll r){
        return mi(l, r, 0, 0, size);
    }
};
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    segtree st;
    st.init(n);
    vector<ll> a(n), p(n+1);
    for(ll i=0; i<n; i++) {
        cin>>a[i];
        st.set(i, a[i]);
        p[i+1]=p[i]+a[i];
    }
    ll l=0, r=n, q=(p.back()+1)/2;
    while(l<r-1){
        ll m = (l+r)/2, ok=0;
        for(ll i=0; i<n-m; i++){
            if(p[i+m+1]-p[i]-st.mi(i, i+m)>=q) {ok=1; break;}
        }
        if(ok) r = m;
        else l = m;
    }
    cout<<r;
    }
