#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template <typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1505;

const int dx[] = {1, -1, 1, -1};
const int dy[] = {-1, 1, 1, -1};
const pii w[] = {{6, 2}, {2, 6}, {4, 8}, {8, 4}};

int sign(int x) {
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

int n, m;
int a[N][N], b[N][N];

bool valid(int x, int y) {
    return x >= 1 && y >= 1 && x <= n && y <= m;
}
ve<pii> v;

void go(int x, int y) {
    int X = x;
    int Y = y;
//    cout << "GO: " << x << " " << y << "\n";
    fr (i, 1, n) {
        fr (j, 1, m) {
            if (i == x && j == y) {
                continue;
            }

            if (abs(i - x) == abs(j - y)) {
                fr (d, 0, 3) {
                    if (sign(x - i) == dx[d] && sign(y - j) == dy[d]) {
                        b[i][j] = w[d].fi;
                        break;
                    }
                }
            } else {
                int dx = x - i;
                int dy = y - j;

                if (abs(dx) < abs(dy)) {
                    if (dy > 0) {
                        b[i][j] = 3;
                    } else {
                        b[i][j] = 7;
                    }
                } else {
                    if (dx > 0) {
                        b[i][j] = 5;
                    } else {
                        b[i][j] = 1;
                    }
                }
            }
        }
    }


    ve<int> row, col;
    int cnt = 0;



    cnt = 0;

    fr (idx, 1, 2) {
        ve<int> pos;
        cnt = 0;
        fr (i, 1, n) {
            if (a[i][idx] != b[i][idx] && b[i][idx] != 0) {
                cnt++;
                pos.pb(i);
            }
        }

    //    cout << "cnt: " << cnt << "\n";
        if (cnt == 1) {
            assert(cnt == 1);
            row.pb(pos[0]);
        }

        pos.clear();
        cnt = 0;
        fr (j, 1, m) {
            if (a[idx][j] != b[idx][j] && b[idx][j] != 0) {
                cnt++;
                pos.pb(j);
            }
        }

        if (cnt == 1) {
            assert(cnt == 1);
            col.pb(pos[0]);
        }
    }

    if (n * m <= 50) {
        fr (i, 1, n) {
            row.pb(i);
        }
        fr (i, 1, m) {
            col.pb(i);
        }
    }

//    cout << "row: ";
//    fe (x, row) {
//        cout << x << " ";
//    }
//    cout << "\n";
//    cout << "col: ";
//    fe (x, col) {
//        cout << x << " ";
//    }
//    cout << "\n";
//
//    fr (i, 1, n) {
//        fr (j, 1, m) {
//            cout << b[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";

    fe (x, row) {
        fe (y, col) {

            bool good = 1;
            fr (i, 1, n) {
                fr (j, 1, m) {
                    if (b[i][j] == 0) continue;

                    bool flip = 0;
                    if (i == x) flip |= 1;
                    if (j == y) flip |= 1;

                    int val = b[i][j];

                    if (flip) {
//                        cout << "YEP\n";
                        if (val == 8) val = 4;
                        else if (val == 4) val = 8;
                        else if (val == 1) val = 5;
                        else if (val == 5) val = 1;
                        else if (val == 2) val = 6;
                        else if (val == 6) val = 2;
                        else if (val == 7) val = 3;
                        else if (val == 3) val = 7;
                    }
//                    cout << val << " ";
                    good &= val == a[i][j];
                }
//                cout << "\n";
            }

            if (good) {
                cout << X << " " << Y << "\n";
                cout << x << " " << y << "\n";
                exit(0);
            }
        }
    }
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;

    fr (i, 1, n) {
        fr (j, 1, m) {
            cin >> a[i][j];
        }
    }

    fr (i, 1, n) {
        fr (j, 1, m) {
            if (a[i][j] % 2 == 0) {
                v.pb({i, j});
            }
        }
    }

    ve<pii> toGo;
//    if (sz(v) <= min(n, m)) {
//        fe (cur, v) {
//            if (cur.fi == 1 || cur.fi == n || cur.se == 1 || cur.se == m) {
//                toGo.pb(cur);
//            }
//        }
//    } else {
    int best = -1;
    int bestX = -1;
    int bestY = -1;
    fr (i, 1, n) {
        fr (j, 1, m) {
            pii cur = {i, j};

            int cnt = 0;
            fr (d, 0, 3) {
                if (valid(cur.fi + dx[d], cur.se + dy[d])) {
                    if (a[cur.fi + dx[d]][cur.se + dy[d]] % 2 == 0) {
                        cnt++;
                    }
                }
            }
            if (cnt == 1) {
                toGo.pb({i, j});
            }
            if (umx(best, cnt)) {
                bestX = cur.fi;
                bestY = cur.se;
            }
        }
    }

    toGo.pb({bestX, bestY});

    fe (cur, toGo) {
        go(cur.fi, cur.se);
    }

    return 0;
}
