#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define ft first
#define sd second

#define pb push_back
#define pob pop_back

#define sz(x) int((x).size())

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 25;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

ll sum, a[N];
ll n, l, ans = 1e9;
set<pair<ll, ll>> st;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;

    ll need = 0;

    for(int i = 1; i <= n; i++){
        cin >> a[i];
        need += a[i];
    }

    need = (need + 1) / 2;

    l = 1;

    for(int r = 1; r <= n; r++){
        sum += a[r];
        st.insert({a[r], r});
        while(l < r and sum - a[l] >= need){
            sum -= a[l];
            st.erase({a[l], l});
            l++;
        }
        if(sum >= need){
            auto it = st.begin();

            if(sum - (*it).fi >= need){
                ans = min(ans, (r - l));
            } else {
                ans = min(ans, (r - l + 1));
            }
        }
    }

    cout << ans << "\n";

    return 0;
}
