


#include <bits/stdc++.h>

using namespace std;

#define int long long

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int get(char c) {
return c == 'L';}
int tmm = 0;

struct trie {
    struct node {
        int to[2];
        int terminal, value;
        node(): terminal(-1), value(-1) {
            to[0] = to[1] = -1;
        }
    };

    vector<node> tr;
trie() {tr.emplace_back();}
    pair<string, int> process(string val) {
        int c = 0;
        string cur = "";
        string best = "";
        int res = -1, value = -1;
        for (int i = 0; i < val.size(); ++i) {
            if(tr[c].to[get(val[i])] == -1) {
                return {best, value};
            } else {
                c = tr[c].to[get(val[i])];
                cur.push_back(val[i]);
                if (tr[c].terminal != -1) {
                    if (res < tr[c].terminal) {res = tr[c].terminal; value = tr[c].value; while(best.size() < cur.size()) best.push_back(cur[best.size()]);}
                }
            }
        }
        return {best, value};
    }

    void update(string path, int val) {
        ++tmm;
        int c = 0;
        for (int i = 0; i < (int)path.size(); ++i) {
            if (tr[c].to[get(path[i])] == -1) {
                tr[c].to[get(path[i])] = tr.size();
                tr.emplace_back();
            }
            c = tr[c].to[get(path[i])];
        }
        tr[c].terminal = tmm;
        tr[c].value = val;
    }

};

trie tr;

void solve() {
    int q, c;
    cin >> q >> c;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            string s;
            cin >> s;
            pair<string, int> w = tr.process(s);
            string st = w.first;
            int e = w.second;

            if (e == -1) {
                cout << "-1\n";
                continue;
            }

            for (int i = st.size(); i < s.size(); i++) {
                if (s[i] == 'L') {
                    e = (e + 1) % c;
                } else {
                    e = (e - 1 + c) % c;
                }
            }

            cout << e << '\n';
        } else {
            int cc;
            cin >> cc;
            string s;
            cin >> s;
            tr.update(s, cc);
        }
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

/*

#include <bits/stdc++.h>

using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};


void solve() {

}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2R
R

*/

