#include <bits/stdc++.h>

using namespace std;

#define int long long

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

#define ld long double

struct seg {
    long double x1, x2, y1, y2;
};

long double cross(pair<ld, ld> a, pair<ld, ld> b) {
    return a.first * b.second - b.first * a.second;
}

ld eps = 1e-11;

bool eqs (ld a, ld b) {
    //if (abs(a) < eps && abs(b) < eps) return true;
    if (abs(b) < eps) return true;
    if (a < 0) return b < 0;
    return b > 0;
}

bool rayIntersection(seg a, seg b) {
    b.x1 -= a.x1;
    b.y1 -= a.y1;
    b.x2 -= a.x1;
    b.y2 -= a.y1;

    a.x2 -= a.x1;
    a.y2 -= a.y1;
    a.x1 = 0;
    a.y1 = 0;

    cout << "a: " << a.x2 << ' ' << a.y2 << " b: " << b.x1 << ' ' << b.x2 << ' ' << b.y1 << ' ' << b.y2 << '\n';

    ld cross1 = cross({a.x2, a.y2}, {b.x1, b.y1});
    ld cross2 = cross({a.x2, a.y2}, {b.x2 - b.x1, b.y2 - b.y1});

    if (abs(cross1) < eps) return true;

    cout << "c1: " << cross1 << " c2: " << cross2 << '\n';

    return !eqs(cross1, cross2) || (abs(cross1) < eps && abs(cross2) < eps);
}

bool raySegIntersection(seg a, seg b) {
    return rayIntersection(a, b) && rayIntersection(a, {b.x2, b.x1, b.y2, b.y1});
}

bool intersect(seg a, seg b) {
    return raySegIntersection(a, b) && raySegIntersection({a.x2, a.x1, a.y2, a.y1}, b);
}

ld len(seg a) {
    return hypotl(a.x1 - a.x2, a.y1 - a.y2);
}

ld dist(seg a, pair<ld, ld> b) {

}

ld dist(seg a, seg b) {

}

void solve() {
    /*int n, res = 0;
    cin >> n;
    vector<seg> segs(n);
    for (auto& e : segs)
        cin >> e.x1 >> e.y1 >> e.x2 >> e.y2;
    for (int i = 0; i < n - 2; ++i) {
        for (int j = i + 1; j < n - 1; ++j) {
            for (int k = j + 1; k < n; ++k) {
                if ((intersect(segs[i], segs[j]) && len(segs[k]) + eps > dist(segs[i], segs[j])) ||
                    (intersect(segs[i], segs[k]) && len(segs[j]) + eps > dist(segs[i], segs[k])) ||
                    (intersect(segs[k], segs[j]) && len(segs[i]) + eps > dist(segs[k], segs[j])))
                    res++;

                    cout << "PUDGE";

            }
        }
    }
    cout << res;*/

    long long x;
    cin >> x;
    x = abs(x);
    long long tot1 = __builtin_popcountll(x);

    long long ll = 0;

    for (long long i = 0; i < 64; i++)
        if (x & (1ll << i))
            ll = i;

    long long cnt0 = 0;
    long long cnt1 = 0;

    long long ans = tot1;

    for (long long i = 0; i <= ll; i++) {
        if ((x & (1ll << i)) == 0) {
            ans = min(ans, tot1 - cnt1 + (2 + cnt0));
            cnt0++;
        } else {
            cnt1++;
        }
    }

    cout << min(ans, __builtin_popcountll((1ll << (ll+1ll)) - x) + 1ll);
}

/*
4
1 1 2 3
1 3 2 1
3 1 4 3
2 6 3 6
*/

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;

    //ld ax1, ax2, ay1, ay2, bx1, bx2, by1, by2;

    //cin >> ax1 >> ax2 >> ay1 >> ay2 >> bx1 >> bx2 >> by1 >> by2;

    //cout << intersect({ax1, ax2, ay1, ay2}, {bx1, bx2, by1, by2});

    cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

/*

#include <bits/stdc++.h>

using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};


void solve() {

}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2R
R

*/
