#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define int long long
#define ld long double
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sqr(x) ((x)*(x))
#define pw(x) (1LL << x)
#define sz(x) (int)x.size()

using namespace std;

const ld e = 1e-9, E = 1e-6;

int XA[105], YA[105], XB[105], YB[105];
ld mi[105][105];

ld dist(ld xa, ld ya, ld xb, ld yb)
{
    return sqrtl(sqr(xa - xb) + sqr(ya - yb));
}

ld get_y_by_x(ld xa, ld ya, ld xb, ld yb, ld x)
{
    return ya + (x - xa) * (yb - ya) / (xb - xa);
}

ld f(int i, ld x, ld y)
{
    ld xa = XA[i], ya = YA[i], xb = XB[i], yb = YB[i];
    bool sw = false;
    if(xa == xb)
    {
        sw = true;
        swap(xa, ya);
        swap(xb, yb);
    }
    ld l = min(xa, xb);
    ld r = max(xa, xb);
    while(r - l > e)
    {
        ld m1 = (l * 2 + r) / 3;
        ld m2 = (l + r * 2) / 3;
        ld _m1 = get_y_by_x(xa,ya,xb,yb, m1);
        ld _m2 = get_y_by_x(xa,ya,xb,yb, m2);
        ld f1 = (sw ? dist(x, y, _m1, m1) : dist(x, y, m1, _m1));
        ld f2 = (sw ? dist(x, y, _m2, m2) : dist(x, y, m2, _m2));
        if(f1 <= f2)
            r = m2;
        else
            l = m1;
    }
    ld _l = get_y_by_x(xa,ya,xb,yb, l);
    return (sw ? dist(x, y, _l, l) : dist(x, y, l, _l));
}

ld get_min(int i, int j)
{
    ld xa = XA[i], ya = YA[i], xb = XB[i], yb = YB[i];
    bool sw = false;
    if(xa == xb)
    {
        sw = true;
        swap(xa, ya);
        swap(xb, yb);
    }
    ld l = min(xa, xb);
    ld r = max(xa, xb);
    while(r - l > e)
    {
        ld m1 = (l * 2 + r) / 3;
        ld m2 = (l + r * 2) / 3;
        ld _m1 = get_y_by_x(xa,ya,xb,yb, m1);
        ld _m2 = get_y_by_x(xa,ya,xb,yb, m2);
        ld f1 = (sw ? f(j, _m1, m1) : f(j, m1, _m1));
        ld f2 = (sw ? f(j, _m2, m2) : f(j, m2, _m2));
        if(f1 <= f2)
            r = m2;
        else
            l = m1;
    }
    ld _l = get_y_by_x(xa,ya,xb,yb, l);
    return (sw ? f(j, _l, l) : f(j, l, _l));
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> XA[i] >> YA[i] >> XB[i] >> YB[i];
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            mi[i][j] = get_min(i, j);
    int ans = 0;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            for(int k = j + 1; k < n; k++)
                ans += (mi[i][j] <= dist(XA[k], YA[k], XB[k], YB[k]) + E || mi[i][k] <= dist(XA[j], YA[j], XB[j], YB[j]) + E || mi[j][k] <= dist(XA[i], YA[i], XB[i], YB[i]) + E);
    cout << ans;
    return 0;
}

//3
//0 0 0 1
//0 3 0 4
//5 0 5 2

