def merge(left, right):
    if len(left) == 0:
        return right
    if len(right) == 0:
        return left
    result = []
    index_left = index_right = 0
    while len(result) < len(left) + len(right):
        if left[index_left] <= right[index_right]:
            result.append(left[index_left])
            index_left += 1
        else:
            result.append(right[index_right])
            index_right += 1
        if index_right == len(right):
            result += left[index_left:]
            break
        if index_left == len(left):
            result += right[index_right:]
            break
    return result


def merge_sort(array):
    if len(array) < 2:
        return array
    midpoint = len(array) // 2
    return merge(
        left=merge_sort(array[:midpoint]),
        right=merge_sort(array[midpoint:]))


n = int(input())
sps = []
for i in range(n):
    sps.append(input())
sps = merge_sort(sps)
if n % 2 == 1:
    print("0")
else:
    k = n
    for i in range(0, n // 2):
        kk = 0
        while i < n:
            if sps[i * 2][kk] == sps[i * 2 + 1][kk]:
                kk += 1
            else:
                break
        k = min(kk, n)
        if k == 0:
            break
    print(k)

