#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> sum(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i++) {
        sum[i] = sum[i - 1] + a[i - 1];
    }
    int ans = n;
    for (int i = 0; i < n; i++) {
        int l = 0, r = n - i;
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (sum[i + m] - sum[i] < sum[n] / 2 + sum[n] % 2) {
                l = m;
            }
            else {
                r = m;
            }
        }
        bool can = false;
        int need_x = sum[i + r] - sum[i] - (sum[n] / 2 + sum[n] % 2);
        for (int j = i; j < i + r; j++) {
            if (a[j] <= need_x) {
                can = true;
                break;
            }
        }
        if (sum[i + r] - sum[i] >= sum[n] / 2 + sum[n] % 2) {
            ans = min(ans, r - can);
        }
    }
    cout << ans << '\n';
    return 0;
}
