#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

vector<string> res;

bool check(int x) {
    string pref = res[0].substr(0, x);
    for (int i = 1; i < res.size(); i++) {
        if (res[i].substr(0, x) != pref) {
            return 0;
        }
    }
    return 1;
}

int main() {
    int n;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    if (n == 2) {
        res.resize(n);
        for (int i = 0; i < n; i++) {
            res[i] = a[i];
        }
    }
    else {
        res.resize(n / 2);
        for (int i = 0; i < n / 2; i++) {
            res[i] = a[i] + a[i + n / 2];
        }
    }
//    for (int i = 0; i < res.size(); i++) cout << res[i] << '\n';
//    cout << res[0].substr(0, 3);
    int l = 0, r = a[0].size() * 2 + 1;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        if (check(m)) {
            l = m;
        }
        else {
            r = m;
        }
    }
    cout << l << '\n';
    return 0;
}
