#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
const double EPS = 1e-12;
const int P = 41;
const int mod = 99826161353;

int a[100];

void init ()
{
    int ret = 1;
    for (int i = 0; i <= 62; i++) {
        a[i] = ret;
        ret <<= 1;
    }
}

inline int binpow (int k)
{
    if (k == 0)
        return 1;
    if (k % 2 == 0) {
        int num = binpow(k / 2);
        return num * num;
    } else {
        return binpow(k - 1) * 2;
    }
}

inline void solve ()
{
    int n, ans = 0;
    map <int, int> used;
    cin >> n;
    if (!n) {
        cout << 0 << endl;
        return;
    }

    queue <pair <int, int> > q;
    q.push({abs(n), 0});
    while (1)
    {
        int x = q.front().first, step = q.front().second;
        q.pop();
        used[x] = 1;
        int t = log2(x);
        int num1 = a[t], num2 = a[t + 1];
        if (num1 == x || num2 == x) {
            ans = step;
            break;
        }
        if (!used[x - num1])
            q.push({abs(x - num1), step + 1});
        if (!used[x - num2])
            q.push({abs(x - num2), step + 1});
    }

    cout << ans + 1 << endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    init();
    int _;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
