#pragma GCC optimize("Ofast,O2,O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

int A1 = 23, B1 = 998244853;
int A2 = 101, B2 = 1e9 + 7;

#define endl '\n'

vector<pair<int, int>> __hash(const string &s){
    int n = (int)s.size();
    vector<pair<int, int>> res;

    ll h1 = 0, h2 = 0;
    for (int i = 0; i < n; i++){
        h1 = (h1 * A1 + s[i]) % B1;
        h2 = (h2 * A2 + s[i]) % B2;
        res.emplace_back(h1, h2);
    }

    return res;
}

const int N = 1e6 + 3e2;
int L[N], R[N];

void solve(){
    int q, c;
    cin >> q >> c;

    map<pair<int, int>, pair<int, int>> mp;

    for (int tt = 1; tt <= q; tt++){
        int t;
        cin >> t;
        if (t == 1){
            int x; string s;
            cin >> x >> s;

            pair<int, int> h = __hash(s).back();

            for (char c : s){
                L[tt] += (c == 'L');
                R[tt] += (c == 'R');
            }

            mp[h] = make_pair(tt, x);

           // cout << "\t" << h << endl;

        } else {
            string s;
            cin >> s;

            vector<pair<int, int>> h = __hash(s);

            int curl = 0, curr = 0;
            for (char c : s){
                curl += (c == 'L');
                curr += (c == 'R');
            }

            int last = -1;
            int col = -1;
            for (int i = 0; i < s.size(); i++){
                if (mp.find(h[i]) != mp.end()){
                    if (mp[h[i]].first > last){
                        last = mp[h[i]].first;
                        col = mp[h[i]].second;
                    }
                }

            }

            if (last == -1){
                cout << -1 << endl;
            } else {
                int diff = (curl - L[last]) - (curr - R[last]);
                cout << ((col + diff) % c + c) % c << endl;
            }

        }
    }

}

int main(){
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
