#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const int N = 2e5 + 5;

int a[N];
ll p[N];

int t[N][20];
int LOG[N];

void solve(){
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++){
        cin >> a[i];
        p[i] = p[i - 1] + a[i];
    }

    LOG[1] = 0;
    for (int i = 2; i <= n; i++) LOG[i] = LOG[i / 2] + 1;

    for (int i = 1; i <= n; i++) t[i][0] = a[i];

    for (int j = 1; j < 20; j++){
        for (int i = 1; i <= n; i++){
            if (i + (1 << j) - 1 <= n){
                t[i][j] = min(t[i][j - 1], t[i + (1 << (j - 1))][j - 1]);
            }
        }
    }

    function<int(int, int)> get = [&](int l, int r){
        int x = LOG[r - l + 1];
        return min(t[l][x], t[r - (1 << x) + 1][x]);
    };

    ll half = (p[n] + 1) / 2;

    int ans = n;
    for (int i = 1; i <= n; i++){
        int l = i, r = n;

        int j = -1;
        while (l <= r){
            int m = (l + r) >> 1;
            if (p[m] - p[i - 1] >= half){
                j = m;
                r = m - 1;
            } else {
                l = m + 1;
            }
        }

        if (j == -1) continue;

        ans = min(ans, j - i + 1);

        if (p[j] - p[i - 1] - get(i, j) >= half){
            ans = min(ans, j - i);
        }

    }

    cout << ans << endl;

}

int main(){
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
