#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const int A = 998244353, B = 1e9 + 9;

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    ll x = binpow(n, k / 2);
    x = x * x % B;
    if (k % 2) x = x * n % B;
    return x;
}

void solve(){
    int n; cin >> n;
    string s; cin >> s;

    vector <int> a(n + 2, -1);
    bool sign = 1;
    int l = 0, r = n;
    set <int> S;
    for(int i = 0; i <= n; i ++){
        S.insert(i);
    }
    for(int i = 0; i < s.size(); i ++){
        if(s[i] != 'A') continue;
        int L = a[i], R = a[i + 1];
        if(L == -1){
            if(sign){
                L = l ++;
            } else {
                L = r --;
            }
        }

        if(R == -1){
            if(sign){
                R = r --;
            } else {
                R = l ++;
            }
        }
        a[i] = L; a[i + 1] = R;
        if(S.count(L)) S.erase(L);
        if(S.count(R)) S.erase(R);
        sign ^= 1;
    }
    for(int i = 0; i <= s.size(); i ++){
        if(a[i] == -1){
            int X = *S.begin();
            a[i] = X;
            S.erase(X);
        }
        cout << a[i] + 1 << " ";
    }
}

int main(){
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
