﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;

struct seg_tree {
    int sz;
    vi a, tree;

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) tree[v] = a[tl];
        else {
            int tm = (tl + tr) / 2;

            build(2 * v + 0, tl, tm);
            build(2 * v + 1, tm, tr);

            tree[v] = tree[2 * v] + tree[2 * v + 1];
        }
    }

    seg_tree(vi &s) {
        a = s;
        sz = a.size();
        tree.resize(4 * sz);
        build(1, 0, sz);
    }

};

int sum(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    if (b < 0) {
        return sum(a - 1, b + 1);
    } else {
        return sum(a + 1, b - 1);
    }
}


signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
    int n, m;
    cin >> n >> m;
    int c = m + 14 - n;
    int ans = n - 7;
    if (ans < 0) ans += c;
    cout << ans;
}


//#pragma clang diagnostic pop