/*
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░    ▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓                                                            ░░                                    ░░▒▒▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓    ░░▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓                                                            ░░                                    ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓    ░░▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓                  ░░░░                                            ░░                              ▒▒▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓    ░░▓▓▓▓▓▓▓▓▓▓████▓▓▓▓        ░░░░░░      ░░      ░░░░░░                                ░░                              ░░▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░    ░░▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓  ░░                ░░░░            ░░░░                                                          ░░▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓        ▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓░░        ░░▓▓▓▓▒▒░░░░▒▒▓▓▓▓▓▓          ░░                          ░░                            ░░▒▒▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒        ▓▓▓▓▓▓▓▓▓▓████▒▒          ▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒          ░░            ░░        ░░                            ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░        ▓▓▓▓▓▓▓▓▓▓██▒▒        ▒▒▓▓▓▓▓▓▓▓▓▓▓▓░░    ▓▓▓▓▓▓▓▓▓▓▓▓▒▒        ░░          ░░                                      ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓          ░░▓▓▓▓▓▓▓▓▒▒      ▒▒▓▓▒▒  ▒▒▓▓▓▓▒▒░░        ▒▒▓▓▓▓░░░░▓▓▓▓░░      ░░                    ░░                          ░░▓▓▒▒░░▒▒▒▒░░▒▒░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░            ▓▓▓▓▓▓▓▓      ▓▓▓▓░░    ░░░░                ░░▒▒      ▒▒▓▓        ░░    ░░            ░░                          ░░▓▓▒▒░░▒▒░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓              ░░▓▓▓▓      ▒▒▒▒                                        ░░▓▓      ░░  ░░              ░░                          ░░▓▓░░░░▒▒░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓                ░░░░    ▒▒░░                                            ░░▒▒    ░░░░                ░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓                  ░░░░░░░░                                                ░░▒▒░░░░                  ░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓                ░░░░░░      ░░      ░░                            ░░          ░░░░                  ░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░              ░░░░░░    ░░      ░░      ░░                      ░░    ░░    ░░░░░░                ░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓              ░░░░░░    ░░      ░░      ░░              ░░              ░░    ░░░░              ░░                            ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░          ░░░░░░    ░░                ░░              ░░        ░░    ░░    ░░░░░░            ░░                            ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓          ░░░░░░    ░░      ░░        ░░              ░░                      ░░░░          ░░░░                            ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░      ░░░░░░░░    ░░      ░░        ░░          ░░  ░░                ░░    ░░░░░░        ░░░░░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░    ░░▒▒▒▒              ░░      ░░░░  ░░      ░░  ░░░░              ░░    ░░░░░░░░    ░░░░░░░░                          ░░▓▓░░░░░░░░░░░░░░
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░░░░░░░░░░░    ░░      ░░░░      ▒▒░░  ░░      ░░    ░░        ░░    ░░    ░░░░░░░░░░░░▒▒░░░░░░                          ░░▓▓░░░░░░░░░░▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓    ░░░░▒▒▒▒    ░░      ░░        ▒▒░░  ░░      ░░    ░░        ░░            ▒▒▒▒░░░░  ░░░░░░░░                          ░░▓▓▒▒░░░░░░░░▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓    ░░░░░░░░    ░░      ░░        ░░░░  ░░      ░░    ▒▒        ░░            ▒▒░░░░░░  ░░▒▒▒▒░░                          ░░▓▓▒▒░░░░░░░░▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒    ░░░░░░░░    ░░░░    ░░        ░░░░          ░░    ▒▒        ░░            ▒▒░░░░    ░░░░                              ░░▓▓▒▒░░░░░░░░▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░      ░░▒▒        ░░  ░░░░        ░░░░  ░░      ░░    ░░░░  ░░  ░░            ▒▒░░        ░░                              ░░▓▓░░░░░░░░░░▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░        ░░        ░░  ░░▒▒  ░░░░░░░░░░  ░░      ░░  ░░░░░░░░░░                ░░░░        ░░                              ░░▓▓░░░░▒▒▒▒▒▒▒▒▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓          ░░        ░░  ░░▓▓  ░░  ░░░░░░  ░░      ░░    ░░░░  ░░                ░░░░        ░░                              ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓        ░░░░        ░░  ░░▒▒  ░░  ░░░░░░  ░░      ░░    ░░▒▒  ░░░░    ░░        ░░░░          ░░                            ░░▓▓░░░░▒▒▒▒▒▒▒▒▒▒
████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒            ░░        ░░  ░░▒▒  ░░  ░░░░░░  ▒▒      ░░    ░░▒▒    ░░  ░░          ░░                ░░                        ▒▒▓▓░░▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████▓▓▓▓▓▓▓▓██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓                ░░        ░░  ░░▒▒  ░░  ░░  ░░  ▒▒          ░░  ░░    ░░  ░░░░        ░░░░            ░░                          ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒▒▒░░▒▒░░        ░░░░  ░░░░  ░░  ░░  ░░  ▒▒          ░░  ░░░░  ▒▒  ▒▒░░        ░░    ░░░░░░░░░░░░                          ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓▓▓▓▓▓▓▓▓          ░░    ░░░░  ░░  ▒▒░░░░░░░░          ░░  ░░░░  ▒▒  ▒▒░░░░      ░░    ░░░░░░░░░░░░                          ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓██▓▓▓▓▓▓▓▓▓▓▓▓          ░░    ▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░░░░░░░░░░░  ▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░░░      ░░    ░░░░░░░░░░░░                          ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓██▓▓          ░░▒▒░░▓▓▒▒▒▒▓▓▓▓▓▓▓▓▒▒░░            ▒▒▒▒▓▓▓▓▓▓▓▓▒▒▒▒▒▒░░      ░░    ░░░░░░░░░░░░                          ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒            ▒▒  ░░  ░░▓▓▓▓▓▓▓▓░░                ▒▒▓▓▒▒▓▓▓▓░░░░  ░░      ░░    ░░░░░░░░░░░░                          ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░    ░░      ░░  ░░  ▓▓▓▓▒▒▓▓▓▓░░                ▓▓▓▓▒▒▓▓▓▓░░░░  ░░            ░░░░░░░░░░░░░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓████░░░░  ░░      ░░      ▒▒▒▒▓▓░░▒▒                  ▒▒▓▓▓▓  ▒▒    ░░░░            ░░░░░░░░░░░░░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████████████▓▓▓▓▓▓████████▓▓      ░░      ░░      ░░▒▒░░  ▒▒                  ░░░░░░  ░░    ░░      ░░      ░░▒▒▒▒▒▒░░▒▒░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████████████████████████████      ░░        ░░  ░░    ░░░░                        ░░░░      ░░      ░░        ▓▓▒▒▒▒▒▒▒▒░░                        ▒▒▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████▓▓              ░░░░  ░░                                          ░░    ░░          ░░░░░░░░▒▒░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████████████████████████▓▓░░  ░░    ░░░░░░░░░░  ░░░░░░                            ░░  ░░    ░░░░░░░░            ░░▒▒▒▒▒▒░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████    ░░    ░░░░░░░░░░                                            ░░░░░░░░░░  ░░    ░░  ▒▒▒▒▒▒▒▒░░                        ░░▓▓▒▒░░▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████████████████████████▓▓    ░░    ░░░░░░░░░░░░                                          ▒▒░░░░░░▒▒  ░░        ░░▒▒▒▒▒▒░░                        ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████░░  ░░    ░░░░░░░░░░░░                                        ░░▒▒░░░░░░▒▒░░░░        ▒▒▒▒▒▒▒▒░░                        ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████▓▓      ░░▒▒▒▒░░░░░░░░▒▒                                    ░░░░▒▒░░░░░░░░░░░░  ░░  ░░▒▒▒▒▒▒▒▒░░  ░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████████▒▒░░░░▒▒░░░░░░░░▒▒░░░░░░                              ░░░░░░░░░░░░░░░░░░░░░░░░░░        ░░░░  ░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████████████████████████▓▓▓▓▒▒▒▒░░▒▒░░░░▒▒░░░░░░░░░░                      ░░  ░░░░▒▒░░░░░░░░░░░░░░▒▒▒▒      ░░░░    ░░░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
██████████████████████████████████████████████████████████████▓▓▒▒▓▓▓▓▓▓▓▓▓▓░░░░░░░░░░░░░░  ░░░░░░          ░░░░░░░░    ░░▒▒░░░░░░▒▒▓▓▓▓▓▓▓▓▓▓▓▓        ░░  ░░░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████████████████████████████████████▓▓▓▓████████▓▓▓▓▓▓▓▓░░▒▒▓▓▓▓▓▓▓▓░░░░░░░░░░  ░░    ░░░░░░▒▒░░▒▒░░░░░░░░        ▒▒░░░░░░▓▓▓▓▓▓▓▓▒▒░░▓▓▒▒        ░░  ░░                    ▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▒▒▒▒▒▒▓▓▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒░░▒▒▒▒    ░░      ░░░░░░░░░░░░░░░░    ░░    ▒▒░░░░░░▓▓▓▓▓▓▓▓▓▓▒▒▓▓▓▓░░░░  ░░░░  ░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░▒▒░░      ░░          ░░░░░░              ▒▒░░░░▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░░░░░░░    ░░                    ▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
██████████████▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒░░▒▒░░░░░░░░░░▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒▒▒▒▒░░      ░░                    ░░    ░░▒▒▒▒▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒░░░░░░░░    ░░                    ░░▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
██████████████▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒░░░░░░░░░░░░░░░░▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒░░▒▒▒▒░░        ░░              ░░        ░░▒▒▒▒▒▒▒▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░      ░░░░  ░░                    ▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
████████████▓▓▓▓░░▒▒▒▒░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░▓▓▓▓▓▓▓▓▓▓▓▓▓▓  ░░▒▒▒▒▒▒            ░░░░  ░░░░░░          ░░░░▒▒▒▒  ▒▒▓▓▓▓▓▓▓▓▓▓▓▓          ░░░░░░                    ▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░░░░░░░░░                                ▓▓▓▓▓▓▓▓▓▓▓▓▓▓░░      ▒▒▒▒▒▒            ░░      ░░░░          ░░▒▒░░▒▒    ░░▒▒▓▓▓▓▓▓▓▓▓▓▓▓░░░░░░░░░░░░  ░░  ░░  ░░  ░░  ░░▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒▒                                        ░░▓▓░░▓▓▓▓▓▓▓▓▓▓░░      ▒▒░░▒▒            ░░  ░░░░  ░░          ░░▒▒░░░░    ░░▓▓▓▓▓▓▓▓▓▓▒▒▒▒▓▓░░░░░░░░░░░░░░░░░░░░░░░░░░  ░░▒▒▓▓▒▒▒▒▒▒▒▒▒▒▒▒▒▒*/
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
template <typename _T, typename _Cmp = less<>>
using indexed_set = tree<int, null_type, _Cmp, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;
using vpi = vector<pi>;
using vpll = vector<pll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using ull = unsigned ll;

/* Debug */
template <typename A, typename B>
ostream &operator<<(ostream &os, const pair<A, B> &p)
{
    return os << '(' << p.first << ", " << p.second << ')';
}
template <typename T_container, typename T = typename enable_if<!is_same<T_container, string>::value, typename T_container::value_type>::type>
ostream &operator<<(ostream &os, const T_container &v)
{
    os << "{";
    string sep;
    for (const T &x : v)
    {
        os << sep << x, sep = ", ";
    }
    return os << "}";
}

void dbg_out()
{
    cerr << endl;
}

template <typename Head, typename... Tail>
void dbg_out(Head H, Tail... T)
{
    cerr << " " << H;
    dbg_out(T...);
}
#define dbg(...) cerr << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        ll x;
        cin >> x;
        x = abs(x);
        vi c;
        ll c1 = 0, c2 = 0, c3;
        while (x)
        {
            c.push_back(x & 1);
            if (x & 1)
            {
                c1++;
            }
            else
            {
                c2++;
            }
            x >>= 1;
        }
        for (int i = 0; i < c.size();)
        {
            int j = i;
            while (j < c.size() && c[i] == c[j])
                ++j;
            if (c[i] == 1)
            {
                if (j - i > 1)
                {
                    c3 += 2;
                }
                else
                {
                    c3++;
                }
            }
            i = j;
        }
        cout << min({c1, c2 + 2, c3}) << "\n";
    }
    return 0;
}