﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;



vector<ll> arr, st;
vector <pair<int, ll>> dp;

void build(ll v, ll l, ll r) {
	if (r - l == 1) {
		st[v] = arr[l];
	}
	else if (r - l > 1) {
		ll mid = l + (r - l) / 2;
		build(v * 2 + 1, l, mid);
		build(v * 2 + 2, mid, r);
		st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
	}
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
	if (l >= tr || r <= tl) return 1e18;
	if (l <= tl && tr <= r) return st[v];
	ll mid = tl + (tr - tl) / 2;
	return min(get(v * 2 + 1, tl, mid, l, r), 
		get(v * 2 + 2, mid, tr, l, r));
}

int main() {
	ll n, s = 0;
	cin >> n;
	arr.assign(n, 0);
	for (ll i = 0; i < n; ++i) {
		cin >> arr[i];
		s += arr[i];
	}
	s = (s + 1) / 2;
	st.assign(n * 4, 0);
	build(0, 0, n);
	dp.assign(n, { -1, 0 });
	for (int i = 0; i < n; ++i) {
		dp[0].second += arr[i];
		if (dp[0].second >= s) {
			dp[0].first = i + 1;
			break;
		}
	}
	for (int i = 1; i < n; ++i) {
		dp[i] = dp[i - 1];
		dp[i].second -= arr[i - 1];
		--dp[i].first;
		for (int j = i + dp[i].first; j < n; j++) {
			dp[i].second += arr[j];
			++dp[i].first;
			if (dp[i].second >= s) break;
		}
		if (dp[i].second < s) {
			dp[i].first = -1; break;
		}
	}
	ll ans = 1e18;
	for (int i = 0; i < n; ++i) {
		if (dp[i].first == -1) break;
		else {
			ans = min(ans, (ll)dp[i].first);
			ll tmp = get(0, 0, n, i, i + dp[i].first);
			if (dp[i].second - get(0, 0, n, i, i + dp[i].first) >= s) {
				ans = min(ans, (ll)dp[i].first - 1);
			}
		}
	}
	cout << ans << "\n";
	return 0;
}