﻿#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
int countstepen(long long a) {
	int cnt = 0;
	while (a % 2 == 0) {
		a /= 2;
		++cnt;
	}
	return cnt;
}
long long mod_bin_pow(long long n) {
	if (n == 0)
		return 1;
	else if (n == 1)
		return 2;
	else if (n % 2 == 0) {
		long long t = mod_bin_pow(n / 2);
		return t * t;
	}
	return 2 * mod_bin_pow(n - 1);
}
int main() {
	int t; cin >> t;
	while (t--) {
		long long n; cin >> n;
		n = abs(n);
		long long ans = 0;
		bool is = true;
		if (n == 0) {
			cout << 0 << endl;
		}
		else {
			while (n != 0) {
				if (n - mod_bin_pow(countstepen(n)) == 0) {
					++ans;
					cout << ans;
					is = false;
					break;
				}
				else if (countstepen(n - mod_bin_pow(countstepen(n))) >= countstepen(n + mod_bin_pow(countstepen(n)))) {
					n -= mod_bin_pow(countstepen(n));
					++ans;
				}
				else {
					n += mod_bin_pow(countstepen(n));
					++ans;
				}
			}
			if (is)
				cout << ans + 1;
			cout << endl;
		}
	}
}

/*#include <iostream>
#include <vector>
using namespace std;

int main() {
	int n; cin >> n;
	vector <int> a(n), p(n + 1);
	for (int i = 0; i < n; ++i) cin >> a[i];
	p[0] = 0;
	for (int i = 0; i < n; ++i) p[i] = p[i - 1] + a[i - 1];
	for (int l = 0; l < n; ++l) {
		int sum = a[l];
		int r = l + 1;
		while()
	}
}*/
