﻿#include <iostream>
#include <deque>
#include <vector>
#define ll long long
using namespace std;
vector<ll> a;
ll n;
ll s = 0;
bool check(ll k) {
    if (k == n)
        return true;
    ll sum = 0; 
    deque <ll> mn;
    for (ll i = 0; i <= k; i++) {
        sum += a[i];
        while (!mn.empty() && a[mn.front()] > a[i])
            mn.pop_front();
        while (!mn.empty() && a[mn.back()] > a[i])
            mn.pop_back();
        mn.push_back(i);
    }
    ll st = 0;
    while (st + k < n) {
        if (st > 0) {
            ll i = st + k;
            sum -= a[st - 1]; sum += a[i];
            while (!mn.empty() && a[mn.front()] > a[i])
                mn.pop_front();
            while (!mn.empty() && a[mn.back()] > a[i])
                mn.pop_back();
            while (!mn.empty() && mn.front() < st)
                mn.pop_front();
            mn.push_back(i);
        }
        if (sum - mn.front() >= (s + 1) / 2) {
            return true;
        }
        st++;
    }
    return false;
}
ll bisearch() {
    ll l = 0, r = n;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    return r;
}
int main() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        s += a[i];
    }
    cout << bisearch();
}
