#include <iostream>
#include <string>
#include <unordered_map>

using namespace std;

int main() {
    unordered_map<string, int> pref;
    int q, c;
    cin >> q >> c;

    while (q--) {
        int type;
        string path;
        cin >> type;
        if (type == 1) {
            int color;
            cin >> color >> path;
            pref[path] = color;
        } else {
            cin >> path;
            int cur = -1;
            for (int i = 0; i < path.size(); i++) {
                string sub = path.substr(0, i + 1);
                auto it = pref.find(sub);
                if (it != pref.end()) {
                    cur = it->second;
                } else {
                    if (cur != -1) {
                        if (path[i] == 'L')
                            cur = (cur + 1) % c;
                        else
                            cur = (cur - 1 + c) % c;
                    }
                }
            }
            cout << cur << '\n';
        }
    }

    return 0;
}
