#include <iostream>
#include <string>
#include <unordered_map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unordered_map<string, pair<int, int>> pref;
    int q, c;
    cin >> q >> c;
    int priority = 0;

    while (q--) {
        int type;
        string path;
        cin >> type;
        if (type == 1) {
            int color;
            cin >> color >> path;
            pref[path] = make_pair(color, priority++);
        } else {
            cin >> path;
            int cur = -1;
            int cur_pri = -1;
            string sub;
            for (int i = 0; i < path.size(); i++) {
                sub += path[i];
                auto it = pref.find(sub);
                if (it != pref.end() && it->second.second > cur_pri) {
                    cur = it->second.first;
                    cur_pri = it->second.second;
                } else {
                    if (cur != -1) {
                        if (path[i] == 'L')
                            cur = (cur + 1) % c;
                        else
                            cur = (cur - 1 + c) % c;
                    }
                }
            }
            cout << cur << '\n';
        }
    }

    return 0;
}
