#include <iostream>
#include <cmath>

using namespace std;
using ll = long long;

ll dp(ll cur, ll x) {
    if (cur == x)
        return 0;

    ll dist = abs(cur - x);
    ll lower = floor(log2(dist));
    ll higher = ceil(log2(dist));
    if (x > cur)
        return min(lower + dp(cur + 1 << lower, x), higher + dp(cur + 1 << higher, x));
    else
        return min(lower + dp(cur - 1 << lower, x), higher + dp(cur - 1 << higher, x));
}

int main()
{
    int n;
    cin >> n;
    while (n--) {
        ll x;
        cin >> x;
        cout << dp(0, x) << '\n';;
    }
    return 0;
}
