/// @author Camillus
#include <bits/stdc++.h>
#define x first
#define y second
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...)
#endif
#define int long long
using namespace std;

using Vector = pair<int, int>;
using Point = Vector;

Vector operator-(Vector V) {
    return {-V.x, -V.y};
}

Vector operator+(Vector A, Vector B) { return {A.x + B.x, A.y + B.y}; }
Vector operator-(Vector A, Vector B) { return {A.x - B.x, A.y - B.y}; }

int operator%(Vector A, Vector B) { return A.x * B.y - A.y * B.x; }
int operator*(Vector A, Vector B) { return A.x * A.x + A.y * B.y; }

bool check(Vector A, Vector B) {
    return A * B > 0 && A % B == 0;
}

int get(Vector V) {
    swap(V.x, V.y);
    V.y = -V.y;
    vector<Vector> A;
    A.emplace_back(1, 1);
    A.emplace_back(-1, 1);
    A.emplace_back(-1, -1);
    A.emplace_back(1, -1);
    map<int, int> B;
    B[0] = 2;
    B[1] = 8;
    B[2] = 6;
    B[3] = 4;
    for (int i = 0; i < 4; i++) {
        if (check(V, A[i])) {
            return B[i];
        }
    }
    B[0] = 1;
    B[1] = 7;
    B[2] = 5;
    B[3] = 3;
    for (int i = 0; i < 4; i++) {
        if (A[i] % V > 0 && V % A[(i + 1) % 4] > 0) {
            return B[i];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> A(n, vector<int>(m));
    int a, b;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> A[i][j];
            if (A[i][j] == 2 || A[i][j] == 6) {
                a = i + j;
            }
            if (A[i][j] == 8 || A[i][j] == 4) {
                b = i - j;
            }
        }
    }
    int x = (a + b) / 2;
    int y = a - x;
    cout << x + 1 << " " << y + 1 << "\n";

    Point C(x, y);

    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            Point P(i, j);
            if (P == C) {
                cnt += 1;
                continue;
            }
            Vector V = C - P;
//            debug(V, get(V));
//            debug(get(-V), A[i][j]);
            cnt += get(-V) == A[i][j];
        }
        if (cnt == m) {
            cout << i + 1 << " ";
            break;
        }
    }

    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            Point P(i, j);
            if (P == C) {
                cnt += 1;
                continue;
            }
            Vector V = C - P;
            cnt += get(-V) == A[i][j];
        }
        if (cnt == n) {
            cout << j + 1 << "\n";
            break;
        }
    }
    return 0;
}
