/// @author Camillus
#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...)
#endif
#define int long long
using namespace std;

const pair<int, int> none = {-1, -1};
struct node {
    pair<int, int> state = none;
    node* left = nullptr;
    node* right = nullptr;
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q, c;
    cin >> q >> c;

    node *root = new node;

    for (int t = 0; t < q; t++) {
        int type; cin >> type;
        if (type == 1) {
            int x; cin >> x;
            string s; cin >> s;
            node *u = root;
            for (char d : s) {
                if (d == 'L') {
                    if (u->left == nullptr) {
                        u->left = new node;
                    }
                    u = u->left;
                } else {
                    if (u->right == nullptr) {
                        u->right = new node;
                    }
                    u = u->right;
                }
            }
            u->state = {x, t};
        } else {
            string s; cin >> s;
            node *u = root;
            pair<int, int> state = u->state;
            for (char d : s) {
                if (d == 'L') {
                    if (state != none) {
                        state.first = (state.first + 1) % c;
                    }
                    if (u->left == nullptr) {
                        u->left = new node;
                    }
                    u = u->left;
                } else {
                    if (state != none) {
                        state.first = (state.first + c - 1) % c;
                    }
                    if (u->right == nullptr) {
                        u->right = new node;
                    }
                    u = u->right;
                }
                if (u->state.second > state.second) {
                    state = u->state;
                }
            }
            if (state == none) {
                cout << -1 << "\n";
            } else {
                cout << state.first << "\n";
            }
        }
    }
    return 0;
}
