/// @author Camillus
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...)
#endif
#define int __int128

using namespace std;
typedef long long ll;
typedef long double ld;

istream& operator>>(istream& in, __int128 &x) {
    long long y; in >> y;
    x = y;
    return in;
}

int pop_count(int x) {
    unsigned int x2 = x;
    unsigned int y = x2 << 64;
    x2 -= y;
    return __builtin_popcountll((unsigned long long)x2) + __builtin_popcountll((long long)y);
}

void solve() {
    int x; cin >> x;
    x = abs(x);
    int one = 1;
    int ans = pop_count(x);
    for (int i = 0; i < 100; i++) {
        if ((one << i) > x) {
            ans = min(ans, pop_count((one << i) - x) + 1);
        }
    }
    cout << (long long)ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}