#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;
long long s;
long long mx = 1000000000000000000;
long long F(long long a) {
    if (a < 10) return a + 1;
    long long ans = 10, v = 10, len = 2;
    while (v <= a) {
        if (v == mx || a < 10 * v) {
            ans += (a - v + 1) * len;
            break;
        }
        ans += ((long long)9 * v * len);
        if (v == mx) break;
        len++; v *= 10;
    }
    return ans;
}
void solvve(long long x) {
    long long l = x, r = 1, k = 18;
    while (k--)
        r *= 10;
    while (l <= r) {
        long long mid = (l + r) / 2;
        long long value = F(mid) - F(x - 1);
        if (value == s) {
            cout << mid - x + 1 << "\n";
            cout << x << " " << mid << "\n";
            exit(0);
        }
        if (value < s) l = mid + 1;
        else r = mid - 1;
    }
}
void solve() {
    cin >> s;
    for (long long i = 0; i <= 1000000; i++)
        solvve(i);
    cout << "-1\n";
    return;
}
int main()
{
    int t = 1;
    while (t--) {
        solve();
    }
}