#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void print(vector <int> x) {
    for (auto c : x) {
        cout << c << " ";
    }
    cout << endl;
}

vector <int> a;
vector <int> post;
int ANS;

void build(int ans, int i, int mn, int cnt) {
    if (i >= a.size() - 1) return;
    int j = i;
    while (ans < cnt) {
        ans += a[j];
        if (mn > a[j]) mn = a[j];
        post[i]++;
        j++;
    }
    post[i + 1] = post[i] - 1;
    if (ans - mn >= cnt) post[i]--;
    if (ANS > post[i]) ANS = post[i];
    build(ans - a[i], i + 1, mn, cnt);
}

int main() {
    int n, cnt = 0;
    cin >> n;
    a.resize(n);
    post.resize(n, 0);
    ANS = n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt += a[i];
    }
    cnt = (cnt + 1) / 2;
    build(0, 0, 1e9, cnt);
    if (a[n - 1] >= cnt) ANS = 1;
    cout << ANS;
}
