#include <bits/stdc++.h>

using namespace std;
using ll = unsigned long long;

const int N = 1e5 + 3;

ll fp(ll d, ll u){
    if(u == 0) return 0;
    ll res = 1;
    while(u){
        if(u & 1){
            res *= d;
        }
        d *= d;
        u >>= 1;
    }
    return res;
}

ll st(ll n){
    ll res = 0;
    while(n){
        res++;
        n /= 10;
    }
    return res;
}

ll f(ll r){
    ll res = 0;
    ll z = st(r);
    for(ll i = 1; i < z; ++i){
        res += fp(10, i) * i;
    }
    res += z * (r - fp(10, z - 1) + 1);
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll s;
    cin >> s;

    ll l = -1, r = 1e18;
    while(r - l > 1){
        ll m = (l + r) / 2;
        if(f(m) >= s){
            r = m;
        }else{
            l = m;
        }
    }

    l = 0;
    ll sum = f(r);

    for(; ; ++r){
        l = 0;
        sum = f(r);
        while(sum > s){
            sum -= st(l);
            ++l;
        }
        if(sum == s){
            cout << r - l + 1 << "\n";
            cout << l << " " << r;
            break;
        }
    }
}