from math import ceil, log

def cbi(x):
    c = 0
    while x:
        c += x % 2
        x //= 2
    return c

def f(x):
    n = 2 ** ceil(log(x, 2))
    if n == x:
        return 1
    return min(cbi(x), f(n - x) + 1)

t = int(input())

for _ in range(t):
    a = abs(int(input()))
    if a:
        print(f(a))
    else:
        print(0)