#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <iostream>
#include <string>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <bitset>
#include <assert.h>
#include <any>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define iters(obj) obj.begin(), obj.end()
#define riters(obj) obj.rbegin(), obj.rend()

ll bins(ll x) {
    ll l = 0;
    ll r = 64;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if ((1 << mid) <= x) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return (1 << l);
}

ll ans = 0;

void rec(ll x, ll cnt) {
    ll h = bins(x);
    if (x - h == 0) {
        cnt++;
        ans = min(ans, cnt);
        return;
    }
    rec(x - h, cnt + 1);
    rec(h * 2 - x, cnt + 1);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    ll t;
    ll n;
    cin >> t;
    while (t--) {
        cin >> n;
        n = abs(n);
        if (n == 0) {
            cout << 0 << '\n';
            continue;
        }
        ans = 1e9;
        rec(n, 0);
        cout << ans << '\n';
    }
    return 0;
}