#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <iostream>
#include <string>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <bitset>
#include <assert.h>
#include <any>
#include <deque>
using namespace std;
typedef long long ll;
typedef long double ld;
#define iters(obj) obj.begin(), obj.end()
#define riters(obj) obj.rbegin(), obj.rend()
int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
	ll n;
	cin >> n;
	vector<ll>v(n);
	vector<ll>pref(n + 1, 0);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		cin >> v[i];
		pref[i + 1] = v[i];
		pref[i + 1] += pref[i];
		ans += v[i];
	}
	ans = ans / 2 + ans % 2;
	ll l = 0;
	ll r = 0;
	ll sm = v[0];
	ll x = 1e9;
	while (true) {
		if (sm < ans) {
			r++;
			if (r == n) {
				break;
			}
			sm += v[r];
		}
		else {
			x = min(x, r - l + 1);
			sm -= v[l];
			l++;
		}
	}
	deque <ll> d{ min_element(v.begin(), v.begin() + x) - v.begin() };
	for (ll i = x; i <= n; i++) {
		// [i-x; i)
		if (pref[i] - pref[i - x] - v[d.front()] >= ans) {
			cout << x - 1;
			return 0;
		}
		// d.front() -     [i-x; i)
		if (d.front() <= i - x) {
			d.pop_front();
		}
		if (i == n) break;
		while (!d.empty() && v[d.back()] >= v[i]) {
			d.pop_back();
		}
		d.push_back(i);
		// [i+1-x; i]
	}
	cout << x;
	return 0;
}