#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pdd pair<ld, ld>
#define ff first
#define ss second
#define all(v) v.begin(),v.end()

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update> ordset;

#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")

ll INF = 2e18;
const ll mod = 1000000007;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll binpow(ll n, ll m){
    if(m == 0) return 1ll;
    if(m & 1ll) return n * binpow(n, m - 1ll);
    ll b = binpow(n, m / 2ll);
    return b*b;
}

void solve(){
    ll s;
    cin >> s;
    ll ans = 0, ost = 1;
    if(s >= 10){
        s -= 10;
        ans = 9;
        ost = 2;
        for(ll i = 2; i <= 16; i++){
            if(9ll * binpow(10ll, i - 1ll) * i <= s){
                s -= 9ll * binpow(10ll, i - 1ll) * i;
                ans += 9ll * binpow(10ll, i - 1ll);
                ost = i + 1ll;
            } else break;
        }
    }
    //cout << ans << ' ' << ost << ' ' << s << '\n';
    ll ostost = (ost - (s % ost)) % ost;
    ll id = 0;
    ll num = ans + s / ost + (ans == 0 ? -1ll : 0ll);
    if(ostost == 0){
        cout << (ll)(num - id + 1ll) << '\n';
        cout << id << ' ' << num << '\n';
        return;
    }
    if(ostost <= 10){
        id += ostost;
        num += 1ll;
        cout << (ll)(num - id + 1ll) << '\n';
        cout << id << ' ' << num << '\n';
        return;
    }
    if(ostost % 2 == 0){
        ostost -= 10;
        id += 10;
        id += ostost / 2;
        num += 1ll;
        cout << (ll)(num - id + 1ll) << '\n';
        cout << id << ' ' << num << '\n';
        return;
    }
    for(ll i = 0; i < 100000; i++){
        ll diff = (ll)(to_string(id).length());
        id++;
        ostost += diff;
        if(ostost >= ost) {
            num += 1ll;
            ostost %= ost;
        }
        if(ostost == 0){
            cout << (ll)(num - id + 1) << '\n';
            cout << id << ' ' << num << '\n';
            return;
        }
        if(id >= num){
            cout << -1;
            return;
        }
        ost = (ll)(to_string(num + 1ll).length());
    }
    cout << -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif
	int tt;
    //cin >> tt;
    tt = 1;
	while (tt--) {
		solve();
		#ifdef LOCAL
            cout << "__________________________________" << endl;
		#endif
	}
	#ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << "sec" << '\n';
	#endif
	return 0;
}





