#include <iostream>
#include <algorithm>
using namespace std; 
int partition(string a[], int start, int end)
{ 
    string pivot = a[end];
    int pIndex = start;
    for (int i = start; i < end; i++)
    {
        if (a[i] <= pivot)
        {
            swap(a[i], a[pIndex]);
            pIndex++;
        }
    }
    swap (a[pIndex], a[end]);
    return pIndex;
}
void quicksort(string a[], int start, int end)
{
    if (start >= end) {
        return;
    }
    int pivot = partition(a, start, end);
    quicksort(a, start, pivot - 1);
    quicksort(a, pivot + 1, end);
}
int main()
{
	int n;
   string a[200000];
    cin >>n;
    for (int i=0; i<n; i++){
    	cin>>a[i];
	}
    quicksort(a, 0, n - 1);
   int i=0,min=1000000; 
   string s,l;
   while (i<=n/2){
   	s=a[i];
   	l=a[i+1];
   	int j=0;
	   while ( s[j]==l[j]){
		   j+=1;
		   if (j==s.length()) break;
	   }
	   if (j<min){
	   	min=j;
	   }
   	i+=2;
   } 
 cout<<min;
    return 0;
}
