#include <bits/stdc++.h>

#ifdef LOCAL

#include "debug.h"

#else
#define debug(...)
#endif

using namespace std;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int long long


template<size_t D, typename T>
struct vec : public vector<vec<D - 1, T>> {
    static_assert(D >= 1, "Vector dimension must be greater than zero!");

    template<typename... Args>
    explicit vec(int n = 0, Args... args) : vector<vec<D - 1, T>>(n, vec<D - 1, T>(args...)) {}
};

template<typename T>
struct vec<1, T> : public vector<T> {
    explicit vec(int n = 0, const T &val = T()) : vector<T>(n, val) {}
};


bool good(vector<string> a, int m) {
    bool ans = false;
    for (int i = 0; i < (int) a.size(); i += 2) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == a[i + 1][j]) ans = true;
            else {
                ans = false;
                return ans;
            }
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());

    int l = 0, r = INT32_MAX;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (good(a, m)) {
            l = m;
        } else
            r = m;
    }
    cout << l;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());
    string a1 = a[0], a2 = a[n / 2 - 1], b1 = a[n / 2], b2 = a[n - 1];
    if (n < 4 && a1 != b2) cout << 0;
    else if (n < 4 && a1 == b2) cout << a1.size();
    else {
        int q = 0;
        for (int i = 0; i < a1.size(); i++) {
            if (a1[i] == a2[i] and b1[i] == b2[i]) q++;
            else break;
        }
        cout << q;
    }
}