//#pragma GCC target( "sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3")
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <string>
#include <queue>
#include <numeric>
#include <bitset>
// #include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ndl '\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const double pi = 3.14159265359;
const int mod = 1e9 + 7;
const int dx[] = {0, 0, 1, -1};
const int dy[] = {1, -1, -1, 0};
const long long inf = 1ll<<62;
const int P = 31;
const int maxn = 100100;
using namespace std;
long long pref[200200];
long long t[400400], a[200200];
void build(long long v, long long tl, long long tr) {
	if(tl==tr) {
		t[v]=a[tl];
	} else {
		long long mid=(tl+tr)>>1;
		build(v*2, tl, mid);
		build(v*2+1, mid+1, tr);
		t[v]=min(t[v*2], t[v*2+1]);
	}
}
long long get(long long v, long long tl, long long tr, long long l, long long r) {
	if(tl>r || tr<l) return 2e9;
	if(tl>=l && tr<=r) {
		return t[v];
	}
	long long mid=(tl+tr)>>1;
	return min(get(v*2, tl, mid, l, r), get(v*2+1, mid+1, tr, l, r));
}
void tilt() {
	long long n;
	cin>>n;
	long long sum=0;
	for(long long i=1;i<=n;i++) {
		cin>>a[i]; sum+=a[i];
		pref[i]=pref[i-1]+a[i];
	} build(1, 1, n);
	sum=sum-(sum/2);
	long long ans=n;
	for(long long i=1;i<=n;i++) {
		long long l=i, r=n, res=1e9;
		while(l<=r) {
			long long mid=(l+r)>>1;
			if(pref[mid] - pref[i-1] - get(1, 1, n, i, mid) >= sum) {
				res=mid-i;
				r=mid-1;
			} else l=mid+1;
		}
		ans=min(ans, res);
	}
	cout<<ans;
}
int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
   int tt=1;
   // cin>>tt; 
   for(int i=1;i<=tt;i++) {
      // cout<<"Case "<<i<<": ";
      tilt();
   }
}
