#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define fr first
#define sc second
#define mp make_pair
#define pb push_back
#define _pb pop_back
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define nu_chto_pognali main
#define ios ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

mt19937 rnd(time(NULL));

const int INF = 2e9;
const int M1 = 1e9 + 7;
const int M2 = 1e9 + 9;
const int p = 257;

int sum(int a, int b, int m) {
	if (a + b > m)
		return a + b - m;
	return a + b;
}

int diff(int a, int b, int m) {
	if (a - b < 0)
		return a - b + m;
	return a - b;
}

int mult(int a, int b, int m) {
	return int((1LL * a * b) % m);
}


long long pw2(int st)
{
	long long ans=2;
	while (st!=1)
	{
		ans<<=1;
		if(st%2==1)
			ans*=2;
		st/=2;
	}
	return ans;
}

bool check(vector<vector<int>>& h1, vector<vector<int>>& h2, int k) {
	gp_hash_table<int, int> hashes1;
	gp_hash_table<int, int> hashes2;
	for (int i = 0; i < h1.size(); ++i) {
		++hashes1[h1[i][k]];
		++hashes2[h2[i][k]];
	}

	for (auto& [h, cnt] : hashes1) {
		if (cnt & 1)
			return 0;
	}
	for (auto& [h, cnt] : hashes2) {
		if (cnt & 1)
			return 0;
	}

	return 1;
}

int siz = 1;
vector<int> t;
void build(vector<ll>& a, int x, int tl, int tr) {
	if (tr - tl == 1) {
		if (tl < a.size())
			t[x] = a[tl];
	} else {
		int tm = (tl + tr) / 2;
		build(a, 2 * x + 1, tl, tm);
		build(a, 2 * x + 2, tm, tr);
		t[x] = min(t[2 * x + 1], t[2 * x + 2]);
	}
}

int getMin(int l, int r, int x, int tl, int tr) {
	if (l >= tr || r <= tl) return INF;
	if (l <= tl && r >= tr) return t[x];

	int tm = (tl + tr) / 2;
	int m1 = getMin(l, r, 2 * x + 1, tl, tm);
	int m2 = getMin(l, r, 2 * x + 2, tm, tr);
	return min(m1, m2);
}

void solve() {
	int n;
	cin >> n;
	vector<ll> a(n);

	ll half = 0;
	for (auto& el : a) {
		cin >> el;
		half += el;
	}
	half = (half + 1) / 2;

	vector<ll> sufSum(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		sufSum[i] = sufSum[i + 1] + a[i];
	}

	siz = 1;
	while (siz < n)
		siz <<= 1;
	t.resize(2 * siz - 1, INF);
	build(a, 0, 0, siz);

	int k = INF;
	for (int i = 0; i < n && sufSum[i] >= half; ++i) {
		int l = 1, r = n - i;
		while (l < r) {
			int m = (l + r) / 2;
			if (sufSum[i] - sufSum[i + m] >= half)
				r = m;
			else
				l = m + 1;
		}

		k = min(k, l);
		if (sufSum[i] - sufSum[i + l] - getMin(i, i + l, 0, 0, siz) >= half)
			k = min(k, l - 1);
	}

	cout << k << '\n';
}



int nu_chto_pognali() {
	ios;

	int T = 1;
	// cin >> T;
	while (T--) solve();

	return 0;
}
