#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define fr first
#define sc second
#define mp make_pair
#define pb push_back
#define _pb pop_back
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define nu_chto_pognali main
#define ios ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

mt19937 rnd(time(NULL));

const ll INF = 1e18;
const int M1 = 1e9 + 7;
const int M2 = 1e9 + 9;
const int p = 257;

int sum(int a, int b, int m) {
	if (a + b > m)
		return a + b - m;
	return a + b;
}

int diff(int a, int b, int m) {
	if (a - b < 0)
		return a - b + m;
	return a - b;
}

int mult(int a, int b, int m) {
	return int((1LL * a * b) % m);
}


long long pw2(int st)
{
	long long ans=2;
	while (st!=1)
	{
		ans<<=1;
		if(st%2==1)
			ans*=2;
		st/=2;
	}
	return ans;
}

bool check(vector<vector<int>>& h1, vector<vector<int>>& h2, int k) {
	gp_hash_table<int, int> hashes1;
	gp_hash_table<int, int> hashes2;
	for (int i = 0; i < h1.size(); ++i) {
		++hashes1[h1[i][k]];
		++hashes2[h1[i][k]];
	}

	for (auto& [h, cnt] : hashes1) {
		if (cnt & 1)
			return 0;
	}
	for (auto& [h, cnt] : hashes2) {
		if (cnt & 1)
			return 0;
	}

	return 1;
}

void solve() {
	int n;
	cin >> n;

	vector<string> str(n);
	int l = 0, r = 2 * 1e6 + 1;
	for (auto& s : str) {
		cin >> s;
		r = min(r, (int)s.length());
	}

	vector<vector<int>> h1(n, vector<int>(r + 1, 0)), h2(n, vector<int>(r + 1, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < r; ++j) {
			h1[i][j + 1] = sum(h1[i][j], str[i][j], M1);
			h2[i][j + 1] = sum(h2[i][j], str[i][j], M2);
		}
	}

	while (l < r) {
		int m = (l + r + 1) / 2;
		if (check(h1, h2, m))
			l = m;
		else r = m - 1;
	}

	cout << l << '\n';
}



int nu_chto_pognali() {
	ios;

	int T = 1;
	// cin >> T;
	while (T--) solve();

	return 0;
}
