#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool comp(pair<long long, int> a, pair<long long, int> b) {
    if (a.first == b.first) {
        if (a.second >= b.second) {
            return true;
        }
        return false;
    }
    return a.first > b.first;
}

int main()
{
    int n;
    cin >> n;
    vector <long long> a(n);
    vector<long long> ps(n + 1, 0);
    vector <pair<long long, int>> m(n);
    long long win = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ps[i + 1] = ps[i] + a[i];
        win = win + a[i];
        m[i] = make_pair(a[i], i);
    }
    win = win / 2 + win % 2;
    //for (auto i : ps) {
      //  cout << i << " ";
    //}
    //cout << endl;
    //cout << win << endl;
    sort(m.begin(), m.end(), comp);
    for (auto i : m) {
        //cout << i.second << " " << i.second - 1 << " " << ps.size() << endl;
        long long sum = i.first;
        int c = 1;
        int gr = i.second + c;
        while (sum < win && c + i.second <= n) {
            //cout << i.second + c << " " << i.second << endl;
            sum = ps[i.second + c] - ps[i.second];
            gr = i.second + c;
            c++;
        }

        //cout << sum << endl;
        if (sum < win) {
            continue;
        }
        if (sum > win) {
            long long minel = 10e10;
            for (int j = i.second; j < n; j++) {
                if (a[j] < minel) {
                    minel = a[j];
                }
            }
            //cout << minel << " " << sum - minel << endl;
            if (sum - minel >= win) {
                cout << gr - i.second - 1;
                return 0;
            }
            else {
                cout << gr - i.second;
                return 0;
            }
        }
        cout << gr - i.second;
        return 0;
    }
}
