#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

class segment_tree {
private:
    vector <ll> a;
    ll Size, MIN;
    void RecF (ll _l, ll _r, ll l, ll r, ll c) {
        if (l > _r || r < _l) return;
        if (l >= _l && r <= _r) {
            MIN = min(MIN, a[c]);
            return;
        }
        ll m = (l + r) / 2;
        RecF(_l, _r, l, m, c * 2);
        RecF(_l, _r, m + 1, r, c * 2 + 1);
    }
public:
    void Update (vector <ll> &b) {
        ll k = 1;
        while (k < b.size()) k *= 2;
        Size = k * 2;
        a = vector <ll> (Size, (ll)1e11);
        for (ll x = 0; x < b.size(); x++)
            a[k + x] = b[x];
        for (ll x = k - 1; x > 0; x--)
            a[x] = min(a[x * 2], a[x * 2 + 1]);
    }
    void Print () {
        for (ll x = 0; x < Size; x++)
            cout << a[x] << " ";
        cout << "\n";
    }
    ll Get (ll l, ll r) {
        MIN = 1e11;
        RecF(l, r, 1, Size / 2, 1);
        return MIN;
    }
};

void __MAIN__ () {
    ll n, s = 0, l, r, _l, _r, m, MIN = 1e11;
    cin >> n;
    vector <ll> b(n), c(n + 1);
    for (ll x = 0; x < n; x++) {
        cin >> b[x];
        s += b[x];
        c[x + 1] = b[x] + c[x];
    }
    s = (s + 1) / 2;
    segment_tree a;
    a.Update(b);
    for (ll x = 0; x < n; x++) {
        if (c[n] - c[x] < s)
            break;
        _l = x + 1;
        _r = n;
        l = x;
        r = n + 1;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (c[m] - c[_l - 1] >= s) {
                r = m;
                _r = min(_r, m);
            }else {
                l = m;
            }
        }
        MIN = min(MIN, _r - _l + 1);
        ll t = a.Get(_l, _r);
        if (c[_r] - c[_l - 1] - t >= s) MIN = min(MIN, _r - _l);
    }
    cout << MIN << "\n";
}

int main () {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll __T__ = 1;
    //cin >> __T__;
    while(__T__--) __MAIN__();
    return 0;
}
