#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
//#include "temp.cpp"
#include <cstdio>
using namespace std;

#define sz(x) (int)x.size()
#define len(x) (int)x.length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()
#define uniq(x) x.resize(unique(all(x)) - x.begin());
#define blt __builtin_popcount

#define fri(x) for(long long i = 0; i < x; ++i)
#define frj(x) for(long long j = 0; j < x; ++j)
#define frr(a, b) for(long long i = a; i < b; ++i)
#define frrj(a, b) for(long long j = a; j < b; ++j)

const long long inf = 1e12;
const int N = 5e5 + 10;
vector<pair<int, pair<long long, int>>> queries[N];
vector<int> harc[N];
int q, curr_node = 2;
long long c;
int son1[N], son2[N];
long long add[N], del[N];
long long answ[N];

void build(string &s, int ind, int size, int node, long long x, int query_cnt) {
  if(ind == size) {
    queries[node].push_back({query_cnt, {x, node}});
    return;
  }

  if(s[ind] == 'L') {
    if(!son1[node]) {
      son1[node] = curr_node++;
      
      //
      add[son1[node]] = add[node] + 1;
      del[son1[node]] = del[node];
    }
    build(s, ind + 1, size, son1[node], x, query_cnt);
  } else {
    if(!son2[node]) {
      son2[node] = curr_node++;

      //
      del[son2[node]] = del[node] + 1;
      add[son2[node]] = add[node];
    }
    build(s, ind + 1, size, son2[node], x, query_cnt);
  }
}

void build_(string &s, int ind, int size, int node, long long query_cnt) {
  if(ind == size) {
    harc[node].push_back(query_cnt);
    return;
  }

  if(s[ind] == 'L') {
    if(!son1[node]) {
      son1[node] = curr_node++;

      //
      add[son1[node]] = add[node] + 1;
      del[son1[node]] = del[node];
    }
    build_(s, ind + 1, size, son1[node], query_cnt);
  } else {
    if(!son2[node]) {
      son2[node] = curr_node++;

      //
      del[son2[node]] = del[node] + 1;
      add[son2[node]] = add[node];
    }
    build_(s, ind + 1, size, son2[node], query_cnt);
  }
}

set<pair<int, pair<long long, int>>> st;

void dfs(int node) {
  for(auto i: queries[node]) {
    st.insert(i);
  }

  if(!st.empty()) {
    for(auto i: harc[node]) {
      auto it = st.upper_bound(make_pair(i, make_pair(inf, N)));
      if(it == st.begin()) continue;
      it = prev(it);
      long long curr_x = it->second.first;
      long long to_plus = add[node] - add[it->second.second];
      long long to_minus = del[node] - del[it->second.second];

      to_plus %= c;
      to_minus %= c;

      curr_x += to_plus;
      curr_x %= c;

      curr_x -= to_minus;
      curr_x += 2 * c;

      curr_x %= c;
      answ[i] = curr_x;
    }
  }

  if(son1[node]) {
    dfs(son1[node]);
  }

  if(son2[node]) {
    dfs(son2[node]);
  }

  for(auto i: queries[node]) {
    st.erase(i);
  }
}

void solve_() {
  cin >> q >> c;

  vector<long long> to_answ;
  for(int i = 1; i <= q; i++) {
    int type; cin >> type;
    answ[i] = -1;

    if(type == 1) {
      long long x; cin >> x;
      string s; cin >> s;
      int m = sz(s);
      build(s, 0, m, 1, x, i);
    } else {
      string s; cin >> s;
      int m = sz(s);
      build_(s, 0, m, 1, i);
      to_answ.push_back(i);
    }
  }

  dfs(1);

  for(auto i: to_answ) {
    cout << answ[i] << "\n";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr); cout.tie(nullptr);

  auto solve = [&](int test_case)-> void {
    while(test_case--) {
      solve_();
    }
  };

  int test_cases = 1;
  // cin >> test_cases;
  solve(test_cases);

  return 0;
}
