#include <bits/stdc++.h>

using namespace std;

#define endl '\n'

int c;

struct Node {
    int color = -1, push = -1;
    int l = -1, r = -1;
};

vector<Node> trie(1);

void push(int ind) {

    if (trie[ind].l == -1) {
        trie[ind].l = trie.size();
        trie.push_back(Node());
    }
    if (trie[ind].r == -1) {
        trie[ind].r = trie.size();
        trie.push_back(Node());
    }
    if (trie[ind].push == -1) return;
    int l = trie[ind].l, r = trie[ind].r;
    trie[l].push = (trie[ind].push + 1) % c;
    trie[r].push = (trie[ind].push - 1 + c) % c;
    trie[ind].color = trie[ind].push;
    trie[ind].push = -1;
}

int find(string &s) {
    int ind = 0;
    for (int i = 0; i < s.length(); i++) {
        push(ind);
        if (s[i] == 'L') {
            ind = trie[ind].l;
        } else {
            ind = trie[ind].r;
        }
    }
    push(ind);
    return trie[ind].color;
}

void change(string &s, int col) {
    int ind = 0;
    for (int i = 0; i < s.length(); i++) {
        push(ind);
        if (s[i] == 'L') {
            ind = trie[ind].l;
        } else {
            ind = trie[ind].r;
        }
    }
    trie[ind].push = col;
    push(ind);
}
void solve() {
    int q;
    cin >> q >> c;
    for (int i = 0; i < q; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int col;
            string st;
            cin >> col >> st;
            change(st, col);
        } else {
            string st;
            cin >> st;
            cout << find(st) << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--)
        solve();
    return 0;
}