#include <bits/stdc++.h>

using namespace std;
     
typedef long long ll;
typedef string ss;
 
#define pb push_back
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define pii pair < ll, ll >
#define all(a) a.begin(), a.end()

const int N = 1e5 + 5, INF = int(1e9), mod = 998244353, base = 1, block = 300;

const ll BIG = ll(1e18);

int n, a[N], id[N];

ll sum, p[N], t[4 * N];

void build(int v, int lx, int rx){
	if(lx == rx){
		t[v] = a[lx];
		return;
	}
	int m = (lx + rx) / 2;
	build(2 * v, lx, m);
	build(2 * v + 1, m + 1, rx);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}

ll get(int l, int r, int v, int lx, int rx){
	if(l > rx or r < lx) return INF;
	if(l <= lx and rx <= r) return t[v];
	int m = (lx + rx) / 2;
	return min(get(l, r, 2 * v, lx, m), get(l, r, 2 * v + 1, m + 1, rx));
}

int main(){
	speed;
	cin >> n;
	for(int i = 1; i <= n; i++){
		cin >> a[i];
		sum += a[i];
		p[i] = p[i - 1] + a[i];
	}
	ll need = (sum + 1) / 2;
	for(int i = 1; i <= n; i++){
		int l = i, r = n, pos = -1;
		while(l <= r){
			int mid = (l + r) / 2;
			if(p[mid] - p[i - 1] >= need){
				r = mid - 1;
				pos = mid;
			}
			else{
				l = mid + 1;
			}
		}
		id[i] = pos;
	}
	build(1, 1, n);
	int ans = n;
	for(int i = 1; i <= n; i++){
		if(id[i] != -1){
			ans = min(ans, id[i] - i + 1);
			//cout << p[id[i]] - p[i - 1] - get(i, id[i], 1, 1, n) << " ";
			if(p[id[i]] - p[i - 1] - get(i, id[i], 1, 1, n) >= need) ans = min(ans, id[i] - i);
		}
	}
	cout << ans;
}
