#include <bits/stdc++.h>

using namespace std;
     
typedef long long ll;
typedef string ss;
 
#define pb push_back
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define pii pair < ll, ll >
#define all(a) a.begin(), a.end()

const int N = 2e6 + 5, INF = int(1e9), mod = 998244353, base = 1, block = 300;

const ll BIG = ll(1e18);

int n, sz = 1, go[30][N], cnt[30 * N];


void add(string s){
	int v = 1;
	int m = (int)s.size();
	for(int i = 0; i < m; i++){
		int c = s[i] - 'a';
		if(!go[c][v]){
			go[c][v] = ++sz;
		}
		v = go[c][v];
		cnt[v]++;
	}
}

bool bad = 0;

void dfs(int v, int h, int x){
	if(h == x){
		if(cnt[v] & 1){
//			cout << v << ' ' << cnt[v] << endl;
			bad = 1;
		}
		return;
	}
	for(int i = 0; i < 26; i++){
		if(go[i][v]){
			dfs(go[i][v], h + 1, x);
		}
	}
}


bool check(int x){
	bad = 0;
	dfs(1, 0, x);
	return 1 - bad;
}

int main(){
	speed;
	cin >> n;
	int sz = 0;
	for(int i = 1; i <= n;i++){
		ss s;
		cin >> s;
		sz = (int)s.size();
		add(s);
	}
	int l = 0, r = sz, ans = 0;
	while(l <= r){
		int mid = (l + r) / 2;
		if(check(mid)){
			l = mid + 1;
			ans = mid;
		}
		else{
			r = mid - 1;
		}
	}
	cout << ans;
}

