#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <random>

using namespace std;

const int N = 5003, mod = 998244353;
const long long inf = 1e18;

int n;
long long dp[N][N], mn[N][N];


void solve()
{
    for (int i = 0; i < N; i++)
    {
        fill(dp[i], dp[i] + N, inf);
        fill(mn[i], mn[i] + N, inf);
    }
    cin >> n;
    mn[0][0] = dp[0][0] = 0;
    for (int i = 1; i <= n; i++)
    {
        //cout << 'e';
        for (int j = 1; j <= i; j++)
        {
            dp[i][j] = j * (j - 1) / 2 + mn[i - j][min(j - 1, i - j)];
            mn[i][j] = min(dp[i][j], mn[i][j - 1]);
        }
    }
    cout << mn[n][n];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}