#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

using namespace std;

ld f(ld x1, ld y1, ld x2, ld y2)
{
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

ld dist(ld x1, ld y1, ld x2, ld y2, ld xk, ld yk)
{
    ld l = f(xk, yk, x1, y1);
    ld r = f(xk, yk, x2, y2);
    for(int i = 0; i < 100; i++)
    {
        if(l <= r)
        {
            x2 = (x1 + x2) / 2;
            y2 = (y1 + y2) / 2;
            r = f(x2, y2, xk, yk);
        }
        else
        {
            x1 = (x1 + x2) / 2;
            y1 = (y1 + y2) / 2;
            l = f(x1, y1, xk, yk);
        }
    }
    return l;
}

bool is(ld d, vector<int>& c)
{
    if(f(c[0], c[1], c[2], c[3]) >= d) return 1;
    return 0;
}

bool ha(vector<int>& a, vector<int>& b)
{
    ld x1 = a[0], y1 = a[1], x2 = a[2], y2 = a[3], x3 = b[0], y3 = b[1], x4 = b[2], y4 = b[3];
    ld b1 = ((x2 - x1) ? y1 - x1 * (y2 - y1) / (x2 - x1) : -1),
       b2 = ((x4 - x3) ? y3 - x3 * (y4 - y3) / (x4 - x3) : -1),
         k1 = ((x2 - x1) ? (y2 - y1) / (x2 - x1) : -1),
         k2 = ((x4 - x3) ? (y4 - y3) / (x4 - x3) : -1);
    if(b2 - b1 == 0) return 1;
    else if(k1 - k2)
    {
        int l = x1, r = x2;
        if(x3 >= l) l = x3;
        if(x4 <= r) r = x4;
        ld x = (b2 - b1) / (k1 - k2);
        if(l <= x && x <= r) return 1;
    }
    return 0;
}

void solve() {
    int n; cin >> n;
    vector<vector<ld>> dp(n, vector<ld>(n));
    vector<vector<int>> v(n, vector<int>(4));
    for(int i = 0; i < n; i++) for(int j = 0; j < 4; j++) cin >> v[i][j];
    ll ans = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = i + 1; j < n; j++)
        {
            dp[i][j] = dp[j][i] = min(min(dist(v[i][0], v[i][1], v[i][2], v[i][3], v[j][0], v[j][1]),dist(v[i][0], v[i][1], v[i][2], v[i][3], v[j][2], v[j][3])),
                                      min(dist(v[j][0], v[j][1], v[j][2], v[j][3], v[i][0], v[i][1]),dist(v[j][0], v[j][1], v[j][2], v[j][3], v[i][2], v[i][3])));
        }
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = i + 1; j < n; j++)
        {
            for(int k = j + 1; k < n; k++)
            {
                bool hatvox = (ha(v[i], v[j]) || ha(v[i], v[k]) || ha(v[j], v[k]));

                ans += (is(dp[i][j], v[k]) || is(dp[i][k], v[j]) || is(dp[j][k], v[i]) || hatvox);
            }
        }
    }
    cout << ans << endl;
}

int  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    //int t; cin >> t; while (t--)
        solve();
    return 0;
}
