#include <bits/stdc++.h>
#define int long long
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e9 + 7;
const int P = 131;

int c, t = 1;
map<int, pair<int, int>> m;

int makeHash(string &s) {
    int n = s.size();
    vector<int> h(n + 1, 0);
    int a = 0;
    for (int i = 0; i < n; ++i) {
        a = a * P + s[i];
        a %= INF;
    }
    return a;
}

void solve() {
    int type;
    cin >> type;
    if (type == 1) {
        int cc;
        cin >> cc;
        string s;
        cin >> s;
        int h = makeHash(s);
        m[h] = {cc, t};
        t++;
    }
    else {
        string s;
        cin >> s;
        int n = s.length();
        int ans = -1, anst = 0;
        bool sw = 0;
        int hs = 0;
        for(int i = 0; i < n; i++){
            hs = hs * P + s[i];
            hs = hs % INF;
            if(m[hs].second > anst){
                sw += 1;
                ans = m[hs].first;
                anst = m[hs].second;
;           }
            else if(sw == 1){
                if(s[i] == 'R'){
                    ans = (ans - 1 + c) % c;
                }
                else{
                    ans = (ans + 1) % c;
                }
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int test = 1;
    cin >> test >> c;
    while (test--)
        solve();
    return 0;
}
