#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
 
void io(){
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.precision(5);
}
 
vector<int> z_function(vector<int> s){
   int n = s.size();
   vector<int> z(n,0);
   int l = 0 , r = 0;
   for(int i = 1; i < n; i++){
      if (i <= r) z[i] = min(z[i-l] , r-i+1);
      while(z[i]+i < n && s[z[i]] == s[z[i]+i]) z[i]++;
      if (z[i]+i-1 > r) r = z[i]+i-1 , l = i;
   }
   z[0] = n;
   return z;
}
 
 
int solve(){
   string s1, s2;
   cin >> s1 >> s2;
   
   int maxx = 0 , ind = 0;
   while(s1[maxx] == s2[maxx]) maxx++;
   return maxx;
}
 
int main() {
   io();
   int t;
   cin >> t;
   int minn = 1e9;
   while(t) {
      int maxx = solve();
      minn = min(minn , maxx);
      t-=2;
   }
   cout << minn;
    return 0;
}