#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define pf push_front
#define F first
#define S second
#define ll long long // TL/ML
#define ull unsigned long long
#define all(x) x.begin(), x.end() 
#define pii pair<int, int>
#define unm unordered_map
#define pll pair<ll, ll>
#define speed ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)
#define rand mt19937 rng(chrono::steady_clock::now().time_since_epoch().count())
#define file freopen("a.txt", "r", stdin), freopen("A.txt", "w", stdout);
#define mem(x) memset(x, 0, sizeof(x))
const int N = (int) 1e5 + 100;
ll a[N];
pair<ll, ll> tree[N * 4];
int n;

void build(int v = 1, int l = 1, int r = n){
	if(l == r){
		tree[v].F = a[l];
		tree[v].S = a[l];
	}
	else{
		int m = (l + r) / 2;
		build(v * 2, l, m), build(v * 2 + 1, m + 1, r);
		tree[v].F = tree[v * 2].F + tree[v * 2 + 1].F;
		tree[v].S = min(tree[v * 2].S, tree[v * 2 + 1].S);
	}
}

pair<ll, ll> get(int l, int r, int v = 1, int tl = 1, int tr = n){
	if(r < tl || tr < l){
		return {0, INT_MAX};
	}
	if(l <= tl && tr <= r){
		return tree[v];
	}
	int m = (tl + tr) / 2;
	pair<ll, ll> f = get(l, r, v * 2, tl, m), s = get(l, r, v * 2 + 1, m + 1, tr);
	return {f.F + s.F, min(f.S, s.S)};
}

void solve(){
	cin >> n;
	ll s = 0;
	for(int i = 1; i <= n; i++){
		cin >> a[i];
		s += a[i];
	}
	build();
	ll M = (s + 1) / 2, ans = INT_MAX;
	for(int i = 1; i <= n; i++){
		int l = i - 1, r = n + 1;
		while(r - l > 1){
			int m = (l + r) / 2;
			pair<ll, ll> x = get(i, m);
			if(x.F >= M){
				r = m;
				ll k = (r - i + 1);
				ans = min(ans, k);
				if(x.F - x.S >= M){
					ans = min(ans, k - 1);
				}
			}
			else{
				l = m;
			}
		}
	}
	cout << ans;
} 
signed main(){
   speed;
   int t = 1;
   //cin >> t;
   while(t--){
      solve();
   }
}