#include<bits/stdc++.h>

#define nl "\n"
#define ll long long
#define sz(x) (int)(x).size()
#define pb push_back

using namespace std;

const int N = (int)2e5 + 7;
const ll MOD = (ll)998244353;

int n;
vector<vector<int> > h; 
string s[N];

unordered_map<int, int> cnt;

int mult(int x, int y) {
	return 1ll * x * y % MOD;
}

bool may(int k) {
	cnt.clear();
	for(int i = 1; i <= n; ++i) {
		cnt[h[i - 1][k - 1]]++;
	}	
	for(auto [x, y] : cnt) {
		if(y & 1) return 0;
	}
	return 1;
}

int main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        vector<int> o;
    	cin >> s[i];

    	int cur = 0;
    	for(int j = 0; j < sz(s[i]); ++j) {
    		cur = mult(cur, 31) + (s[i][j] - 'a' + 1);
    		cur %= MOD;
    		o.pb(cur);	
    	}
    	h.pb(o);
    }
    
    int l = 1, r = sz(s[1]), res = 0;
    while(l <= r) {
    	int mid = (l + r) >> 1;
    	if(may(mid)) {
    		res = mid;
    		l = mid + 1;
    	} else
    		r = mid - 1;
    }
	cout << res << nl;
	return 0;
}