recursion_db ={}

def isPowerOfTwo(x):
    return (x & (x - 1)) == 0

def findClosestPowerOfTwo(x):
    if x == 0:
        return 0
    if isPowerOfTwo(x):
        return x
    else:
        l = 2 ** (x.bit_length() - 1)
        r = 2 ** (x.bit_length())
        if abs(x - l) < abs(x - r):
            return l
        else:
            return r

def answer(x):
    if recursion_db.get(x):
        return recursion_db[x]
    else:
        if x == 0:
            return 0
        if x > 0:
            recursion_db[x] = answer(x - findClosestPowerOfTwo(x)) + 1
            return recursion_db[x]
        else:
            recursion_db[x] = answer(x + findClosestPowerOfTwo(x)) + 1
            return recursion_db[x]

t = int(input())
for i in range(t):
    x = abs(int(input()))
    print(answer(x))
    