db ={}
powdb = {}
n = int(input())
def isPowerOfTwo(x):
    return (x & (x - 1)) == 0
def findClosestPowerOfTwo(x):
    if powdb.get(x) is not None:
        return powdb[x]
    if x == 0:
        return 0
    if isPowerOfTwo(x):
        return x
    else:
        l = 2 ** (x.bit_length() - 1)
        r = 2 ** (x.bit_length())
        if abs(x - l) < abs(x - r):
            powdb[x] = l
        else:
            powdb[x] = r
        return powdb[x]

def number_of_steps(x):
    if db.get(x) is not None:
        return db[x]
    if x == 0:
        return 0
    elif x == 1:
        return 1
    elif x & (x - 1) == 0:
        return 1
    else:
        db[x] =1 + number_of_steps(abs(x - findClosestPowerOfTwo(x)))
        return db[x]

for i in range(n):
    x = abs(int(input()))
    print(number_of_steps(x))
