#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int n, m;
    cin >> n >> m;
    --n; --m;
    {
        vector<int> months = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
        for (int i = 0; i < 12; ++i) {
            int dd = n - 14;
            int prevm = months[(i - 1 + 12) % 12];
            if (dd < 0) {
                dd += prevm;
            }
            if (dd == m) {
                int cur = dd + 7;
                if (cur >= prevm) {
                    cur -= prevm;
                }
                cout << cur + 1 << "\n";
                return;
            }
        }
    }
    {
        vector<int> months = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
        for (int i = 0; i < 12; ++i) {
            int dd = n - 14;
            int prevm = months[(i - 1 + 12) % 12];
            if (dd < 0) {
                dd += prevm;
            }
            if (dd == m) {
                int cur = dd + 7;
                if (cur >= prevm) {
                    cur -= prevm;
                }
                cout << cur + 1 << "\n";
                return;
            }
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
