#include <bits/stdc++.h>

using namespace std;

#define int int64_t

const int MOD = 1'000'000'000'003;

int add(int a, int b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

int mul(int a, int b) {
    return (int) (((int64_t) a * b) % MOD);
}

int32_t main() {
    int q, c;
    cin >> q >> c;

    map<int, pair<int, int>> mp;

    int time = 0;

    while (q--) {
        time++;
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;

            int v = 0;
            for (auto it : s) {
                v = mul(v, 2);
                if (it == 'L') {
                    v = add(v, 1);
                } else {
                    v = add(v, 2);
                }
            }
            mp[v] = {time, x};
        } else {
            string s;
            cin >> s;

            pair<int, int> ans = {0, -1};

            int v = 0, l = 0, r = 0;
            for (auto it : s) {
                if (mp.find(v) != mp.end()) {
                    if (mp[v] > ans) {
                        ans = mp[v];
                        l = r = 0;
                    }
                }
                v = mul(v, 2);
                if (it == 'L') {
                    l++;
                    v = add(v, 1);
                } else {
                    r++;
                    v = add(v, 2);
                }
            }
            if (mp.find(v) != mp.end()) {
                if (mp[v] > ans) {
                    ans = mp[v];
                    l = r = 0;
                }
            }
            if (ans.first == 0) {
                cout << "-1\n";
                continue;
            }
            cout << (((ans.second + l - r) % c) + c) % c << "\n";
        }
    }
}