#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define dbg(a) cout << #a << " = " << a << "\n"
#define dbg1(a) cout << #a << " = [ "; for (auto& _ : a) cout << _ << " "; cout << "]\n"
#define dbg2(a) cout << #a << " = [ "; for (auto& _ : a) cout << "(" << _.first << " " << _.second << ") "; cout << "]\n"
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)

using ll = long long;
using ld = long double;
const double Pi = 3.14159265;


const int INF = 2e9;
const ll INFll = 2e18;
const double EPS = 1e-8;

mt19937 rnd(2282282274);


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;
    for (int _ = 0; _ < (int)1e5; _++) {
        shuffle(all(p), rnd);
        vector<bool> good(n - 2);
        int cnt = 0;
        for (int i = 0; i < n - 2; i++) {
            good[i] = a[p[i]] * b[p[i + 1]] + a[p[i + 1]] * b[p[i + 2]] + a[p[i + 2]] * b[p[i]] >=
                      a[p[i + 2]] * b[p[i + 1]] + a[p[i + 1]] * b[p[i]] + a[p[i]] * b[p[i + 2]];
            cnt += !good[i];
        }
        if (cnt & 1) continue;
        for (int i = 0; i < n - 3; i++) {
            if ((!good[i] && good[i + 1]) || (!good[i] && !good[i + 1])) {
                good[i] = !good[i];
                good[i + 1] = !good[i + 1];
                swap(p[i + 1], p[i + 2]);
            }
        }
        bool ok = true;
        for (int i = 0; i < n - 2; i++) {
            ok &= (a[p[i]] * b[p[i + 1]] + a[p[i + 1]] * b[p[i + 2]] + a[p[i + 2]] * b[p[i]] >=
                  a[p[i + 2]] * b[p[i + 1]] + a[p[i + 1]] * b[p[i]] + a[p[i]] * b[p[i + 2]]);
        }
        if (ok) {
            for (auto &i: p) cout << i + 1 << ' ';
            return;
        }
    }
    assert(0);
}

signed main() {
    fastIo(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}