/*#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC target ("avx2")*/

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
  
#define fix fixed<<setprecision
#define forn(i, n) for(int i = 1; i <= (n); ++i)
#define all(v) v.begin(),v.end()
#define sz(s) (int) (s).size()
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define ss second
#define ff first

using namespace std;
using namespace __gnu_pbds;
using pii = pair<int,int>;
using pll = pair<long long, long long>;
using ll = long long;
using ull = unsigned long long;
 
 
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int N = 1e5+100;
int n, ans = INT_MAX;
ll p[N], a[N], t[N*5];

void build(int v = 1, int tl = 1, int tr = n){
	if(tl == tr){
		t[v] = a[tl];
		return;
	}
	int tm = tl + tr >> 1;
	build(v+v, tl, tm);
	build(v+v+1, tm+1, tr);
	t[v] = min(t[v+v], t[v+v+1]);
}

ll get(int l, int r, int v = 1, int tl = 1, int tr = n){
	if(tl > r || tr < l) return LLONG_MAX;
	if(tl >= l && tr <= r) return t[v];
	int tm = tl + tr >> 1;
	ll s1 = get(l, r, v+v, tl, tm);
	ll s2 = get(l, r, v+v+1, tm+1, tr);
	return min(s1, s2);
}


int main(){
	//freopen("outofplace.in", "r", stdin);
	//freopen("outofplace.out", "w", stdout);
	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
	cin >> n;
	for(int i = 1; i <= n; ++i){
		cin >> a[i];
		p[i] = p[i-1] + a[i];
	}
	build();
	for(int k = 1; k <= n; ++k){
		int l = k, r = n, pos = -1;
		while(l <= r){
			int mid = l + r >> 1;
			if(p[mid] - p[k-1] >= p[n] / 2) pos = mid, r = mid - 1;
			else l = mid + 1;
		}
		if(pos == -1) continue;
		ans = min(ans, pos-k+1);
		ll x = get(k, pos);
		if(p[pos] - p[k-1] - x >= p[n] / 2) ans = min(ans, pos-k);
	}
	cout << ans << '\n';
}
