﻿#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <stack>
#include <deque>
using namespace std;
using ll = long long;
const ll LONGINF = 1e18 + 7;
const int INF = 1e9 + 7;
int non_col = -1;
ll c;
deque<char>way;
struct item
{
    item* l, * r;
    bool pushed;
    int col;
    item() { col = non_col; l = r = nullptr; pushed = true; }
};
void push(item*& root)
{
    if (root->col == non_col)return;
    root->l->col = (root->col + 1) % c;
    root->l->pushed = false;
    root->r->col = (root->col - 1 + c) % c;
    root->r->pushed = false;
}
ll check(item*& root)
{
    if (root->l == nullptr)root->l = new item();
    if (root->r == nullptr)root->r = new item();
    if (root->pushed == false) { push(root); root->pushed = true; }
    if (way.empty())return root->col;
    char c = way.front();
    way.pop_front();
    if (c == 'L')return check(root->l);
    else return check(root->r);
}
void paint(item*& root, int cl)
{
    if (root->l == nullptr)root->l = new item();
    if (root->r == nullptr)root->r = new item();
    if (root->pushed == false) { push(root); root->pushed = true; }
    if (way.empty()) { root->col = cl; root->pushed = false; return; }
    char c = way.front();
    way.pop_front();
    if (c == 'L')return paint(root->l, cl);
    else return paint(root->r, cl);
}
ll g(int n)
{
    return n * (n - 1) / 2;
}

void solve()
{
    int q;
    cin >> q >> c;
    item* root = new item();
    while (q--)
    {
        int type;
        cin >> type;
        if (type == 1)
        {
            int cl; string s;
            cin >> cl >> s;
            for (auto k : s)way.push_back(k);
            paint(root, cl);
        }
        else
        {
            string s;
            cin >> s;
            for (auto k : s)way.push_back(k);
            cout << check(root) << "\n";
        }
    }
}
int main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
//confirmed by association of the best code