﻿#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <stack>
#include <deque>
using namespace std;
using ll = long long;
const ll LONGINF = 1e18 + 7;
const int INF = 1e9 + 7;

ll bin_pow(ll n, int p)
{
	if (p == 0)return 1;
	if (p % 2 == 0)
	{
		ll a = bin_pow(n, p / 2);
		return a * a;
	}
	return n * bin_pow(n, p - 1);
}

ll f(ll n)
{
	int len = to_string(n).size();
	ll ans = 0;
	for (int i = 1; i < len; i++)
	{
		ans += bin_pow(10, i-1)*9*i;
	}
	ans += 1;
	ans += (n - bin_pow(10, len - 1) + 1) * len;
	return ans;
}

void solve() 
{
	ll n;
	cin >> n;
	ll ans = 0, start, end;
	for (ll a = 0; a <= 30000; a++)
	{
		//cout << 1;
		int len = to_string(a).size();
		ll l = a, r = 1e18 + 1;
		while (r - l > 1)
		{
			ll mid = (r + l) / 2;
			if (f(mid)-f(a)+len >= n)
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}
		if (r >= a && f(r) - f(a) + len == n && r - a + 1 > ans)
		{
			//cout << f(a) << ' ' << f(r) << '\n';
			ans = r - a + 1; start = a; end = r;
			cout << ans << '\n' << start << ' ' << end << '\n';
			break;
		}
	}
}
int main()
{
	int t = 1;
	//cin >> t;
	while (t--) solve();
}
//confirmed by association of the best code