﻿#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <stack>
#include <deque>
using namespace std;
using ll = long long;
const ll LONGINF = 1e18 + 7;
const int INF = 1e9 + 7;
void solve() {
    int n;
    cin >> n;
    vector<int>ans(n + 1), used(n + 2);
    bool last = false;
    int curmin = 1, curmax = n + 1;
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        if (c == 'A') {
            if (i == 0) {
                ans[0] = 1;
                ans[1] = n + 1;
                used[1] = 1;
                used[n + 1] = 1;
                curmin = 2;
                curmax = n;
                last = true;
                continue;
            }
            if (last) {
                if (!ans[i - 1]) {
                    ans[i] = curmax;
                    ans[i+1] = curmin;
                    used[curmin] = 1;
                    used[curmax] = 1;
                    ++curmin; --curmax;
                }
                else {
                    ans[i+1] = curmin;
                    used[curmin] = 1;
                    ++curmin;
                }
                last = false;
            }
            else if (!last) {
                if (!ans[i - 1]) {
                    ans[i + 1] = curmax;
                    ans[i] = curmin;
                    used[curmin] = 1;
                    used[curmax] = 1;
                    ++curmin; --curmax;
                }
                else {
                    ans[i + 1] = curmax;
                    used[curmax] = 1;
                    --curmax;
                }
                last = true;
            }
        }
    }
    int c = 1;
    while (c <= n+1 and used[c]) ++c;
    for (int i = 0; i < n + 1; ++i) {
        if (!ans[i]) {
            ans[i] = c;
            ++c;
        }
    }
    for (int i : ans) cout << i << ' ';
}
int main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
//confirmed by association of the best code