#ifndef _DEBUG
#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

using namespace std;

typedef long long ll;
typedef long double ld;

constexpr int INF = 2e9 + 3;

int getmin(vector<vector<int>> &st, int l, int r) {
    int lo = log2(r - l);
    return min(st[lo][l], st[lo][r - (1 << lo)]);
}

void solve()
{
    int n;
    cin >> n;
    vector<ll> a(n), pref(n + 1);
    for (auto &i : a)
        cin >> i;
    vector<vector<int>> st(20, vector<int>(n));
    for (int i = 0; i < n; ++i){
        st[0][i] = a[i];
    }
    for (int i = 1; i < 20; ++i) {
        for (int j = 0; j + (1 << (i-1)) < n; ++j) {
            st[i][j] = min(st[i - 1][j], st[i-1][j + (1 << (i-1))]);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        pref[i + 1] = pref[i] + a[i];
    }
    vector<pair<int,int>> b;
    for (int i = 0; i < n; ++i)
    {
        int l = i, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if ((pref[mid + 1] - pref[i]) * 2 < pref[n]) {
                l = mid;
            }
            else r = mid;
        }
        if (r < n)
            b.push_back({r - i, i});
    }
    sort(all(b));
    for (auto [len, l] : b) {
        int r = l + len;
        if ((pref[r] - pref[l] - getmin(st, l, r)) * 2 >= pref[n]) {
            cout << len - 1;
            return;
        }
    }
    cout << b[0].first;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int _ = 1;
    // cin >> _;
    while (_--)
        solve();
}