#include "bits/stdc++.h"
using namespace std;

#define ar array
typedef long long ll;
#define int ll

const int M = 1e5;

signed main(){
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int s; cin >> s;
	int pw[63];
	pw[0] = 1;
	for(int i=1;i<63;i++) pw[i] = pw[i-1] * 10;
	int L = -1, R = -1;
	
	auto get = [&](int x){
		if(x < 10) return max(0ll, x + 1);
		int k = 0, tmp = x;
		while(tmp) tmp /= 10, k++;
		return pw[k - 1] + (x - pw[k - 1] + 1) * k;
	};
	
	auto sum = [&](int l, int r){
		//~ cout<<l<<" "<<r<<" "<<get(r)<<" "<<get(l - 1)<<"\n";
		return get(r) - get(l - 1);
	};
	
	while(L == -1 || sum(L, R) > s){
		L++;
		int l = 0, r = 1e18 - R;
		while(l < r){
			int m = (l + r) >> 1;
			if(sum(L, R + m) >= s) r = m;
			else l = m + 1;
		}
		
		R += l;
	}
	
	if(sum(L, R) == s) cout<<R - L + 1<<"\n"<<L<<" "<<R<<"\n";
	else cout<<-1<<"\n";
}
