#include <bits/stdc++.h>

#define int long long   
#define pii pair <int, int>                                                                         	
#define pb push_back
#define all(data) data.begin(), data.end();
#define c cout << "OK\n";

using namespace std;

const int N = 1e5 + 5;
const int inf = 1e18;

int n, t[4 * N], p[N], a[N];

void build(int v, int l, int r) {
    if(l == r) {
        t[v] = a[l];
        return;
    }
    int md = (l + r) / 2;
    build(v * 2, l, md);
    build(v * 2 + 1, md + 1, r);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int l, int r, int tl, int tr) {
    if(tl <= l && r <= tr) return t[v];
    if(r < tl || tr < l) return inf;
    int md = (l + r) / 2;
    return min(get(v * 2, l, md, tl, tr),
               get(v * 2 + 1, md + 1, r, tl, tr));
}

// to infinity and beyond
signed main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
        p[i] = p[i - 1] + a[i];
    }
    build(1, 1, n);
    int x = (p[n] + 1) / 2, ans = inf;
    for(int l = 1; l <= n; l++) {
        if(a[l] >= x) {
            ans = 1;
            break;
        }
        int tl = l, tr = n;
        while(tl < tr) {
            int md = (tl + tr) / 2;
            if(p[md] - p[l - 1] >= x) tr = md;
            else tl = md + 1;
        }
        if(p[tr] - p[l - 1] >= x) ans = min(ans, tr - l + 1);
        tl = l; tr = n;
        while(tl < tr) {
            int md = (tl + tr) / 2;
            if(p[md] - p[l - 1] - get(1, 1, n, l, md) >= x) tr = md;
            else tl = md + 1;
        }
        if(p[tr] - p[l - 1] - get(1, 1, n, l, tr) >= x) ans = min(ans, tr - l);
    }
    cout << ans;
}












