#include<bits/stdc++.h>
#define int long long
#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define vec vector
#define all(x) x.begin(), x.end()
#define For(i, n) for(int i = 0; i < (n); i++)
#define FoR(i, j, n) for(int i = j; i < (n); i++)
#define sz(x) (int)(x).size()
#define INF 1e18
#define fi first
#define se second

using namespace std;
using ld = long double;

ld const pi = acos(-1);
ld const eps = 1e-12;

struct S{
    int x, y;
};

int cp(S p, S p1, S p2){
    int a1 = p1.x - p.x, b1 = p1.y - p.y;
    int a2 = p2.x - p.x, b2 = p2.y - p.y;
    return a1 * b2 - a2 * b1;
}

int skol(S p, S p1, S p2){
    int a1 = p1.x - p.x, b1 = p1.y - p.y;
    int a2 = p2.x - p.x, b2 = p2.y - p.y;
    return a1 * b1 + a2 * b2;
}

ld angl(int a1, int b1, int a2, int b2){
    ld an = abs(atan2(b1, a1) - atan2(b2, a2));
    return min(an, 2 * pi - an);
}

ld dist(S p1, S p2){
    return sqrtl((ld)(p1.x - p2.x) * (p1.x - p2.x) + (ld)(p1.y - p2.y) * (p1.y - p2.y));
}

ld p_dist(S p, S p1, S p2){
    ld ans = min(dist(p, p1), dist(p, p2));
    //cout << "BEB " << p.x << ' ' << p.y << "  " << p1.x << ' ' << p1.y << ' ' << p2.x << ' ' << p2.y << "   " << skol(p2, p1, p) << ' ' <<skol(p1, p2, p) << endl;
    if(2.0 * angl(p1.x - p2.x, p1.y - p2.y, p.x - p2.x, p.y - p2.y) - pi <= eps  and 2.0 * angl(p2.x - p1.x, p2.y - p1.y, p.x - p1.x, p.y - p1.y) - pi <= eps){
        return min(ans, (ld)abs(cp(p, p1, p2))/(ld)dist(p1, p2));
    }
    return ans;
}

ld seg_dist(S p1, S p2, S p3, S p4){
    return min(min(p_dist(p1, p3, p4), p_dist(p2, p3, p4)), min(p_dist(p3, p1, p2), p_dist(p4, p1, p2)));
}

bool is_per(S p1, S p2, S p3, S p4){
    int a1 = p1.y - p2.y, b1 = p2.x - p1.x, c1 = (-a1 * p1.x - b1 * p1.y);
    int a2 = p3.y - p4.y, b2 = p4.x - p3.x, c2 = (-a2 * p3.x - b2 * p3.y);
    ld x, y;
    if(a1 != 0){///    ?
        y = ((ld)c1 * a2 - (ld)c2 * a1)/(ld)((ld)b2 * a1 - (ld)b1 * a2);
        x = ((ld)-b1 * y - (ld)c1)/(ld)a1;
    }
    else{
        x = ((ld)b2 * c1 - (ld)c2 * b1)/(ld)((ld)a2 * b1 - (ld)b2 * a1);
        y = ((ld)-a1 * x - (ld)c1)/(ld)b1;
    }
    return ((((ld)min(p1.x, p2.x) <= x + eps and x <= (ld)max(p1.x, p2.x) + eps) and ((ld)min(p1.y, p2.y) <= y + eps and y <= (ld)max(p1.y, p2.y) + eps)) and
            (((ld)min(p3.x, p4.x) <= x + eps and x <= (ld)max(p3.x, p4.x) + eps) and ((ld)min(p3.y, p4.y) <= y + eps and y <= (ld)max(p3.y, p4.y) + eps)));
}

bool can_this(pair <S, S> s1, pair <S, S> s2, pair <S, S> s3){
    //cout << s1.fi.x << ' ' << s1.fi.y << "  " << s1.se.x << ' ' << s1.se.y << "  ";
    //cout << s2.fi.x << ' ' << s2.fi.y << "  " << s2.se.x << ' ' << s2.se.y << "  ";
    //cout << is_per(s1.fi, s1.se, s2.fi, s2.se) << ' ' << seg_dist(s1.fi, s1.se, s2.fi, s2.se) << ' ' << dist(s3.fi, s3.se) << endl;
    if(is_per(s1.fi, s1.se, s2.fi, s2.se)){
        return 1;
    }
    else{
        return (seg_dist(s1.fi, s1.se, s2.fi, s2.se) <= dist(s3.fi, s3.se));
    }
}

bool can(pair <S, S> s1, pair <S, S> s2, pair <S, S> s3){
    return (can_this(s1, s2, s3) or can_this(s1, s3, s2) or can_this(s2, s3, s1));
}

signed main()
{
    ibase;
    int n, ans = 0;
    cin >> n;
    vector <pair <S, S> > v(n);
    for(int i = 0; i < n; ++i){
        cin >> v[i].fi.x >> v[i].fi.y >> v[i].se.x >> v[i].se.y;
    }
    for(int i = 0; i < n; ++i){
        for(int j = i + 1; j < n; ++j){
            for(int k = j + 1; k < n; ++k){
                //cout << "  " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                if(can(v[i], v[j], v[k])){
                    ++ans;
                }
            }
        }
    }
    cout << ans;
}



