#include <bits/stdc++.h>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define vi vector<int>
#define forn(i, s, n) for(int i = s; i < n; ++i)
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
 
const int N = 2e5;
const int MOD = 1e9 + 7;
const int INF = 1e9;
typedef long long ll;

ll pows[65]; 
ll dp[N +5];

int bin_cnt(ll n) {
	int cnt = 0;
	while(n) {
		cnt += n % 2;
		n /= 2;
	}
	return cnt;
}

ll rec(ll n, ll cur) {
	ll dst = n - cur;
	int dir = 1;
	if(dst < 0) {
		dir = -1;
		dst *= -1;
	}
	if(dst == 0) {
		return 0;
	}
	int lower, higher;
	for(int i = 1; i < 63; ++i) {
		if (pows[i] >= dst) {
			lower = i - 1;
			higher = i;
			break;
		}
	}
	if(pows[lower] == dst || pows[higher] == dst) {
		return 1;
	}
	ll dst_lower = abs(cur + dir * pows[lower] - n);
	ll dst_higher = abs(cur + dir * pows[higher] - n);
	int x = bin_cnt(dst_lower);
	int y = bin_cnt(dst_higher);
	if(x < y) {
		return rec(n, cur + dir * pows[lower]) + 1;
	}
	else if(y < x){
		return rec(n, cur + dir * pows[higher]) + 1;
	}
	else if(dst_lower < dst_higher) {
		return rec(n, cur + dir * pows[lower]) + 1;
	}
	else {
		return rec(n, cur + dir * pows[higher]) + 1;
	}
}

int main() {
	fast_io;
	#ifdef LOCAL_PROJECT
	freopen("main.in", "r", stdin);
	#endif
	
	pows[0] = 1;
	for(int i = 1; i < 63; ++i) {
		pows[i] = pows[i - 1] * 2;
	}
	int t;
	cin >> t;
	while(t--) {
		ll n;
		cin >> n;
		cout << rec(n, 0) << endl;
	}
}
