#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <string>
#include <bitset>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <fstream>

using namespace std;

const int N = 1e5 + 1;

int t[4 * N], n, a[N];
long long pref[N];

void build (int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = a[tl];
		return;
	}
	int mid = (tl + tr) >> 1;
	build (v + v, tl, mid), build (v + v + 1, mid + 1, tr);
	t[v] = min (t[v + v], t[v + v + 1]);
	return;
}

int get (int v, int tl, int tr, int l, int r) {
	if (l <= tl && tr <= r) return t[v];
	if (tr < l || r < tl) return 1000000000;
	int mid = (tl + tr) >> 1;
	return min (get (v + v, tl, mid, l, r), get (v + v + 1, mid + 1, tr, l, r));
}

int main () {
	ios_base::sync_with_stdio(0),cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++ i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	build (1, 1, n);
	int res = n / 2 + (n % 2);
	for (int i = 1; i <= n; ++ i) {
		int l = i, r = n, ans = -1;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if ((pref[mid] - pref[i - 1]) * 2 >= pref[n]) {
				ans = mid;
				r = mid - 1;
			} else l = mid + 1;
		}
		if (ans == -1) continue;
	//	cout << i << ' ' << ans << '\n';
		if ((pref[ans] - pref[i - 1] - get (1, 1, n, i, ans)) * 2 >= pref[n]) {
			res = min (res, ans - i);
		} else res = min (res, ans - i + 1);
	}
	cout << res;
	return 0;	
}


