#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<string> a(n);
    for (auto& s : a)
        cin >> s;

    auto f = [&](int k) {
        map<string, int> count;

        for (auto& s : a) {
            string prefix;
            for (int i = 0; i < k; i++)
                prefix += s[i];

            count[prefix] += 1;
        }

        for (auto& [k, v] : count) {
            if (v % 2 != 0) {
                return false;
            }
        }

        return true;
    };

    int m, l = 0, r = (int)a[0].length() + 1;
    while (r - l > 1) {
        m = (l + r) / 2;

        if (f(m)) {
            l = m;
        } else {
            r = m;
        }
    }

    cout << l << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}