#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define last(a) (a.end() - 1)

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
ostream& operator<<(ostream& os, vector<T> &a) {
	for (auto &i: a) {
		os << i << " ";
	}
	return os;
}

template<class T>
ostream& operator<<(ostream& os, vector<vector<T>> &a) {
	for (auto &i: a) {
		os << i << "\n";
	}
	return os;
}

template<class X, class Y>
ostream& operator<<(ostream& os, pair<X, Y> &a) {
	os << a.first << " " << a.second;
	return os;
}

// #define FILEI "input.txt"
// #define FILEO "output.txt"

int main() {
	#ifdef FILEI
		freopen(FILEI, "r", stdin);
	#else
		ios::sync_with_stdio(false);
		cin.tie(0);
	#endif
	#ifdef FILEO
		freopen(FILEO, "w", stdout);
	#else
		cout.tie(0);
	#endif

	int n, m;
	cin >> n >> m;

	if (n > 7) {
		cout << n - 7 << "\n";
		return 0;
	}
	cout << m + 7;
	return 0;
}