#include <bits/stdc++.h>

using namespace std;

#define int long long

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto x : v) {
        out << x << ' ';
    }
    return out;
}

const long long INF = 1e18;

bool ifpow2(int x) {
    return (x >= 1 && !(x & (x - 1)));
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int x;
        cin >> x;

        x = abs(x);

        if (x == 0) {
            cout << 0 << '\n';
        } else if (ifpow2(x)) {
            cout << 1 << '\n';
        } else {
            bool flag = false;
            int c = 1;
            for (int i = 0; i < 64; i++, c *= 2) {
                if (ifpow2(x + c) || ifpow2(abs(x - c))) {
                    flag = true;
                    break;
                }
            }

            if (flag)
                cout << 2 << '\n';
            else
                cout << 3 << '\n';
        }
    }
    return 0;
}
