#include <bits/stdc++.h>

using namespace std;

// clang-format off
#define int long long
#define eb emplace_back
#define ef emplace_front
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vi vector <int>
#define sz(a) (int)(a).size()
typedef long long ll;
typedef long double ld;
template<typename TYPE> using ve = vector<TYPE>;
// clang-format on

struct node {
    node *l = nullptr, *r = nullptr;
    int col = -1;
    int t = -10;
    explicit node(int x, int tt) {
        col = x;
        t = tt;
    }
};

void color(node *&nroot, string &s, int idx, int x, int c, int t) {
    if (idx == sz(s)) {
        nroot->col = x;
        nroot->t = t;
        return;
    }
    if (s[idx] == 'L') {
        if (nroot->l) {
            color(nroot->l, s, idx + 1, x, c, t);
        } else {
            node *res;
            res = new node(-1, -20);
            nroot->l = res;
            color(nroot->l, s, idx + 1, x, c, t);
        }

    } else {
        if (nroot->r) {
            color(nroot->r, s, idx + 1, x, c, t);
        } else {
            node *res;
            res = new node(-1, -1);
            nroot->r = res;
            color(nroot->r, s, idx + 1, x, c, t);
        }
    }
}

int get(node *&root, string &s, int idx, int c) {
    if (idx == sz(s)) {
        return root->col;
    }
    if (s[idx] == 'L') {
        if (!root->l) {
            node *res;
            if (root->col != -1) {
                res = new node((root->col + 1) % c, root->t);
            } else {
                res = new node(-1, -1);
            }
            root->l = res;
        }
        if (root->col != -1 and root->t > root->l->t) {
            root->l->col = (root->col + 1) % c;
            root->l->t = root->t;
        }
        return get(root->l, s, idx + 1, c);
    } else {
        if (!root->r) {
            node *res;
            if (root->col != -1) {
                res = new node((root->col - 1 + c) % c, root->t);
            } else {
                res = new node(-1, -1);
            }
            root->r = res;
        }
        if (root->col != -1 and root->t > root->r->t) {
            root->r->col = (root->col - 1 + c) % c;
            root->r->t = root->t;
        }
        return get(root->r, s, idx + 1, c);
    }
}

void solve() {
    int q, c;
    cin >> q >> c;
    node *root = new node(-1, -1);
    for (int i = 0; i < q; i++){
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            color(root, s, 0, x, c, i);
        } else {
            string s;
            cin >> s;
            if (s.empty()) {
                cout << root->col << "\n";
            } else {
                cout << get(root, s, 0, c) << "\n";
            }
        }
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //    cin >> t;
    while (t--) solve();
    return 0;
}