#include <iostream>
#include <vector>
#include <string>

int in_vector(const std::vector <int>& positions, int position) 
{
	for (int i : positions)
		if (position == i)
			return 1;

	return 0;
}

int main() 
{
	int n; std::cin >> n;
	std::vector <std::string> words;
	std::vector <int> positions;
	
	std::string temp;
	for (int i = 0; i < n; i++) 
	{
		std::cin >> temp;
		words.push_back(temp);
	}

	int word_size = words[0].size(), k = 2000001;
	for (int i = 0; i < n - 1; i++) 
		if (!in_vector(positions, i)) {
			int current_k = 0;
			int k_pos = 0;

			for (int j = i + 1; j < n; j++)
			{
				int t = 0;
				if (!in_vector(positions, j))
				{
					while (words[i][t] == words[j][t] && t < word_size)
						t++;

					if (t > current_k) {
						current_k = t;
						k_pos = j;
					}
				}
			}
			positions.push_back(k_pos);

			if (k > current_k)
				k = current_k;
		}

	std::cout << k;
	return 0;
}		