#include <bits/stdc++.h>
using namespace std;
struct Node {
    int l, r, time, color;
    bool is_term;
    Node() : l(-1), r(-1), time(-1), color(-1), is_term(false) {}
};
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q, c, t, x, v;
    string s;
    cin >> q >> c;
    vector <Node> tree(1);
    for (int p = 0; p < q; p++) {
        cin >> t;
        if (t == 1) {
            cin >> x;
            cin >> s;
            v = 0;
            for (auto e: s) {
                if (e == 'L') {
                    if (tree[v].l == -1) {
                        tree[v].l = int(tree.size());
                        tree.emplace_back();
                    }
                    v = tree[v].l;
                }
                else {
                    if (tree[v].r == -1) {
                        tree[v].r = int(tree.size());
                        tree.emplace_back();
                    }
                    v = tree[v].r;
                }
            }
            tree[v].is_term = true;
            tree[v].time = p;
            tree[v].color = x;
            continue;
        }
        cin >> s;
        int cur_color = 0, cur_time = -1;
        v = 0;
        for (auto e: s) {
            if (e == 'L') {
                cur_color = (cur_color + 1) % c;
                if (tree[v].l == -1) {
                    tree[v].l = int(tree.size());
                    tree.emplace_back();
                }
                v = tree[v].l;
            }
            else {
                cur_color = (cur_color + c - 1) % c;
                if (tree[v].r == -1) {
                    tree[v].r = int(tree.size());
                    tree.emplace_back();
                }
                v = tree[v].r;
            }
            if (tree[v].is_term) {
                if (tree[v].time > cur_time) {
                    cur_color = tree[v].color;
                    cur_time = tree[v].time;
                }
            }
        }
        if (cur_time == -1) cout << -1 << "\n";
        else cout << cur_color << "\n";
    }
    return 0;
}