#include <bits/stdc++.h>

using namespace std;
vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    tree[v] = min(tree[2 * v], tree[2 * v + 1]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (r <= ql || qr <= l) {
        return 1e9 + 100;
    }
    int m = (l + r) / 2;
    return min(get(2 * v, l, m, ql, qr), get(2 * v + 1, m, r, ql, qr));
}

int main() {
    int n;
    cin >> n;
    tree.resize(4 * n);
    long long sum = 0;
    vector<int> pref(n + 1, 0);
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        pref[i + 1] = pref[i] + arr[i];
        sum += arr[i];
    }
    build(1, 0, n);
    long long f = (sum + 1) / 2;
    int minimum = 1e9 + 100;
    for (int i = 0; i < n; i++) {
        int l = -1;
        int r = n - i;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int sum1 = pref[i + m] - pref[i];
            if (sum1 >= f) {
                r = m;
            } else {
                l = m;
            }
        }
        int summer = pref[i + r] - pref[i];
        if (summer < f) {
            continue;
        }
        int min_otr = get(1, 0, n, i, i + r);
        if (summer - min_otr >= f) {
            if (r - 1 < minimum) {
                minimum = r - 1;
            }
        } else {
            minimum = min(r, minimum);
        }
    }
    cout << minimum;
    return 0;
}
