#include <bits/stdc++.h>

using namespace std;

long long my_pow(int x, int y){
    if(x == 0){
        return 1;
    }
    long long u = my_pow(x/2, y);
    u = u * u;
    if(x % 2 == 1) u *= y;
    return u;
}

vector<long long> tob(long long x) {
    vector<long long> ans;
    while (x != 0) {
        ans.push_back(x % 2);
        x /= 2;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long t;
    cin >> t;
    for (int zxc = 0; zxc < t; zxc++) {
        long long x;
        cin >> x;
        if (x < 0) {
            x = -x;
        }
        long long k = log2(x), count_1 = 0, count_2 = 1;
        long long b = my_pow(k + 1, 2);
        vector<long long> ans_1 = tob(x);
        vector<long long> ans_bx = tob(b - x);
        for(auto u: ans_1){
            count_1 += u;
        }
        for(auto u: ans_bx){
            count_2 += u;
        }
        cout << min(count_1, count_2) << "\n";
    }
    return 0;
}