#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define f first
#define s second
#define all(x) (x.begin(), x.end())

using ll = long long;

const int oo = 1e9;
const ll OO = 1e18;
int q, c;

struct Trie
{
    int color;
    bool lazy;
    Trie *l;
    Trie *r;

    Trie()
    {
        color = -1;
        lazy = 0;
        l = nullptr;
        r = nullptr;
    }

    void push()
    {
        if (l == nullptr) l = new Trie();
        if (r == nullptr) r = new Trie();
        if (!lazy) return;
        l->color = (color + 1) % c;
        r->color = (color - 1 + c) % c;
        l->lazy = 1;
        r->lazy = 1;
        lazy = 0;
    }
};

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> q >> c;
    Trie *root = new Trie();
    while (q--)
    {
        int type;
        cin >> type;
        if (type == 1)
        {
            int x;
            cin >> x;
            string s;
            cin >> s;
            Trie *cur = root;
            for (int i = 0; i < sz(s); i++)
            {
                cur->push();
                if (s[i] == 'L')
                {
                    if (cur->l == nullptr) cur->l = new Trie();
                    cur = cur->l;
                }
                else
                {
                    if (cur->r == nullptr) cur->r = new Trie();
                    cur = cur->r;
                }
            }
            cur->color = x;
            cur->lazy = 1;
        }
        else
        {
            string s;
            cin >> s;
            Trie *cur = root;
            for (int i = 0; i < sz(s); i++)
            {
                cur->push();
                if (s[i] == 'L') cur = cur->l;
                else cur = cur->r;
            }
            cout << cur->color << "\n";
        }
    }
    return 0;
}
