#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template <typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int MOD[2] = {int(1e9) + 7, int(1e9) + 9};
const int P[2] = {227, 229};

int q, c;
gp_hash_table<ll, pii> what;

ll getHash(const string& s) {
    pii h = {0, 0};
    fr (i, 0, sz(s) - 1) {
        h.fi = 1LL * h.fi * P[0] + (s[i] == 'L' ? 1 : 2);
        h.se = 1LL * h.se * P[1] + (s[i] == 'L' ? 1 : 2);
        h.fi %= MOD[0];
        h.se %= MOD[1];
    }
    return 1LL * h.fi * 2e9 + h.se;
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> q >> c;

    fr (i, 1, q) {
        int t;
        cin >> t;

        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;

            ll h = getHash(s);
            what[h] = {i, x};
        }
        if (t == 2) {
            string s;
            cin >> s;

            int mx = -1e9;
            int mnC = -1;
            int pos = -1;

            pii h = {0, 0};
            fr (i, 0, sz(s) - 1) {
                h.fi = 1LL * h.fi * P[0] + (s[i] == 'L' ? 1 : 2);
                h.se = 1LL * h.se * P[1] + (s[i] == 'L' ? 1 : 2);
                h.fi %= MOD[0];
                h.se %= MOD[1];

                ll val = 1LL * h.fi * 2e9 + h.se;

                if (what.find(val) != what.end()) {
                    pii got = what[val];
                    if (umx(mx, got.fi)) {
                        mnC = got.se;
                        pos = i;
                    }
                }
            }

            if (mx == -1e9) {
                cout << "-1\n";
                continue;
            }

            int cur = mnC;
            fr (i, pos + 1, sz(s) - 1) {
                if (s[i] == 'L') {
                    cur = (cur + 1) % c;
                } else {
                    cur = (cur - 1 + c) % c;
                }
            }
            cout << cur << "\n";
        }
    }

    return 0;
}
