#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pll pair <ll, ll>
#define pii pair <int, int>

#define sqr(x) (x) * (x)
#define pw(x) (1LL << x)

#define all(s) s.begin(), s.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mxN = 2e5 + 3;
const ld pi = acos(-1);


const int N = 1e5 + 5;
long long pref[N], a[N];
int n;
long long calc(int l, int r) {
    return (pref[r] - pref[l - 1]);
}
//long long Min(int l, int r) {
//    long long mn = 1e18;
//    for (int i = l; i <= r; i++) {
//        mn = min(mn, a[i]);
//    }
//    return mn;
//}
long long t[N * 4];
void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v] = min(t[v << 1], t[v << 1 | 1]);
}
long long Min(int v, int tl, int tr, int l, int r) {
    if (l > r) return inf;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) >> 1;
    return min(
        Min(v << 1, tl, tm, l, min(r, tm)),
        Min(v << 1 | 1, tm + 1, tr, max(l, tm + 1), r)
    );
}
long long Min(int l, int r) {
    return Min(1, 1, n, l, r);
}
void solve() {
    cin >> n;
    long long sum = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
        sum += a[i];
    }
    build(1, 1, n);
    sum = (sum / 2) + (sum % 2);

    int ans = n;
    for (int i = 1; i <= n; i++) {
        int l = 0, r = n - i;
        while (r - l > 13) {
            int mid = (l + r) / 2;
            if (sum + Min(i, i + mid) <= calc(i, i + mid)) r = mid;
            else l = mid + 1;
        }
        for (int j = 0; j <= r; j++) {
            if (calc(i, i + j) - Min(i, i + j) >= sum) {
                ans = min(ans, (i + j) - i);
            }
        }
//        if (calc(i, i + l) - Min(i, i + l) >= sum) {
//            ans = min(ans, (i + l) - i);
//        }
        l = 0, r = n - i;
        while (r - l > 13) {
            int mid = (l + r) / 2;
            if (sum <= calc(i, i + mid)) r = mid;
            else l = mid + 1;
        }
        for (int j = 0; j <= r; j++) {
            if (calc(i, i + j) >= sum) {
                ans = min(ans, (i + j) - i + 1);
            }
        }
//        if (calc(i, i + l) >= sum) {
//            ans = min(ans, (i + l) - i + 1);
//        }
    }
    cout << ans << "\n";
}

int main() {

#ifdef local
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // local

    solve();


    return 0;
}
