

#include <bits/stdc++.h>
using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};


long long add(long long a, long long b) {
    return (a + b) % 1000000007;
}

long long mul(long long a, long long b) {
    return (a * b) % 1000000007;
}

void solve() {
    int n;
    cin >> n;
    vector<string> s(n);
    vector<vector<long long>> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        h[i].resize(s[i].size() + 1);
        h[i][0] = 0;
        long long pow = 1;
        for (int j = 0; j < (int)s[i].size(); ++j) {
            h[i][j + 1] = add(h[i][j], mul((s[i][j] - 'a' + 1), pow));
            pow = mul(pow, 37);
        }
    }
    int l = 0, r = s[0].size() + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        map<int, int> mp;
        for (int i = 0; i < n; ++i)
            mp[h[i][m]]++;
        bool ok = 0;
        for (auto z : mp)
            ok |= z.second & 1;
        if (ok) r = m;
        else l = m;
    }
    cout << l;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}


/*

#include <bits/stdc++.h>

using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int get(char c) {
return c == 'L';}

struct trie {
    struct node {
        int to[2];
        int terminal;
        node(): terminal(-1) {
            to[0] = to[1] = -1;
        }
    };

    vector<node> tr;

    pair<int, int> process(string val) {
        int c = 0;
        for (int i = 0; i < val.size(); ++i) {
            if(tr[c].to[get(val[i])] == -1) {
                tr[c].to[get(val[i])] = tr.size();
                tr.emplace_back();


            }
        }
    }

};

void solve() {
    long long x;
    cin >> x;
    x = abs(x);
    long long ans1 = __builtin_popcountll(x);
    long long ll = 0;

    for (long long i = 0; i < 64; i++)
        if (x & (1ll << i))
            ll = i;

    cout << min(ans1, __builtin_popcountll((1ll << (ll+1ll)) - x) + 1ll);
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

*/

/*

#include <bits/stdc++.h>

using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};


void solve() {

}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

*/

