#include <bits/stdc++.h>
   
using namespace std;

#define int long long
#define ff first
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 200001;

int t[N * 4], n, tmin[4 * N];

void update(int i, int x, int tl = 1, int tr = n, int idx = 1) {
	if(tr <= tl) {
		t[idx] = x;
	} else {
		int tm = (tl + tr) / 2;
		if(i <= tm) {
			update(i, x, tl, tm, idx << 1);
		} else {
			update(i, x, tm + 1, tr, idx << 1 | 1);
		}
		t[idx] = t[idx << 1] + t[idx << 1 | 1];
	}
}

int sum(int l, int r, int tl = 1, int tr = n, int idx = 1) {
	if(tl > r || tr < l)
		return 0;
	if(tr <= r && tl >= l) {
		return t[idx];
	}
	int tm = (tl + tr) / 2;
	return sum(l, r, tl, tm, idx << 1) + sum(l, r, tm + 1, tr, idx << 1 | 1);
}

void update2(int i, int x, int tl = 1, int tr = n, int idx = 1) {
	if(tr <= tl) {
		tmin[idx] = x;
	} else {
		int tm = (tl + tr) / 2;
		if(i <= tm) {
			update2(i, x, tl, tm, idx << 1);
		} else {
			update2(i, x, tm + 1, tr, idx << 1 | 1);
		}
		tmin[idx] = min(tmin[idx << 1], tmin[idx << 1 | 1]);
	}
}

int getmin(int l, int r, int tl = 1, int tr = n, int idx = 1) {
	if(tl > r || tr < l) {
		return 1e9;
	}
	if(tr <= r && tl >= l) {
		return tmin[idx];
	}
	int tm = (tl + tr) / 2;
	return min(getmin(l, r, tl, tm, idx << 1), getmin(l, r, tm + 1, tr, idx << 1 | 1));
}

signed main(){
    ios::sync_with_stdio(0); cin.tie(0);
    int res = 1e9;
    cin >> n;
    vector<int> a(N);
    for(int i = 1; i <= n; i++) {
    	cin >> a[i];
    	update(i, a[i]);
    }
    int cur = (accumulate(a.begin() + 1, a.end() + 1, 0ll) + 1) / 2;
    for(int i = 1; i <= n; i++) {
    	for(int j = 1; j <= i; j++) {
    		if(sum(i, j) >= cur) {
    			if(sum(i, j) - getmin(i, j) >= cur) {
    				res = min(res, j - i);
    			}
    			res = min(res, j - i + 1);
    		}
    		if(sum(1, i) >= cur) {
    			if(sum(1, i) - getmin(1, i) >= 1) {
    				res = min(res, i - 1);
    			}
    			res = min(res, i);
    		}
    		if(sum(i, n) >= cur) {
    			if(sum(i, n) - getmin(i, n) >= cur) {
    				res = min(res, n - i - 1);
    			}
    			res = min(res, n - i);
    		}
    	}
    }
    cout << res + 1;
    return 0;
}