#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>
#define ll long long
using namespace std;
vector <string> a;
ll n;

bool check(ll mid) {
	vector<string>sp;
	for (ll i = 0; i < n; i++) {
		sp.push_back(a[i].substr(0, mid));
	}
	map <string, ll> url;

	for (ll i = 0; i < n; i++) {
		url[sp[i]]++;
	}

	for (ll i = 0; i < n; i++) {
		if (url[sp[i]] % 2 != 0) {
			return 0;
		}
	}

	return 1;
}


void solution() {
	cin >> n;
	for (ll i = 0; i < n; i++) {
		string c;
		cin >> c;
		a.push_back(c);
	}

	ll l = 0, r = a[0].size(), mid;
	ll ans = 0;
	while (l <= r) {
		mid = (l + r) / 2;
		if (check(mid)) {
			l = mid + 1;
			ans = mid;
		}
		else {
			r = mid - 1;
		}
	}

	cout << ans;
}


int main() {
	solution();
}
