#pragma GCC optimize("Ofast,O3,unroll-loops")
#include <bits/stdc++.h>
#include <x86intrin.h>
#include <ext/pb_ds/assoc_container.hpp>
#define bp __builtin_popcountll
#define mp make_pair
#define pb push_back
#define vec vector
#define ll long long
#define F first
#define S second
#define pii pair <int, int>
#define elif else if
#define sz(a) int32_t(a.size())
#define all(a) a.begin(), a.end()
#define fl fflush(stdout)
#define endl "\n"
#define ex exit(0)
#define int ll
using namespace std;
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const int N = 1e5 + 10;
const int INF = 1e18;
int t[4 * N], ar[N], sum[N], n;

void build(int v, int tl, int tr){
    if(tl == tr){
        t[v] = ar[tl]; return;
    }
    int mid = (tl + tr) / 2;
    build(v + v, tl, mid);
    build(v + v + 1, mid + 1, tr);
    t[v] = min(t[v + v], t[v + v + 1]);
}

int get(int v, int tl, int tr, int l, int r){
    if(tl > r || tr < l) return INF;
    if(tl >= l && tr <= r) return t[v];
    int mid = (tl + tr) / 2;
    return min(get(v + v, tl, mid, l, r), get(v + v + 1, mid + 1, tr, l, r));
}

void solve(){
    cin >> n;
    for(int i = 1; i <= n; ++i) cin >> ar[i];
    build(1, 1, n);

    for(int i = 1; i <= n; ++i){
        sum[i] = sum[i - 1] + ar[i];
    }

    int ans = INF;
    for(int i = 1; i <= n; ++i){
        int l = 1, r = i, res = -INF;
        while(l <= r){
            int mid = (l + r) / 2;
            if(sum[i] - sum[mid - 1] >= sum[n] / 2){ l = mid + 1, res = mid; }
            else r = mid - 1;
        }
        ans = min(ans, i - res + 1);

        l = 1, r = i, res = -INF;
        while(l <= r){
            int mid = (l + r) / 2;
            int x = get(1, 1, n, mid, i);
            if(sum[i] - sum[mid - 1] - x >= n / 2){ l = mid + 1; res = mid; }
            else r = mid - 1;
        }
        ans = min(ans, i - res + 1);
    }
    cout << ans;


}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t; t = 1;
    while(t--) solve();
}
