#include <bits/stdc++.h>

#define int long long

using namespace std;

const int N = 1e5 + 1337;
int a[N], tree[N * 4];

void build_tree(int v, int l, int r) {
    if (l == r) {
        tree[v] = a[l];
    } else {
        int m = (l + r) / 2;
        build_tree(v * 2 + 1, l, m);
        build_tree(v * 2 + 2, m + 1, r);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }
}

int get_mn (int v, int l, int r, int ql, int qr) {
    if (ql > r || qr < l) {
        return 1e12;
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return (min(get_mn(v * 2 + 1, l, m, ql, qr), get_mn(v * 2 + 2, m + 1, r, ql, qr)));
}

int32_t main() {
    int n;
    cin >> n;
    int need = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        need += a[i];
    }
    build_tree(0, 0, n - 1);
    need = (need + 1) / 2;
    int sum = 0, r = 0, ans = 1e16;
    for (int l = 0; l < n; ++l) {
        while (r < n && sum < need)
            sum += a[r++];

//        cout << l << " " << r << " " << sum << " ";
        if (sum < need)
            continue;
        ans = min(ans, r - l);
        int mn = get_mn(0, 0, n - 1, l, r - 1);
//        cout << mn << "\n";
        if (sum - mn >= need && r - l != 1)
            ans = min(ans, r - l - 1);
        sum -= a[l];
    }
    cout << ans;
}

