﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;
int inf = 1e9 + 7;

struct seg_tree {
    int sz;
    vi a, tree;

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) tree[v] = a[tl];
        else {
            int tm = (tl + tr) / 2;

            build(2 * v + 0, tl, tm);
            build(2 * v + 1, tm, tr);

            tree[v] = min(tree[2 * v], tree[2 * v + 1]);
        }
    }

    seg_tree(vi &s) {
        a = s;
        sz = a.size();
        tree.resize(4 * sz);
        build(1, 0, sz);
    }

    int get_min(int v, int tl, int tr, int l, int r) {
        if (l <= tl && r >= tr) return tree[v];
        if (l >= tr || r <= tl) return inf;

        int tm = (tl + tr) / 2;

        int m1 = get_min(2 * v + 0, tl, tm, l, r);
        int m2 = get_min(2 * v + 1, tm, tr, l, r);

        return min(m1, m2);
    }

    int get_min(int l, int r) {
        return get_min(1, 0, sz, l, r);
    }

};

//int sum(ll a, ll b) {
//    if (b == 0) {
//        return a;
//    }
//    if (b < 0) {
//        return sum(a - 1, b + 1);
//    } else {
//        return sum(a + 1, b - 1);
//    }
//}
//
//ll findpow(ll n) {
//    int l = 0, r = 63;
//    while (r - l > 1) {
//        int m = (l + r) / 2;
//        if ((ll) (1ll << m) > n) {
//            r = m;
//        } else {
//            l = m;
//        }
//    }
//    return (ll) (1ll << r);
//}
//
//int getans(ll n) {
//    int ans = 0;
//    while (n) {
//        ans += n % 2;
//        n /= 2;
//    }
//    return ans;
//}

int n, m;
vvi mat, mat1;
pi mag, a;

void fill_true() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (abs(i - mag.first) < abs(j - mag.second)) {
                if (j > mag.second)mat1[i][j] = mat[i][j] == 7;
                if (j < mag.second)mat1[i][j] = mat[i][j] == 3;
            }
            if (abs(i - mag.first) > abs(j - mag.second)) {
                if (i > mag.first)mat1[i][j] = mat[i][j] == 1;
                if (i < mag.first)mat1[i][j] = mat[i][j] == 5;
            }
            if (i + j == mag.first + mag.second) {
                if (i > mag.first)mat1[i][j] = mat[i][j] == 2;
                if (i < mag.first)mat1[i][j] = mat[i][j] == 6;
            }
            if (i - j == mag.first - mag.second) {
                if (i > mag.first)mat1[i][j] = mat[i][j] == 8;
                if (i < mag.first)mat1[i][j] = mat[i][j] == 4;
            }
            if (i == mag.first && j == mag.second)mat1[i][j] = 1;
        }
    }
}

void find_a() {
    a = mag;
    for (int i = 0; i < n; ++i) {
        bool f = 1;
        for (int j = 0; j < m; ++j) {
            if (mat1[i][j] == 1)f = 0;
        }
        if (f)a.first = i;
    }
    for (int j = 0; j < m; ++j) {
        bool f = 1;
        for (int i = 0; i < n; ++i) {
            if (mat1[i][j] == 1)f = 0;
        }
        if (f)a.second = j;
    }
}

bool check() {
//    cout << a.first << " " << a.second << "\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i != a.first && j != a.second && mat1[i][j] == 0){
//                cout << "!1\n";
                return 0;
            }
            if (((i == a.first) || (j == a.second)) && mat1[i][j] == 1) {
                if (i != mag.first || j != mag.second){
//                    cout << "!2\n";
                    return 0;
                }
            }
        }
    }
    return 1;
}

int recurs(int x, int pos, int get, deque<int>&a) {
    if (x == 0){
        if (get == 4){
            for (int i : a){
                cout << i << " ";
            }
            cout << endl;
        }
        return get;
    }
    if (pos == 12) {
        return 1e9;
    }
    a.push_back(- (1 << pos));
    int f = recurs(x - (1 << pos), pos + 1, get + 1, a);
    a.pop_back();
    a.push_back(  (1 << pos));
    int s = recurs(x + (1 << pos), pos + 1, get + 1, a);
    a.pop_back();
    int t = recurs(x, pos + 1, get, a);
}


int right(int x) {
    deque<int> a;
    return recurs(x, 0, 0, a);
}

//
int our(ll x) {
    if (x == 0) {
        return 0;
    }
//    if (x == 3) {
//        int y = 1;
//    }
    x = abs(x);
    int flag = 0;
    int c = 0;
    int ans = 0;
    for (int i = 0; i < 64; ++i) {
        if ((x >> i) & 1) {
            if (flag) {
                c++;
            } else {
                flag = 1;
                c = 1;
            }
        } else {
            if (flag)
                ans += 1 + (c > 1);
            flag = 0;
        }
    }
    return ans;
}


signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
//    right(155);
//    int y;
//    cin >> y;
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cin >> n >> m;
    int g, p;
    int f = 0;
//    vvi mat(n, vi(m));
    mat.assign(n, vi(m));
    mat1.assign(n, vi(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> mat[i][j];
            if (mat[i][j] == 4 || mat[i][j] == 8) {
                g = i - j;
                f |= 1;
            }
            if (mat[i][j] == 2 || mat[i][j] == 6) {
                p = i + j;
                f |= 2;
            }
        }
    }
    // two directions
    if (f == 3) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i - j == g && i + j == p) {
                    mag = {i, j};
                    a = {i, j};
                    break;
                }
            }
        }
        fill_true();
        find_a();
    }
    // one direction
    else {
        if (n != m) {
            // only g
            if (f == 1) {
                if (g == 0)mag = {0, 0};
                else mag = {n - 1, m - 1};
            }
            // only p
            if (f == 2) {
                if (p == m - 1)mag = {0, m - 1};
                else mag = {n - 1, 0};
            }
            fill_true();
            find_a();
        }
            // КВАДРАТ
        else {
            if (f == 1) {
                mag = {0, 0};
                fill_true();
                find_a();
                if (!check()) {
                    mag = {n - 1, m - 1};
                    fill_true();
                    find_a();
                }
            }
            if (f == 2) {
                mag = {0, m - 1};
                fill_true();
                find_a();
                if (!check()) {
                    mag = {n - 1, 0};
                    fill_true();
                    find_a();
                }
            }
        }

    }
    cout << mag.first + 1 << " " << mag.second + 1 << "\n";
    cout << a.first + 1 << " " << a.second + 1 << "\n";
//    for (int i = 0; i < 1024; ++i){
//        ll c = (1ll << ((int) log2(i)) + 1);
//        if (right(i) != min(our(i), our(c - i) + 1)){
//            cout << i << endl;
//            cout << right(i) << " " << min(our(i), our(c - i) + 1)<< endl;
//        }
//    }
//    int t;
//    cin >> t;
//    while (t--) {
//        ll x;
//        cin >> x;
//        ll c = (1ll << ((int) log2(x)) + 1);
//        cout << min(our(x), our(c - x)) << '\n';
//    }
//        cin >> x;
//        if (x == 0) {
//            cout << 0 << '\n';
//            continue;
//        } else if (x == -7) {
//            int y = 1;
//        }
//        x = abs(x);
//        vector<int> sp;
//        vector<ll> o;
//        ll m = 0;
//        for (int i = 0; i < 64; ++i) {
//            m += (1 << i) * ((x >> i) & 1);
//            o.push_back(m);
//        }
//        for (int i = 0; i <= 63; ++i) { if ((x >> i) & 1) sp.push_back(i); }
//        vector<int> huy(sp.size(), 1e9);
//        huy[0] = 1;
//        for (int i = 1; i < huy.size(); ++i) {
//            huy[i] = min(huy[i], huy[i - 1] + 1);
//            huy[i] = min(huy[i], i + 1);
//            ll d = (1 << (sp[i] + 1)) - o[sp[i]];
//            int c = 0;
//            for (int j = 0; j < 64; ++j) {
//                c += (d >> j) & 1;
//            }
//            huy[i] = min(huy[i], c + 1);
//        }
//        cout << huy[sp.size() - 1] << '\n';
//    }
    }


//#pragma clang diagnostic pop