﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;
int inf = 1e9 + 7;


struct Node {
    Node() {
    }

    int c = -1;
    int t = -1;
    Node *left = nullptr;
    Node *right = nullptr;
};


Node *add(string &s, Node *v, int pos = 0) {
    if (pos == s.size()) {
//        if (!v) cout << 100;
        return v;
    }
    if (s[pos] == 'L') {
        if (!v->left) {
            v->left = new Node();
        }
        add(s, v->left, pos + 1);
    } else {
        if (!v->right) {
            v->right = new Node();
        }
        add(s, v->right, pos + 1);
    }
}

int C;

int color(string &s, Node *v, int c = -1, int t = -1, int pos = 0) {
    if (pos == s.size()) {
        return c;
    }
    if (v->t > t) {
        t = v->t;
        c = v->c;
    }
    if (s[pos] == 'L') {
        int pop = (c + 1) % C;
        if (t == -1) pop = -1;
        return color(s, v->left, pop, t, pos + 1);
    } else {
        int pop = (c - 1 + C) % C;
        if (t == -1) pop = -1;
        return color(s, v->right, pop, t, pos + 1);
    }
}


signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
//    right(155);
//    int y;
//    cin >> y;
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    Node *v = new Node();
    int q;
    cin >> q >> C;
    int T = 0;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            auto y = add(s, v, 0);
            y->c = x;
            y->t = ++T;
        } else {
            string s;
            cin >> s;
            add(s, v);
            cout << color(s, v) << '\n';
        }
    }
}


//#pragma clang diagnostic pop






