﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;
int inf = 1e9 + 7;

struct seg_tree {
    int sz;
    vi a, tree;

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) tree[v] = a[tl];
        else {
            int tm = (tl + tr) / 2;

            build(2 * v + 0, tl, tm);
            build(2 * v + 1, tm, tr);

            tree[v] = min(tree[2 * v], tree[2 * v + 1]);
        }
    }

    seg_tree(vi &s) {
        a = s;
        sz = a.size();
        tree.resize(4 * sz);
        build(1, 0, sz);
    }

    int get_min(int v, int tl, int tr, int l, int r) {
        if (l <= tl && r >= tr) return tree[v];
        if (l >= tr || r <= tl) return inf;

        int tm = (tl + tr) / 2;

        int m1 = get_min(2 * v + 0, tl, tm, l, r);
        int m2 = get_min(2 * v + 1, tm, tr, l, r);

        return min(m1, m2);
    }

    int get_min(int l, int r) {
        return get_min(1, 0, sz, l, r);
    }

};

//int sum(ll a, ll b) {
//    if (b == 0) {
//        return a;
//    }
//    if (b < 0) {
//        return sum(a - 1, b + 1);
//    } else {
//        return sum(a + 1, b - 1);
//    }
//}
//
//ll findpow(ll n) {
//    int l = 0, r = 63;
//    while (r - l > 1) {
//        int m = (l + r) / 2;
//        if ((ll) (1ll << m) > n) {
//            r = m;
//        } else {
//            l = m;
//        }
//    }
//    return (ll) (1ll << r);
//}
//
//int getans(ll n) {
//    int ans = 0;
//    while (n) {
//        ans += n % 2;
//        n /= 2;
//    }
//    return ans;
//}

signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
    int n;  
    cin >> n;
    string s;
    cin >> s;
    vector<int> inds;
    for (int i = 0; i < n; ++i) {
        if (s[i] == 'A') {
            inds.push_back(i);
            if (s[i + 1] == 'B' || i + 1 == n) {
                inds.push_back(i + 1);
            }
        }
    }
    vector<int> ans(n + 1);
    deque<int> all;
    for (int i = 1; i <= inds.size(); ++i) {
        all.push_back(i);
    }
    for (int i = 0; i < inds.size(); ++i) {
        if (i % 2) ans[inds[i]] = all.front(), all.pop_front();
        else ans[inds[i]] = all.back(), all.pop_back();
    }
    int c = inds.size() + 1;
    for (int i = 0; i < ans.size(); ++i) {
        if (!ans[i]) {
            ans[i] = c;
            ++c;
        }
    }
    for (int i : ans) {
        cout << i << " ";
    }
}


//#pragma clang diagnostic pop