// #pragma GCC target("avx2")
// #pragma GCC optimize("O3")
// #include <x86intrin.h>
#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define f first
#define s second

// @author: Vlapos

vector<ll> fact;
bool wasFact = false;

void initfact(ll sz, ll mod = 1e9 + 7)
{
    fact.resize(sz);
    fact[0] = 1;
    for (int i = 1; i < sz; i++)
    {
        fact[i] = (fact[i - 1] * i);
        fact[i] %= mod;
    }
}
string yesno(bool ans, string a = "YES", string b = "NO")
{
    if (ans)
    {
        return a;
    }
    else
    {
        return b;
    }
}
void boost()
{
    ios_base ::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
inline int inInt()
{
    int x;
    // scanf("%d", &x);
    cin >> x;
    return x;
}
inline ll inLL()
{
    ll x;
    // scanf("", &x);
    cin >> x;
    return x;
}
inline char inChar()
{
    char x;
    // scanf("", &x);
    cin >> x;
    return x;
}
inline int toInt(char x)
{
    return (x - '0');
}
int getsz(int x)
{
    int cnt = 0;
    while (x)
        cnt++, x /= 10;
    return cnt;
}
ll binpow(ll val, ll deg, ll mod = 1e9 + 9)
{
    if (!deg)
        return 1 % mod;
    if (deg & 1)
        return binpow(val, deg - 1, mod) * val % mod;
    ll res = binpow(val, deg >> 1, mod);
    return (res * res) % mod;
}
ll invert(ll n, int mod)
{
    return binpow(n, mod - 2, mod);
}
ll getC(int n, int i, int modulo = 1e9 + 9)
{
    if (!wasFact)
    {
        wasFact = true;
        initfact(1e8 + 1000, modulo);
    }
    ll res = fact[n];
    ll div = fact[n - i] * fact[i];
    div %= modulo;
    div = binpow(div, modulo - 2, modulo);
    return (res * div) % modulo;
}

ll gcd(int a, int b)
{
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

ll lca(ll a, ll b)
{
    return (a * b) / gcd(a, b);
}

bool isPrime(ll x)
{
    for (int i = 2; i * i <= x; ++i)
    {
        if (!(x % i))
        {
            return false;
        }
    }
    return true;
}

inline bool get_bit(ll &x, ll &bt) { return (x >> bt) & 1; }
inline void make_one(ll &x, ll &bt) { x |= (1 << bt); }
inline void make_null(ll &x, ll &bt) { x &= (~(1 << bt)); }

const int dx4[4] = {-1, 0, 0, 1};
const int dy4[4] = {0, -1, 1, 0};
const int dx8[8] = {-1, -1, -1, 0, 0, 1, 1, 1};
const int dy8[8] = {-1, -0, 1, -1, 1, -1, 0, 1};

const ll INF = (1e18) + 5;
const int BIG = (1e9) + 5;
const int MAXN = (1e5) + 5;
const ll MOD7 = (1e9) + 7;
const ll MOD9 = (1e9) + 9;

// #define int ll

struct test
{
    void solve()
    {
        int n, m;
        cin >> n;

        if (n % 2 == 0)
        {
            cout << (n * (n - 1)) / 2-(((n * (n - 1)) / 2)/2);
        }
        else
        {
            cout << (n * (n - 1)) / 2-(((n * (n - 1)) )/ 2/2) - 1;
        }
    }
};

main()
{
    boost();
    int q = 1;
    for (int i = 0; i < q; i++)
    {
        test t;
        t.solve();
    }
    return 0;
}
//[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]//
//                                                                                    //
//                                 Coded by DVD-Player                                //
//                                                                                    //
//[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]//