#include <bits/stdc++.h>
#define ll long long
#define int ll
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define in insert
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)x.size()
#define fastIO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
using namespace std;
const int INF = 1e9 + 7;
const int N = 2e5 + 25;

int n, a[N], t[4 * N], pref[N], pmn[N];

void build (int v, int tl, int tr) {
	if (tl == tr) t[v] = a[tl];
	else {
		int tm = (tl + tr) / 2;
		build (v * 2, tl, tm);
		build (v * 2 + 1, tm + 1, tr);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}

int get (int v, int tl, int tr, int l, int r) {
	if (l > r)return INF;
	if (l == tl && r == tr)return t[v];
	int tm = (tl + tr) / 2;
	return min(get (v * 2, tl, tm, l, min(r, tm)), get (v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

bool check(int x) {
	int mx = pref[x];
	for(int i = x + 1; i <= n; i++) {
		mx = max(mx, pref[i] - pref[i - x]);
		if(i == x + 1) mx = max(mx, pref[i] - pref[i - x - 1] - pmn[i]);
		else mx = max(mx, pref[i] - pref[i - x - 1] - get(1, 1, n, i - x, i));
		// cout << x << ": " << get(1, 1, n, i - x, i) << '\n';
	}
	return mx >= (pref[n] / 2);
}

void solve() {
	cin >> n;
	pmn[0] = INF;
	for(int i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
		pmn[i] = min(pmn[i - 1], a[i]);
	}
	build(1, 1, n);
	int l = 1, r = n, ans = n;
	while(l <= r) {
		int mid = (l + r) / 2;
		// cout << "M: " << mid << " " << check(mid) << '\n';
		if(check(mid)) {
			ans = min(ans, mid);
			r = mid - 1;
		}
		else l = mid + 1;
	}
	cout << ans;
}

signed main() {
	// freopen(".in", "r", stdin);
	// freopen(".out", "w", stdout);
	fastIO;
	int TT = 1;
	// cin >> TT;
	while(TT--) {
		solve();
	}
	return 0;
}