#include <iostream> 
#include <math.h> 
using namespace std; 
 
long long int n; 
 
long long bpow (long long a, long long b) { 
  if (b == 0) { 
    return 1ll; 
  } 
  if (b == 1) { 
    return a; 
  } 
  if (b % 2) { 
    return bpow (a, b - 1) * a; 
  } 
  else { 
    long long x = bpow (a, b / 2); 
    return x * x; 
  } 
} 
 
int main() { 
    ios_base::sync_with_stdio(0); 
    cin.tie(0); 
    cout.tie(0); 
    cin >> n; 
    for (long long int i = 1; i <= n; ++i) { 
        long long int cnt = 0; 
        long long int in; 
        cin >> in; 
        while (in != 0) { 
            in = abs(in); 
            long long lg = (log2(in)); 
            if (in - bpow(2, lg) > bpow(2, lg + 1) - in) 
                in -= bpow(2, lg + 1); 
            else 
                in -= bpow(2, lg); 
            ++cnt; 
        } 
        cout << cnt << '\n'; 
    } 
}