#include<iostream>
#include<string>
#include<vector>
#define ll long long
using namespace std;

struct Node {
    int l, r, color;
    Node() { 
        l = -1;
        r = -1;
        color = -1;
    }
};

vector<Node> arr;
int c;

void set(string& str, int x, int i = 0, int t = 0) {
    if (i == str.size()) {
        arr[t].color = x;
        if (arr[t].l != -1) {
            arr[arr[t].l].color = (x + 1) % c;
        }
        else {
            arr[t].l = arr.size();
            arr.emplace_back();
            arr[arr[t].l].color = (x + 1) % c;
        }
        if (arr[t].r != -1) {
            arr[arr[t].r].color = (x + c - 1) % c;
        }
        else {
            arr[t].r = arr.size();
            arr.emplace_back();
            arr[arr[t].r].color = (x + c - 1) % c;
        }
        return;
    }
    if (str[i] == 'L') {
        if (arr[t].l != -1) {
            set(str, x, i + 1, arr[t].l);
        }
        else {
            arr[t].l = arr.size();
            arr.emplace_back();
            set(str, x, i + 1, arr[t].l);
        }
    }
    else {
        if (arr[t].r != -1) {
            set(str, x, i + 1, arr[t].r);
        }
        else {
            arr[t].r = arr.size();
            arr.emplace_back();
            set(str, x, i + 1, arr[t].r);
        }
    }
}

int find(string& str, int i = 0, int t = 0) {
    if (i == str.size()) {
        return arr[t].color;
    }
    if (str[i] == 'L') {
        if (arr[t].l != -1) {
            find(str, i + 1, arr[t].l);
        }
        else {
            arr[t].l = arr.size();
            arr.emplace_back();
            find(str, i + 1, arr[t].l);
        }
    }
    else {
        if (arr[t].r != -1) {
            find(str, i + 1, arr[t].r);
        }
        else {
            arr[t].r = arr.size();
            arr.emplace_back();
            find(str, i + 1, arr[t].r);
        }
    }
}

void solve() {
    int q;
    cin >> q >> c;
    arr.emplace_back();
    for (int i = 0; i < q; ++i) {
        int t;
        string str;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            cin >> str;
            set(str, x);
        }
        else {
            cin >> str;
            cout << find(str) << endl;
        }
    }
}

signed main() {
    ////freopen("vikings.in", "rt", stdin);
    ////freopen("vikings.out", "wt", stdout);
    //ios_base::sync_with_stdio(false);
    ////srand((unsigned int)time(nullptr));
    //cout.setf(ios::fixed);
    //cout.precision(9);
    //cout.tie(nullptr);
    //cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) solve();
    return 0;
}