#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<string> a;

bool chk(int mi) {
	for (int i = 0; i < a.size(); i+=2) {
		if (string(a[i].begin(), a[i].begin() + mi) != string(a[i + 1].begin(), a[i + 1].begin() + mi)) {
			return false;
		}
	}
	return true;
}

int main() {
	int n, m;
	cin >> n;
	string s;
	for (int i = 0; i < n; ++i) {
		cin >> s;
		a.push_back(s);
		m = s.size();
	}
	sort(a.begin(), a.end());
	int l = 0, r = m + 1;
	while (r - l > 1) {
		int mi = (l + r) / 2;
		if (chk(mi)) {
			l = mi;
		}
		else {
			r = mi;
		}
	}
	cout << l;
	return 0;
}