#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

using ll = long long;

ll cbi(ll x) {
	ll c = 0;
	while (x) {
		c += x % 2;
		x /= 2;
	}
	return c;
}

ll f(ll x) {
	ll n = pow(2, ceil(log2(x)));
	if (n == x)
		return 1;
	return min(cbi(x), f(n - x) + 1);
}

int main() {

	ll t;
	cin >> t;
	for (int ti = 0; ti < t; ++ti) {
		ll a;
		cin >> a;
		a = abs(a);
		if (a == 0)
			cout << "0\n";
		else
			cout << f(a) << "\n";
	}

	return 0;
}