#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

using ll = long long;

ll f(ll r) {
	if (r == 0){
		return 1;
	}
    ll b = ceil(log10(r)), x;
    if (b == 1) {
        x = r + 1;
    }
    else {
        x = 10 + (r - ll(pow(10, b - 1)) + 1) * b;
        for (int i = 1; i < b - 1; ++i) {
            x += (i + 1) * 9 * ll(pow(10, i));
        }
    }
    return x;
}

int main() {
	ll s;
	cin >> s;

	ll l = 0, r = 1e18, m;
	while (r - l > 1) {
	    m = (r + l + 1) / 2;
		//cout << m << " " << f(m) << "\n";
		if (f(m) == s) {
			l = m;
			r = m;
			break;
		}
	    if (f(m) > s) {
	        r = m;
	    } else {
	        l = m;
	    }
	}
	if (f(r) == s) {
	    cout << r + 1 << "\n0 " << r;
	} else if (f(l) == s) {
		cout << l + 1 << "\n0 " << l;
	} else {
	    cout << -1;
	}

	return 0;
}