#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7, b = 239;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<string> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    int m = (int) a[0].size();
    vector<vector<int>> hsh(n, vector<int>(m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            hsh[i][j + 1] = (hsh[i][j] * b + a[i][j]) % MOD;
        }
    }
    for (auto v : hsh) {
        for (auto el : v)
            cout << el << " ";
        cout << "\n";
    }
    int l = 0;
    int r = m + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int ind = 0;
        bool flag = true;
        while (ind < n){
            if (hsh[ind][mid] == hsh[ind + 1][mid]) ind += 2;
            else{
                flag = false;
                break;
            }
        }
        if (flag) l = mid;
        else r = mid;
    }
    cout << l;
}
