#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pdd pair<ld, ld>
#define ff first
#define ss second
#define all(v) v.begin(),v.end()

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update> ordset;

#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")

ll INF = 2e18;
const ll mod = 1000000007;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll binpow(ll n, ll m){
    if(m == 0) return 1ll;
    if(m & 1ll) return (n * binpow(n, m - 1ll)) % mod;
    ll b = binpow(n, m / 2ll);
    return (b*b) % mod;
}

void solve(){
    ll x1;
    cin >> x1;
    ull x = (ull)abs(x1);
    if(x == 0){
        cout << 0 << '\n';
        return;
    }
    ull mx = 0;
    while(((ull)(1) << mx) <= x) mx++;
    mx--;
    //cout << mx << '\n';
    int ones = 0, zeroes = 0;
    for(ull i = 0; i <= mx; i++){
        if(x & ((ull)(1) << i)) ones++;
        else zeroes++;
    }
    ll ans = ones;
    //cout << ans << '\n';
    ull newx = ((ull)(1) << (ull)(mx + 1));
    newx -= x;
    mx = 0;
    ones = 0;
    zeroes = 0;
    while(((ull)(1) << (ull)mx) <= newx) mx++;
    mx--;
   // cout << mx << '\n';
    for(ll i = 0; i <= mx; i++){
        if(newx & ((ull)(1) << (ull)i)) ones++;
        else zeroes++;
    }
    ans = min(ans, (ll)ones + 1);
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif
	int tt;
    cin >> tt;
    //tt = 1;
	while (tt--) {
		solve();
		#ifdef LOCAL
            cout << "__________________________________" << endl;
		#endif
	}
	#ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << "sec" << '\n';
	#endif
	return 0;
}



