#include <bits/stdc++.h>
using namespace std;
#define int long long
#define forn(i,n) for (int i=0; i<n; ++i)
const int inf = 1e18;
#define all(a) a.begin(),a.end()
#define pb(x) push_back(x)
#define f first
#define s second
#define pi pair<int,int>

int mod;
int tmax=-1,xmax=-1, imax=-1;

struct trie {
	trie* child[2];
	int T=-1,X=-1,end=0;
	trie() {
		child[0]=child[1]=NULL;
	}
	void add(string s, int i, int t, int x) {
		if (i>=s.length()) {
			end=1;
			T=t; X=x;
			return;
		}
		int c=s[i]=='R';
		if (child[c]==NULL) child[c]=new trie;
		child[c]->add(s,i+1,t,x);
	}
	void find(string s, int i){
		if (end) {
			if (T>tmax) {
				tmax=T;
				xmax=X;
				imax=i;
			}
		}
		if (i>=s.length()) {
			return;
		}
		//cout<<"find "<<s<<' '<<i<<'\n';
		int c=s[i]=='R';
		if (child[c]==NULL) return;
		child[c]->find(s,i+1);
	}
};

void rec(string&s, int i, int x) {
	if (i>=s.size()) {
		cout<<x<<'\n';
		return;
	}
	if (s[i]=='L') {
		rec(s,i+1,(x+1)%mod);
	} else {
		rec(s,i+1,(x-1+mod)%mod);
	}
}

void solve() {
	
	int q; cin>>q;
	cin>>mod;

	trie *tr = new trie;

	forn(Q,q) {
		int t; cin>>t;
		if (t==1) {
			int x; cin>>x;
			string s; cin>>s;
			tr->add(s,0,Q,x);
		} else {
			string s; cin>>s;
			tmax=-1, xmax=-1, imax=-1;
			tr->find(s,0);
			//cout<<tmax<<' '<<xmax<<' '<<imax<<'\n';
			if (tmax==-1) {
				cout<<"-1\n";
				continue;
			}
			string n;
			for (int i=imax;i<s.length(); ++i) n+=s[i];
			rec(n,0,xmax);
		}
	}
} 

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1; //cin>>t;
	while (t--) solve();
	return 0;
}