#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(x) (x).begin(), (x).end()
#define vt vector
const ll N = 1e6;

ll n, sum;
ll a[N], t[4*N];
ll p[N];

void build(int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		t[v] = a[tl];
		return;
	}
	int tm = (tl+tr)/2;
	build(v+v, tl, tm);
	build(v+v+1, tm+1, tr);
	t[v] = min(t[v+v], t[v+v+1]);
}

ll get(int l, int r, int v = 1, int tl = 1, int tr = n) {
	if (tr < l || r < tl)
	   return 1e9;
	if (l == tl && tr == r) {
		return t[v];
	}
	int tm = (tl+tr)/2;
	return min(get(l, min(r, tm), v+v, tl, tm), get(max(l, tm+1), r, v+v+1, tm+1, tr));
}

ll bs1(int x) {
	int l = x, r = n, m;
	while (l < r) {
		m = (l+r)/2;
		if (p[m]-p[x-1] >= sum) {
			r = m-1;
		} else {
			l = m+1;
		}
	}
	while (p[l-1]-p[x-1] >= sum)
		  l--;
    while (p[l]-p[x-1] < sum)
		  l++;
 		  
	return l-x+1;
}

ll bs2(int x) {
	int l = x, r = n, m;
	while (l < r) {
		m = (l+r)/2;
		if (p[m]-p[x-1]-get(x, m) >= sum) {
			r = m-1;
		} else {
			l = m+1;
		}
	}
	while (p[l-1]-p[x-1]-get(x, l) >= sum)
		  l--;
    while (p[l]-p[x-1]-get(x, l) < sum)
		  l++;
	return l-x+1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;\
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		p[i] = p[i-1]+a[i];
		sum += a[i];
	}
	sum = (sum+1)/2;
	build();
	ll ans = n;
	for (int i = 1; i <= n; ++i) {
		ans = min(ans, bs1(i));
		ans = min(ans, bs2(i)-1);
	}
	cout << ans << endl;
}
