#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <deque>
#include <string>
#include <cctype>


typedef long long ll;
typedef unsigned long long ull;

using namespace std;
const ll INF = 1e18;
int n, m;

bool onMagnet(int i, int j, vector<vector<int>> &a) {
    ll x = i, y = j;
    while (x > 0) {
        x--;
        if (a[x][y] != 1) return false;
    }
    x = i, y = j;
    while (x < n - 1) {
        x++;
        if (a[x][y] != 5) return false;
    }
    x = i, y = j;
    while (y > 0) {
        y--;
        if (a[x][y] != 7) return false;
    }
    x = i, y = j;
    while (y < m - 1) {
        y++;
        if (a[x][y] != 3) return false;
    }

    return true;
}


int main(int argc, char *argv[]) {
    cout.precision(10);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int i1 = -1, j1 = -1, i2 = -1, j2 = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == 8 or a[i][j] == 4) {
                i1 = i;
                j1 = j;
            }
            if (a[i][j] == 6 or a[i][j] == 2) {
                i2 = i;
                j2 = j;
            }
        }
    }
    int i_m, j_m;
    if (i1 != -1 and i2 != -1) {
        int k1 = i1 - j1;
        int k2 = i2 + j2;
        i_m = (k1 + k2) / 2;
        j_m = (k2 - k1) / 2;
    } else if (i2 == -1) {
        if (n == m) {
            if (a[0][1] == 7 || a[0][1] == 3) {
                i_m = 0, j_m = 0;
            } else {
                i_m = n - 1, j_m = m - 1;
            }
        } else {
            i_m = 0, j_m = 0;
        }
    } else {
        if (n == m) {
            if (a[0][m - 2] == 7 || a[0][m - 2] == 3) {
                i_m = 0, j_m = m - 1;
            } else {
                i_m = n - 1, j_m = 0;
            }
        } else {
            i_m = n - 1, j_m = m - 1;
        }
    }
    cout << i_m + 1 << ' ' << j_m + 1 << "\n";
/*    for (int i = 0; i < n; ++i) {
        int cnt  = 0;
        int pred = 0;
        for (int j = 0; j < 2; ++j) {
            int di = i - i_m;
            int dj = j - j_m;
            if (di == 0) {
                if (dj < 0) {
                    pred = 3;
                }
                else {
                    pred = 7;
                }
            }
            else if (dj == 0) {
                if (di < 0) {
                    pred = 5;
                }
                else {
                    pred = 1;
                }
            }
            else if (){

            }
        }
    }*/

    if (onMagnet(i_m, j_m, a)) {
        cout << i_m + 1 << " " << j_m + 1;
        return 0;
    }

    int i = i_m - 1, j = j_m;
    int i_a = i_m, j_a = j_m;

    while (i >= 0) {
        if (a[i][j] != 5) {
            i_a = i;
            break;
        }
        i--;
    }
    i = i_m + 1;
    while (i < n) {
        if (a[i][j] != 1) {
            i_a = i;
            break;
        }
        i++;
    }
    j = j_m - 1, i = i_m;
    while (j >= 0) {
        if (a[i][j] != 3) {
            j_a = j;
            break;
        }
        j--;
    }
    j = j_m + 1;
    while (j < m) {
        if (a[i][j] != 7) {
            j_a = j;
            break;
        }
        j++;
    }
    cout << i_a + 1 << " " << j_a + 1;

    return 0;
}
