#include <iostream>
#include <vector>

using namespace std;
#define pudge ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);


vector <int> a;

class Node {

public:
    Node* left;
    Node* right;
    long long mins;
    long long tl, tr;

    Node(long long mins, int tl = -1, int tr = -1) : mins(mins), left(nullptr), right(nullptr), tl(tl), tr(tr) {}

    long long get(long long l, long long r) {
        // cout << "1: " << tl << " " << tr << "\n";
        if (l == tl && r == tr) return mins;
        if (l <= left->tr) {
            if (r > left->tr) {
                return min(left->get(l, left->tr), right->get(right->tl, r));
            }
            return left->get(l, r);
        }
        return right->get(l, r);
    }
};

Node* build(int tl, int tr) {
    if (tl == tr) return new Node(a[tl], tl, tl);
    int tm = (tl + tr) / 2;
    Node* left = build(tl, tm);
    Node* right = build(tm + 1, tr);
    Node* node = new Node(min(left->mins, right->mins), tl, tr);
    node->left = left;
    node->right = right;
    return node;
}


int f(int ind, int p, long long need, vector <int> &a, Node* root, vector <int> &sp) {
    long long mins = root->get(ind, p-1);
    long long cur = sp[p] - sp[ind];
    if (cur < need) return -1;
    if (cur - mins >= need) return p - ind - 1;
    return p - ind;
}

int main() {
    //❤❤❤
    pudge
    //❤❤❤

    int n;
    long long need = 0;
    cin >> n;
    a.resize(n);
    vector <long long> sp(n+1);
    sp[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        need += a[i];
        sp[i+1] = sp[i] + a[i];
    }

    Node* root = build(0, n - 1);
    // 7
    // 3 1 1 2 2 1 1
    need = need % 2 + need / 2;

    int mins = 1e9+7;
    int r, l, p;
    int b, b1;
    for (int i = 0; i < n; i++) {
        l = i+1, r = n;
        while (r - l > 1) {
            p = (r + l) / 2;
            b = f(i, p, need, a, root, sp);
            if (b == -1) l = p;
            else r = p;
        }
        //cout << r << " " << l << "\n";
        b = f(i, r, need, a, root, sp);
        b1 = f(i, l, need, a, root, sp);
        if (b != -1 && (b < b1 || b1 == -1)) mins = min(mins, b);
        else if (b1 != -1) mins = min(mins, b1);
    }
    cout << mins;
}