#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define fr first
#define sc second
#define mp make_pair
#define pb push_back
#define _pb pop_back
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define nu_chto_pognali main
#define ios ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

mt19937 rnd(time(NULL));

const int SZ = 2 * 100000 + 10;


void solve() {
	int n, m;
	cin >> n >> m;

	vector<vector<int>> mat(n, vector<int>(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cin >> mat[i][j];
	}

	vector<vector<int>> sum(n, vector<int>(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mat[i][j] == 2 || mat[i][j] == 6) {
				for (int k = 0; i + k < n && j - k >= 0; ++k)
					++sum[i + k][j - k];
				for (int k = 1; i - k >= 0 && j + k < m; ++k)
					++sum[i - k][j + k];
			} else if (mat[i][j] == 4 || mat[i][j] == 8) {
				for (int k = 0; i + k < n && j + k < m; ++k)
					++sum[i + k][j + k];
				for (int k = 1; i - k >= 0 && j - k >= 0; ++k)
					++sum[i - k][j - k];
			}
		}
	}

	int xm = 0, ym = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (sum[i][j] > sum[xm][ym]) {
				xm = i;
				ym = j;
			}
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (sum[i][j] == sum[xm][ym])
				++cnt;
		}
	}

	if (cnt > 1) {
		if (xm == 0 && ym == 0) {
			if (mat[n - 1][0] == 3 && mat[0][m - 1] == 5) {
				xm = n - 1, ym = m - 1;
			} else if (mat[1][1] == 4){
				xm = n - 1, ym = m - 1;
			}
		} else {
			if (mat[0][0] == 5 && mat[n - 1][m - 1] == 7) {
				xm = n - 1, ym = 0;
			} else if (mat[n - 2][1] == 6) {
				xm = n - 1, ym = 0;
			}
		}
	}

	vector<vector<int>> mat2(n, vector<int>(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (abs(xm - i) == abs(ym - j)) {
				if (xm > i && ym > j)
					mat2[i][j] = 4;
				if (xm < i && ym < j)
					mat2[i][j] = 8;
				if (xm > i && ym < j)
					mat2[i][j] = 2;
				if (xm < i && ym > j)
					mat2[i][j] = 6;
			} else {
				if (mat[i][j] == 1 || mat[i][j] == 5) {
					if (i > xm)
						mat2[i][j] = 1;
					else
						mat2[i][j] = 5;
				} else {
					if (j > ym)
						mat2[i][j] = 7;
					else
						mat2[i][j] = 3
				}
			}
		}
	}

	int xa = 0, ya = 0;
	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		for (int j = 0; j < m; ++j)
			if (mat2[i][j] != mat[i][j]) ++cnt;
		if (cnt > 1) {
			xa = i + 1;
			break;
		}
	}

	for (int j = 0; j < m; ++j) {
			int cnt = 0;
			for (int i = 0; i < n; ++i)
				if (mat2[i][j] != mat[i][j]) ++cnt;
			if (cnt > 1) {
				ya = j + 1;
				break;
			}
		}

	cout << xm << ' ' >> ym << '\n';
	cout << xa << ' ' << ya << '\n';

	return;
}



int nu_chto_pognali() {
	ios;

	int tt = 1;
	// cin >> tt;
	while (tt--) solve();

	return 0;
}
