#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define fr first
#define sc second
#define mp make_pair
#define pb push_back
#define _pb pop_back
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define nu_chto_pognali main
#define ios ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

mt19937 rnd(time(NULL));

const ll INF = 1e18;
const int M1 = 1e9 + 7;
const int M2 = 1e9 + 9;
const int p = 257;

int sum(int a, int b, int m) {
	if (a + b >= m)
		return a + b - m;
	return a + b;
}

int diff(int a, int b, int m) {
	if (a - b < 0)
		return a - b + m;
	return a - b;
}

int mult(int a, int b, int m) {
	return int((1LL * a * b) % m);
}


long long pw2(int st)
{
	long long ans=2;
	while (st!=1)
	{
		ans<<=1;
		if(st%2==1)
			ans*=2;
		st/=2;
	}
	return ans;
}


//class Query{
//public:
//	short type;
//	int color;
//	string path;
//};

class vertex {
public:
	int t, color;
	vertex *left, *right;

	vertex() {
		left = right = NULL;
		color = -1;
		t = -1;
	}
};

void solve() {
	int c, q;
	cin >> q >> c;

	vertex* root = new vertex;

	for (int T = 0; T < q; ++T) {
		int type; cin >> type;
		if (type == 1) {
			int color; string path;
			cin >> color >> path;

			vertex* current = root;
			for (int i = 0; i < path.size(); ++i) {
				if (path[i] == 'L') {
					if (!current->left)
						current->left = new vertex;
					current = current->left;
				} else {
					if (!current->right)
						current->right = new vertex;
					current = current->right;
				}
			}
			current->color = color;
			current->t = T;
		} else {
			string path; cin >> path;

			vertex* current = root;
			int t = -1, color = -1;
			for (int i = 0; i < path.size(); ++i) {
				if (path[i] == 'L') {
					if (!current->left)
						current->left = new vertex;
					current = current->left;
//					cout << t << ' ' << current->t << ' ' << color << '\n';
					if (t < current->t) {
						t = current->t;
						color = current->color;
					} else if (color != -1) {
						color = sum(color, 1, c);
					}
				} else {
					if (!current->right)
						current->right = new vertex;
					current = current->right;
					if (t < current->t) {
						t = current->t;
						color = current->color;
					} else if (color != -1) {
						color = diff(color, 1, c);
					}
				}
			}

			cout << color << '\n';
		}
	}
}



int nu_chto_pognali() {
	ios;

	int tt = 1;
	// cin >> tt;
	while (tt--) solve();

	return 0;
}
