#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define ll long long
#define vi vector<int>
#define oo 1000000000

const int N = 5005;
int dp[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        dp[i] = oo;
    }
    dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
        int num = min(i * (i + 1) / 2, n);
        for (int j = num; j >= i; --j) {
            dp[j] = min(dp[j], dp[j - i] + (i * (i - 1) / 2));
        }
    }
    cout << dp[n] << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}