#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define ll long long
#define vi vector<int>
#define oo 1000000000
#define ool 1e18

const int N = 100005;
ll t[4 * N];
ll a[N], pref[N];

void bld(int tl, int tr, int pos) {
    if (tl == tr) {
        t[pos] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    bld(tl, tm, pos * 2);
    bld(tm + 1, tr, pos * 2 + 1);
    t[pos] = min(t[pos * 2], t[pos * 2 + 1]);
}

ll qry(int tl, int tr, int l, int r, int pos) {
    if (l > r) {
        return ool;
    }
    if (l == tl && r == tr) {
        return t[pos];
    }
    int tm = (tl + tr) / 2;
    return min(qry(tl, tm, l, min(r, tm), pos * 2),
            qry(tm + 1, tr, max(l, tm + 1), r, pos * 2 + 1));
}

void solve() {
    int n;
    cin >> n;
    ll sum = 0;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        sum += a[i];
        pref[i] = sum;
    }
    //cout << t[1] << "\n";
    bld(1, n, 1);
    //cout << t[1] << "\n";
    int c = oo;
    sum = (sum + 1) / 2;
    int l = 1, r = 1;
    while (l <= n) {
        if (r < l) {
            r = l;
        }
        ll curr = pref[r] - pref[l - 1];
        if (curr >= sum) {
            c = min(c, r - l + 1);
            ++l;
        }
        else {
            ++r;
            if (r > n) break;
        }
    }
    for (int l = 1; l <= n - c + 1; ++l) {
        int r = l + c - 1;
        ll num = qry(1, n, l, r, 1);
        ll sm = pref[r] - pref[l - 1];
        if (sm - num >= sum) {
            cout << c - 1 << "\n";
            return;
        }
    }
    cout << c << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t = 1;
    //int t;
    //cin >> t;
    while (t--) {
        solve();
    }
}