#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define add push_back
#define mpr make_pair
#define fr first
#define sc second
#define all(v) v.begin(), v.end()
#define fastio ios::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define phh pair<pair<ll, ll>, pair<ll, ll>>

const int N = 500001;
const ll MOD = 998244353;
const ll INF = 1e18 + 1;

ll mods[4] = {998244353ll, 1000000007ll, 999999999989ll, 10000000019ll};
ll ggs[4] = {17ll, 998244353ll, 5ll, 137ll};

map<phh, int> mp;
string s;
int color[N];
phh hsh;

void update(ll x){
    hsh.fr.fr = hsh.fr.fr * ggs[0] + x; hsh.fr.fr %= mods[0];
    hsh.fr.sc = hsh.fr.sc * ggs[1] + x; hsh.fr.sc %= mods[1];
    hsh.sc.fr = hsh.sc.fr * ggs[2] + x; hsh.sc.fr %= mods[2];
    hsh.sc.sc = hsh.sc.sc * ggs[3] + x; hsh.sc.sc %= mods[3];
}

int main() {
    fastio;
    int _ = 1;
    // cin >> _;
    while(_--){
        ll q, c;
        cin >> q >> c;
        for(int i = 0; i < q; i++) {
            int t;
            cin >> t;
            hsh = (phh){{0, 0}, {0, 0}};
            if(t == 1) {
                cin >> color[i];
                cin >> s;
                for(int i = 0; i < (int)s.size(); i++) update(s[i] == 'L');
                mp[hsh] = i;
            }
            else {
                int cnt = -1, sz = -1;
                cin >> s;
                for(int j = 0; j < s.size(); j++) {
                    update(s[j] == 'L');
                    if(mp.find(hsh) != mp.end()) {
                        int r = mp[hsh];
                        if(r > cnt) {
                            cnt = r;
                            sz = j + 1;
                        }
                    }
                }
                if(cnt == -1) cout << cnt << "\n";
                else {
                    int col = color[cnt];
                    for(int j = sz; j < s.size(); j++) {
                        if(s[j] == 'R') col = (col - 1 + c) % c;
                        else col = (col + 1) % c;
                    }
                    cout << col % c << "\n";
                }
            }
        }
    }
    return 0;
}