#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

#define int long long
#define endl '\n'

int curr = 0;

int currLeft, currRight;

vector<int> answer;

void solve(pair<int, int> el) {
    if ((el.second - el.first + 1) % 2 == 1) {
        for (int i = el.first; i <= el.first + (el.second - el.first + 1) / 2; i++) {
            answer[i] = currLeft;
            currLeft -= 2;
        }
        for (int i = el.second; i > el.first + (el.second - el.first + 1) / 2; i--) {
            answer[i] = currRight;
            currRight -= 2;
        }
    } else {
        if (curr == 1) {
            for (int i = el.first; i <= el.first + (el.second - el.first) / 2; i++) {
                answer[i] = currRight;
                currRight -= 2;
            }

            for (int i = el.second; i > el.first + (el.second - el.first) / 2; i--) {
                answer[i] = currLeft;
                currLeft -= 2;
            }
            curr = 0;
        } else {
            for (int i = el.first; i <= el.first + (el.second - el.first) / 2; i++) {
                answer[i] = currLeft;
                currLeft -= 2;
            }

            for (int i = el.second; i > el.first + (el.second - el.first) / 2; i--) {
                answer[i] = currRight;
                currRight -= 2;
            }
            curr++;
        }
    }
}

void solve() {
    int n; cin >> n;
    currLeft = n + 1;
    currRight = n;
    answer.assign(n + 1, 0);
    string s; cin >> s;
    vector<pair<int, int>> ind;
    int prev = 0;
    for (int i = 1; i <= n; i++) {
        if (i == n && s[i - 1] == 'A') {
            ind.push_back({prev, i});
            prev = i + 1;
        } else if(s[i] == 'B' && s[i - 1] == 'A') {
            ind.push_back({prev, i});
            prev = i + 1;
        } else if(s[i] == 'B') {
            prev = i + 1;
        }
    }

    for (auto &el : ind) {
        solve(el);
    }

    set<int> was;
    for (int i = 1; i <= n + 1; i++) {
        was.insert(i);
    }

    for (auto &el : answer) {
        was.erase(el);
    }

    for (int i = 0; i <= n; ++i) {
        if (answer[i] == 0) {
            answer[i] = *was.begin();
            was.erase(was.begin());
        }
    }

    for (auto &el : answer) cout << el << ' ';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--)
        solve();
    return 0;
}