#include <bits/stdc++.h>
using namespace std;

const int inf = 1e8;
const int arraysize = 1e6 + 20;

map<pair<long long, int>, int> memo;

long long rec(int n, int d)
{
    if (n == 0)
        return 0;
    if (d == -1 || abs(n) > pow(2, d + 1))
        return inf;
    if (n > 1e5)
    {
        return min(1 + min(rec(n + pow(2, d), d - 1), rec(n - pow(2, d), d - 1)), rec(n, d - 1));
    }
    if (!memo.count({n, d}))
    {
        memo[{n, d}] = min(1 + min(rec(n + pow(2, d), d - 1), rec(n - pow(2, d), d - 1)), rec(n, d - 1));
    }
    return memo[{n, d}];
}

void solve()
{
    int n;
    cin >> n;
    if (n < 0)
        n = -n;
    cout << rec(n, ceil(log2(n))) << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        solve();
    }
}
