#include<iostream>
#include<vector>
#include <map>

using namespace std;
using ll = long long;
const ll mod = 1e9 + 7;

void solve() {
	int q, c; cin >> q >> c;
	map<ll, pair<int, int>> mp;
	while (q--) {
		int t; cin >> t;
		if (t == 1) {
			int x; cin >> x;
			string s; cin >> s;
			ll u = 0;
			for(int i = 0; i < s.size(); i++){
                if(s[i] == 'L') u = (2 * u + 1) % mod;
                else u = (2 * u + 2) % mod;
			}
			mp[u] = { x, q };
		}
		else {
			string s; cin >> s;
			ll pref  = 0;
			int clr = -1, cur = 1e9;
			for (int i = 0; i < s.size(); i++) {
				if (clr != -1) {
					if (s[i] == 'R') clr = (c + clr - 1) % c;
					else clr = (clr + 1) % c;
				}
				//pref += s[i];
				if(s[i] == 'L') pref = (pref * 2 + 1) % mod;
				else pref = (pref * 2 + 2) % mod;
				if (mp.find(pref) == mp.end()) continue;
				pair<int, int> a = mp[pref];
				if (a.second < cur) {
					cur = a.second;
					clr = a.first;
				}
			}
			cout << clr << endl;
		}
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
	solve();
}
