#include <bits/stdc++.h>
#define int long long
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e18 + 7;

void solve() {
    int n, sum = 0;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    sum = (sum + 1) / 2;
    multiset<pair<int, int>> s;
    vector<int> dp(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        dp[i + 1] = dp[i] + a[i];
        s.emplace(a[i], i);
    }
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        int l = i, r = n;
        while (l < r) {
            int m = (l + r) / 2;
            if (dp[m] - dp[i] < sum)
                l = m + 1;
            else
                r = m;
        }
        int sum1 = dp[r] - dp[i];
        //cout << i << ' ' << r << '\n';
        if (sum1 < sum)
            continue;
        auto it = s.upper_bound(make_pair(sum1 - sum, i));
        while (it != s.begin() && it->second >= r) it--;
        if (it->first <= sum1 - sum && it->second >= i && it->second < r)
            ans = max(1ll, min(ans, r - i - 1));
        else
            ans = max(1ll, min(ans, r - i));
        s.erase(make_pair(a[i], i));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}
