#include <bits/stdc++.h>

using namespace std;

#define int long long

const long long inf = 1e18;

int binpow(int x, int n) {
    if (n == 0) {
        return 1;
    }
    if (n == 1) {
        return x;
    }
    int tmp = binpow(x, n / 2);
    if (n % 2 == 0) {
        return tmp * tmp;
    } else {
        return tmp * tmp * x;
    }
}

void solve() {
    int x;
    cin >> x;

    int ans = 0;
    int power, tmp;
    int l, r;
    while (x != 0) {
        x = abs(x);
        power = 0;
        tmp = x;
        while (tmp > 0) {
            tmp >>= 1;
            power++;
        }
        power--;

        l = binpow(2, power);
        r = binpow(2, power + 1);
        if (x - l < r - x) {
            x = x - l;
        } else {
            x = r - x;
        }
        ans++;
        //cout << ans << endl;
    }
    cout << ans << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
