#include <iostream>
#include <cmath>
using namespace std;
int degree(long long n) {
	return round(log2(n));
}
int solve(long long n) {
	int steps = 0;
	if (n == 0) {
		return 0;
	}
	long long cur = n;
	while (true) {
		steps++;
		if (pow(2, degree(abs(cur))) == abs(cur)) {
			return steps;
		}
		cur = abs(pow(2, degree(abs(cur))) - abs(cur));
	}
}
int main() {
	long long n, a[100000];
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cout << solve(a[i])<<endl;
	}
}